; joust.asm - joust for colecovision

	INCLUDE	"xobits.s"	; for XX__XX__ bit patterns

	ORG	6000H	; alias instead of the usual 7000H

D6000	DS	1
D6001	DS	1
D6002	DS	1
D6003	DS	1
D6004	DS	1
D6005	DS	1
D6006	DS	2 ; also byte
D6008	DS	6
D600E	DS	6
D6014	DS	6
D601A	DS	6
D6020	DS	1
D6021	DS	1
	DS	1
D6023	DS	1
D6024	DS	1
D6025	DS	1
	DS	1
D6027	DS	1
D6028	DS	18H
D6040	DS	4
D6044	DS	1CH
D6060	DS	2 ; also byte
	DS	1
D6063	DS	1
D6064	DS	1
	DS	3
D6068	DS	6
D606E	DS	2
D6070	DS	1
	DS	2
D6073	DS	1
D6074	DS	1
	DS	7
D607C	DS	4
D6080	DS	1
D6081	DS	1
	DS	7
D6089	DS	1
	DS	6
D6090	DS	1
	DS	20H
D60B1	DS	1
D60B2	DS	1
	DS	20H
D60D3	DS	1
D60D4	DS	1BH
D60EF	DS	00B1H
D61A0	DS	1
D61A1	DS	1
D61A2	DS	1
	DS	2
D61A5	DS	1
	DS	1
D61A7	DS	1
	DS	1
D61A9	DS	1
D61AA	DS	2
D61AC	DS	1
D61AD	DS	1
D61AE	DS	1
D61AF	DS	1
D61B0	DS	1
D61B1	DS	2
D61B3	DS	2
D61B5	DS	2
D61B7	DS	1
D61B8	DS	1
D61B9	DS	1
D61BA	DS	1
D61BB	DS	1
D61BC	DS	1
D61BD	DS	2
	DS	1
D61C0	DS	2
D61C2	DS	1	; current level number
;-7 bytes of level info-
D61C3	DS	1
D61C4	DS	1
D61C5	DS	1
D61C6	DS	1
D61C7	DS	1
D61C8	DS	1
D61C9	DS	1
; ----------------------
D61CA	DS	1
D61CB	DS	1
D61CC	DS	2
D61CD	EQU	D61CC+1
D61CE	DS	4
D61D2	DS	2
D61D4	DS	2
D61D6	DS	1
D61D7	DS	2
D61D8	EQU	D61D7+1
D61D9	DS	1
D61DA	DS	5
D61DF	DS	4
D61E3	DS	1
D61E4	DS	1
	DS	3
D61E8	DS	1
D61E9	DS	1
D61EA	DS	3
D61ED	DS	3
D61F0	DS	9CH
D628C	DS	1
D628D	DS	1
	DS	1
D628F	DS	19H
D62A8	DS	1
D62A9	DS	1
D62AA	DS	1
D62AB	DS	1
	DS	1
D62AD	DS	1
D62AE	DS	3
D62B1	DS	1
	DS	1
D62B3	DS	1
D62B4	DS	1
D62B5	DS	2
D62B7	DS	7
D62BE	DS	2
D62C0	DS	2
D62C2	DS	1
D62C3	DS	1
D62C4	DS	1
D62C5	DS	1
D62C6	DS	1
D62C7	DS	1
D62C8	DS	1
D62C9	DS	1
D62CA	DS	256
D63CA
D7FFF	EQU	7FFFH	; stack starts at end of RAM (alias to 73FFH)

I_BE	EQU	0BEH
I_BF	EQU	0BFH
I_FC	EQU	0FCH
I_FF	EQU	0FFH

O_80	EQU	080H
O_BE	EQU	0BEH
O_BF	EQU	0BFH
O_C0	EQU	0C0H
O_FF	EQU	0FFH

; Text character codes
_0	EQU	00H
_1	EQU	01H
_2	EQU	02H
_3	EQU	03H
_4	EQU	04H
_5	EQU	05H
_6	EQU	06H
_7	EQU	07H
_8	EQU	08H
_9	EQU	09H
__	EQU	20H ; blank
_A	EQU	21H
_B	EQU	22H
_C	EQU	23H
_D	EQU	24H
_E	EQU	25H
_F	EQU	26H
_G	EQU	27H
_H	EQU	28H
_I	EQU	29H
_J	EQU	2AH
_K	EQU	2BH
_L	EQU	2CH
_M	EQU	2DH
_N	EQU	2EH
_O	EQU	2FH
_P	EQU	30H
_Q	EQU	31H
_R	EQU	32H
_S	EQU	33H
_T	EQU	34H
_U	EQU	35H
_V	EQU	36H
_W	EQU	37H
_X	EQU	38H
_Y	EQU	39H
_Z	EQU	3AH
_EXCL	EQU	3BH ; exclamation mark
_PER	EQU	3CH ; period

	ORG	8000H

D8000:	DW	0AA55H
	DW	0000H
	DW	0000H
	DW	0000H
	DW	0000H
	DW	L8024	; game code start

L800C:	JP	0000H	; RST 08H vector
L800F:	JP	0000H	; RST 10H vector
L8012:	JP	0000H	; RST 18H vector
L8015:	JP	0000H	; RST 20H vector
L8018:	JP	0000H	; RST 28H vector
L801B:	JP	0000H	; RST 30H vector
L801E:	JP	0000H	; RST 38H vector
L8021:	JP	LBD3C	; NMI vector

; ======================

L8024:	LD	SP,7FFFH
	CALL	LBE6E
L802A:	LD	SP,7FFFH
	CALL	LBE7F
L8030:	LD	SP,7FFFH
	CALL	LBE7F
	CALL	LBC51
	CALL	LAE81
	CALL	LBBA0
	CALL	LBC4A
	LD	BC,012CH
.8045:	PUSH	BC
	CALL	LBD48
	POP	BC
	DEC	BC
	LD	A,C
	OR	B
	JR	Z,L802A
	LD	A,(D61A0)
	XOR	02H
	LD	(D61A0),A
	CALL	LBE14
	CP	7FH
	JR	NZ,.806D
	LD	A,(D61A0)
	XOR	02H
	LD	(D61A0),A
	CALL	LBE14
	CP	7FH
	JR	Z,.8045
.806D:	LD	B,90H
	CP	7DH
	JR	Z,.8091
	LD	B,0A0H
	CP	77H
	JR	Z,.8091
	LD	B,0B0H
	CP	7CH
	JR	Z,.8091
	LD	B,11H
	CP	72H
	JR	Z,.8091
	LD	B,21H
	CP	73H
	JR	Z,.8091
	LD	B,31H
	CP	7EH
	JR	NZ,.8045
.8091:	PUSH	BC
	CALL	LACD1
	POP	AF
	LD	(D61D6),A
	LD	(D61A0),A
	CALL	LBC51
	CALL	LAEB6
	CALL	LBE06
	SUB	A
	LD	(D61C2),A		; get level
	LD	HL,D62CA
	LD	(D61D2),HL
	LD	HL,000CH
	LD	(D62BE),HL
	LD	A,01H
	LD	(D61CB),A
	CALL	LAF41
	CALL	LAF80
	LD	HL,DD070
	LD	DE,D6020
	LD	BC,0008H
	LDIR
	LD	HL,1B00H
	LD	DE,DCAC8
	LD	BC,XCAC8-DCAC8 ; 0010H
	CALL	LBD02	; write DE to VRAM at HL, size BC
	CALL	LBD6B
	CALL	LBC5D
	CALL	LAFA1
	CALL	LAFDE
	CALL	LBC4A
L80E6:	LD	A,(D62A8)
	CP	02H
	JR	NZ,L814A
	CALL	L93D4
	LD	A,(D62C2)
	AND	0C0H
	LD	HL,D62C3
	JR	NZ,L812B
	BIT	0,(HL)
	JR	Z,.811C
	LD	HL,DD126 ; "PLAYER COOPERATION"
	CALL	LB689
	LD	BC,3000H
	PUSH	BC
	CALL	LBC96
	LD	A,(D61A0)
	XOR	02H
	LD	(D61A0),A
	POP	BC
	CALL	LBC96
	LD	HL,DD10C ; "EACH PLAYER 3000 POINTS"
	JR	L8125

.811C:	LD	HL,DD14D ; "NO BONUS AWARDED"
	CALL	LB689
	LD	HL,DD13B ; "PLAYER CONFLICT"
L8125:	CALL	LB689
	JP	L8184

L812B:	BIT	0,(HL)
	JR	Z,.8145
	BIT	7,A
	LD	HL,D61A0
	RES	1,(HL)
	JR	NZ,.813A
	SET	1,(HL)
.813A:	LD	BC,3000H
	CALL	LBC96
	LD	HL,DD20C ; "COLLECT 3000 SURVIVAL POINTS"
	JR	L8125

.8145:	LD	HL,DD22B ; "NO SURVIVAL BONUS AWARDED"
	JR	L8125

L814A:	CP	04H
	JR	NZ,L816D
	LD	A,(D62C2)
	AND	0C0H
	JR	NZ,L816D
	LD	HL,D62C3
	BIT	0,(HL)
	JR	NZ,.8161
	LD	HL,DD160 ; "NO BOUNTY AWARDED"
	JR	L8125

.8161:	BIT	7,(HL)
	LD	HL,DD174 ; "COLLECTED 3000 BOUNTY"
	JR	Z,L8125
	LD	HL,DD18C ; "COLLECTED 3000 BOUNTY"
	JR	L8125

L816D:	CALL	LBD48
	CALL	LB50C		; start a new level?
	LD	A,(D61D6)
	CP	0B0H
	JR	Z,.8181
	CP	31H
	JR	Z,.8181
	CALL	L9775
.8181:	CALL	LBE7F
L8184:	LD	SP,7FFFH
L8187:	LD	A,80H
	OUT	(O_80),A
	LD	A,(D62A9)
	LD	B,A
	IN	A,(I_FC)
	LD	(D62A9),A
	CP	7FH
	JR	Z,.81BE
	CP	7DH
	LD	C,02H
	JR	Z,.81BA
	LD	C,04H
	CP	77H
	JR	Z,.81BA
	LD	C,08H
	CP	7CH
	JR	Z,.81BA
	LD	C,10H
	CP	72H
	JR	Z,.81BA
	CP	71H
	JR	NZ,.81B8
	CP	B
	JP	NZ,L80E6
.81B8:	LD	C,01H
.81BA:	LD	A,C
	LD	(D61CB),A
.81BE:	LD	A,(D61CB)
	LD	B,A
L81C2:	PUSH	BC
	CALL	LBD48
	POP	BC
	DJNZ	L81C2
	CALL	LBD6B
	CALL	L967F
	CALL	L83CB
	CALL	L83E0
	CALL	L9826
	CALL	L9CAD
	CALL	LAAA7
	CALL	L8C19
	CALL	LA0BE
	CALL	LB38A
	CALL	LBC51
	CALL	L934E
	CALL	LBC4A
	CALL	L9029
	CALL	LB800
	CALL	LA42A
	CALL	LB733
	CALL	LBB19
	CALL	LB1A1
	CALL	LB059
	CALL	LB8E6
	LD	HL,(D61D7)
	INC	HL
	LD	(D61D7),HL
	LD	DE,0FF88H
	SUB	A
	ADC	HL,DE
	JR	NZ,.8220
	LD	A,(D62A8)
	AND	A
	JR	NZ,.8220
	CALL	LA2FE
.8220:	LD	HL,(D62B5)
	DEC	HL
	LD	(D62B5),HL
	LD	A,L
	OR	H
	JR	NZ,.8238
	LD	C,81H
	LD	A,(D61D8)
	AND	A
	JR	NZ,.8235
	LD	C,0C1H
.8235:	CALL	LA3B4
.8238:	LD	HL,(D61D4)
	INC	HL
	LD	(D61D4),HL
	LD	A,L
	DEC	A
	AND	07H
	JP	NZ,L8187
	JR	.824E

.8248:	CALL	LBD48
	CALL	LB38A
.824E:	LD	A,(D61A5)
	LD	B,A
	LD	HL,D61A0
	BIT	7,(HL)
	JR	NZ,.825D
	LD	A,(D62C9)
	AND	B
.825D:	PUSH	AF
	LD	A,(D61A7)
	LD	B,A
	POP	AF
	LD	(D61A7),A
	CP	B
	JR	NZ,.8273
.8269:	LD	A,(D61A0)
	BIT	3,A
	JP	Z,L8187
	JR	.8248

.8273:	CP	76H
	JR	NZ,.8281
	LD	A,(D61A0)
	XOR	08H
	LD	(D61A0),A
	JR	.8269

.8281:	CP	79H
	JR	NZ,.8269
	LD	A,(D61A0)
	BIT	3,A
	JP	Z,L8030
	JR	.8248

L828F:	LD	A,(D61D7)
	SUB	05H
	AND	0FH
	RET	NZ
	INC	(IX+0BH)
	CALL	LBAF9
	AND	03H
	ADD	A,A
	ADD	A,A
	ADD	A,A
	LD	E,A
	LD	D,00H
	LD	HL,D98FE
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	LD	C,(HL)
	LD	A,(D61E8)
	AND	C
	RET	NZ
	LD	A,(IX+0BH)
	CP	1EH
	JR	NC,.82BE
	CALL	L82F6
	RET	C
.82BE:	LD	A,(D61E8)
	OR	C
	LD	(D61E8),A
	LD	(IX+08H),C
	LD	(IY+00H),E
	LD	(IY+01H),D
	LD	(IY+02H),6CH
	LD	(IY+03H),0EH
	LD	A,(IX+00H)
	SET	3,A
	RES	2,A
	SET	6,A
	LD	(IX+00H),A
	INC	HL
	INC	HL
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	(IX+17H),D
	LD	(IX+16H),E
	LD	(IX+05H),00H
	LD	(IX+01H),01H
	RET

; ======================

L82F6:	PUSH	IY
	PUSH	IX
	LD	IY,D6020
	LD	IX,D6090
	LD	B,08H
.8304:	LD	A,(IY+00H)
	SUB	E
	BIT	7,A
	JR	Z,.830E
	NEG
.830E:	CP	20H
	JR	NC,.8320
	LD	A,(IY+01H)
	SUB	D
	BIT	7,A
	JR	Z,.831C
	NEG
.831C:	CP	50H
	JR	C,.8335
.8320:	PUSH	DE
	LD	DE,0022H
	ADD	IX,DE
	LD	DE,0004H
	ADD	IY,DE
	POP	DE
	DJNZ	.8304
	POP	IX
	POP	IY
	SCF
	CCF
	RET

.8335:	POP	IX
	POP	IY
	SCF
	RET

; ======================

L833B:	LD	A,(IX+04H)
	AND	A
	JR	NZ,L834D
	LD	A,(D61D7)
	AND	01H
	RET	Z
	LD	A,(IX+05H)
	DEC	A
	JR	NZ,L838B
L834D:	LD	A,0E0H
	LD	L,(IX+16H)
	LD	H,(IX+17H)
	CALL	L99DC
	RES	3,(IX+00H)
	SET	0,(IX+00H)
	LD	(IY+02H),0B0H
	LD	HL,D61A0
	LD	A,04H
	LD	C,0C0H
	BIT	1,(HL)
	JR	Z,.8373
	LD	A,0BH
	LD	C,0C8H
.8373:	LD	(IY+03H),A
	LD	(IX+10H),C
	LD	(IX+11H),C
	LD	A,(D61E8)
	LD	E,(IX+08H)
	XOR	E
	LD	(D61E8),A
	LD	(IX+05H),01H
	RET

L838B:	LD	(IX+05H),A
	DEC	(IX+01H)
	RET	NZ
	LD	L,(IX+16H)
	LD	H,(IX+17H)
	RLCA
	RLCA
	AND	03H
	INC	A
	LD	(IX+01H),A
	LD	HL,D61A0
	LD	C,04H
	LD	B,40H
	BIT	1,(HL)
	JR	Z,.83AF
	LD	C,0DH
	LD	B,0D0H
.83AF:	LD	A,(IY+03H)
	CP	0EH
	JR	Z,.83BD
	LD	(IY+03H),0EH
	LD	A,B
	JR	.83C2

.83BD:	LD	(IY+03H),C
	LD	A,0E0H
.83C2:	LD	L,(IX+16H)
	LD	H,(IX+17H)
	JP	L99DC

; ======================

L83CB:	LD	HL,D61A0
	RES	1,(HL)
	LD	IX,D6090
	LD	IY,D6020
	LD	A,(D6090)
	LD	(D62C4),A
	JR	L83F3

; ======================

L83E0:	LD	HL,D61A0
	SET	1,(HL)
	LD	IX,D60B2
	LD	IY,D6024
	LD	A,(D60B2)
	LD	(D62C5),A
L83F3:	BIT	2,(IX+00H)
	JP	NZ,L828F
	BIT	3,(IX+00H)
	JP	NZ,L833B
L8401:	BIT	0,(IX+00H)
	RET	Z
	BIT	5,(IX+00H)
	JR	NZ,.841C
	LD	A,(IY+00H)
	CP	0A0H
	JR	C,.841C
	LD	A,(D61D7)
	AND	07H
	JP	Z,L8841
	RET

.841C:	LD	A,(IX+04H)
	LD	B,(IX+08H)
	LD	(IX+08H),A
	CALL	L96DC
	LD	A,(IX+04H)
	BIT	4,(IX+00H)
	JR	Z,.844F
	BIT	6,(IX+00H)
	JR	Z,.8448
	BIT	1,A
	JP	Z,L85BC
.843C:	DEC	(IY+00H)
	DEC	(IY+00H)
	RES	4,(IX+00H)
	JR	.844F

.8448:	BIT	3,A
	JR	NZ,.843C
	JP	L865E

.844F:	BIT	3,A
	JP	NZ,L85AF
	BIT	1,A
	JP	NZ,L8651
	BIT	7,(IX+00H)
	LD	A,07H
	JR	Z,L8467
	LD	A,02H
	JR	L8467

L8465:	LD	A,0DH
L8467:	LD	(IX+05H),A
L846A:	LD	A,(IX+03H)
	LD	B,(IX+02H)
	ADD	A,B
	BIT	7,A
	JR	Z,.847D
	CP	0F8H
	JR	NC,.8483
	LD	A,0F8H
	JR	.8483

.847D:	CP	09H
	JR	C,.8483
	LD	A,08H
.8483:	LD	(IX+02H),A
	BIT	7,A
	JR	Z,.848C
	NEG
.848C:	LD	B,A
	SRL	A
	SRL	A
	JP	Z,L875B
	BIT	7,(IX+00H)
	JR	Z,.84A7
	BIT	4,(IX+00H)
	JR	NZ,.84A7
	DEC	A
	JP	Z,L875B
	CALL	L8761
.84A7:	BIT	7,(IX+02H)
	JR	Z,.84AF
	NEG
.84AF:	JP	L86ED

L84B2:	BIT	6,(IX+00H)
	JR	NZ,L84C8
	SET	6,(IX+00H)
	JR	L84C8

L84BE:	BIT	6,(IX+00H)
	JR	Z,L84C8
	RES	6,(IX+00H)
L84C8:	LD	A,07H
	JR	L8467

L84CC:	LD	A,(IX+1FH)
	DEC	A
	JR	Z,L84BE
	LD	(IX+1FH),A
	DEC	(IX+05H)
	JR	NZ,L846A
	BIT	6,(IX+00H)
	JR	Z,.84E6
	RES	6,(IX+00H)
	JR	L84C8

.84E6:	LD	A,(IX+03H)
	BIT	7,A
	JR	Z,L852C
	NEG
	SLA	A
	CP	09H
	JR	C,.84F7
	LD	A,08H
.84F7:	NEG
	BIT	1,(IX+00H)
	JR	Z,L8527
	BIT	6,(IY+03H)
	JR	Z,.8509
	LD	A,0FFH
	JR	L8527

.8509:	BIT	2,(IX+00H)
	JR	Z,.8517
	CP	0FBH
	JR	NC,L8527
	LD	A,0FCH
	JR	L8527

.8517:	LD	B,A
	LD	A,(D61C9)
	INC	A
	NEG
	CP	B
	LD	A,B
	JR	C,L8527
	LD	A,(D61C9)
	NEG
L8527:	LD	(IX+03H),A
	JR	L84C8

L852C:	AND	A
	JR	NZ,.853B
	DEC	(IX+20H)
	JR	NZ,L8527
	LD	(IX+20H),02H
	DEC	A
	JR	L8527

.853B:	SRL	A
	JR	L8527

L853F:	LD	A,(IX+1FH)
	DEC	A
	JP	Z,L84B2
	LD	(IX+1FH),A
	DEC	(IX+05H)
	JP	NZ,L846A
	BIT	6,(IX+00H)
	JR	NZ,.855C
	SET	6,(IX+00H)
	JP	L84C8

.855C:	LD	A,(IX+03H)
	BIT	7,A
	JR	Z,.856B
	NEG
	SRL	A
	NEG
	JR	L8527

.856B:	AND	A
	JR	NZ,.857A
	DEC	(IX+20H)
	JR	NZ,L8527
	LD	(IX+20H),02H
	INC	A
	JR	L8527

.857A:	SLA	A
	CP	09H
	JR	C,.8582
	LD	A,08H
.8582:	BIT	1,(IX+00H)
	JR	Z,L8527
	BIT	6,(IY+03H)
	JR	Z,.8593
	LD	A,01H
	JP	L8527

.8593:	BIT	2,(IX+00H)
	JR	Z,.85A3
	CP	05H
	JP	C,L8527
	LD	A,04H
	JP	L8527

.85A3:	LD	B,A
	LD	A,(D61C9)
	CP	B
	JP	C,L8527
	LD	A,B
	JP	L8527

L85AF:	BIT	7,(IX+00H)
	JP	Z,L84CC
	BIT	3,(IX+08H)
	JR	Z,L85C2
L85BC:	DEC	(IX+05H)
	JP	NZ,L846A
L85C2:	LD	A,(IX+03H)
	BIT	7,A
	JR	Z,L8607
	NEG
	SLA	A
	CP	09H
	JR	C,L85D3
	LD	A,08H
L85D3:	NEG
	BIT	1,(IX+00H)
	JR	Z,L8601
	BIT	6,(IY+03H)
	JR	Z,L85E5
	LD	A,0FFH
	JR	L8601

L85E5:	BIT	2,(IX+00H)
	JR	Z,L85F1
	CP	0FBH
	JR	NC,L8601
	LD	A,0FCH
L85F1:	LD	B,A
	LD	A,(D61C9)
	INC	A
	NEG
	CP	B
	LD	A,B
	JR	C,L8601
	LD	A,(D61C9)
	NEG
L8601:	LD	(IX+03H),A
	JP	L8465

L8607:	AND	A
	JR	NZ,L862D
	BIT	4,(IX+00H)
	JR	Z,L861D
	RES	4,(IX+00H)
	DEC	(IY+00H)
	DEC	(IY+00H)
	JP	L8465

L861D:	BIT	6,(IX+00H)
	JR	Z,L862A
	RES	6,(IX+00H)
	JP	L8465

L862A:	DEC	A
	JR	L8601

L862D:	BIT	4,(IX+00H)
	JR	NZ,.864D
	CP	04H
	JR	C,.864D
	BIT	2,(IX+00H)
	JR	NZ,.8643
	BIT	1,(IX+00H)
	JR	NZ,.864D
.8643:	SET	4,(IX+00H)
	INC	(IY+00H)
	INC	(IY+00H)
.864D:	SRL	A
	JR	L8601

L8651:	BIT	7,(IX+00H)
	JP	Z,L853F
	BIT	1,(IX+08H)
	JR	Z,L8664
L865E:	DEC	(IX+05H)
	JP	NZ,L846A
L8664:	LD	A,(IX+03H)
	BIT	7,A
	JR	Z,.8694
	NEG
	BIT	4,(IX+00H)
	JR	NZ,.868D
	CP	04H
	JR	C,.868D
	BIT	2,(IX+00H)
	JR	NZ,.8683
	BIT	1,(IX+00H)
	JR	NZ,.868D
.8683:	SET	4,(IX+00H)
	INC	(IY+00H)
	INC	(IY+00H)
.868D:	SRL	A
	NEG
	JP	L8601

.8694:	AND	A
	JR	NZ,.86BB
	BIT	4,(IX+00H)
	JR	Z,.86AA
	RES	4,(IX+00H)
	DEC	(IY+00H)
	DEC	(IY+00H)
	JP	L8465

.86AA:	BIT	6,(IX+00H)
	JR	NZ,.86B7
	SET	6,(IX+00H)
	JP	L8465

.86B7:	INC	A
	JP	L8601

.86BB:	SLA	A
	CP	09H
	JR	C,.86C3
	LD	A,08H
.86C3:	BIT	1,(IX+00H)
	JP	Z,L8601
	BIT	6,(IY+03H)
	JR	Z,.86D4
	LD	A,01H
	JR	.86E1

.86D4:	BIT	2,(IX+00H)
	JR	Z,.86E1
	CP	05H
	JP	C,L8601
	LD	A,04H
.86E1:	LD	B,A
	LD	A,(D61C9)
	CP	B
	JP	C,L8601
	LD	A,B
	JP	L8601

L86ED:	BIT	2,(IX+1EH)
	JR	Z,.86F4
	SUB	A
.86F4:	BIT	7,A
	JR	NZ,.8727
	BIT	7,(IY+03H)
	JR	NZ,.8718
	ADD	A,(IY+01H)
	JR	NC,.8754
	BIT	2,(IX+00H)
	JR	NZ,.8710
	BIT	5,(IX+00H)
	JP	NZ,L8FA3
.8710:	SET	7,(IY+03H)
	ADD	A,12H
	JR	.8754

.8718:	ADD	A,(IY+01H)
	CP	20H
	JR	C,.8754
	RES	7,(IY+03H)
	SUB	20H
	JR	.8754

.8727:	BIT	7,(IY+03H)
	JR	NZ,.873A
	ADD	A,(IY+01H)
	JR	C,.8754
	SET	7,(IY+03H)
	ADD	A,20H
	JR	.8754

.873A:	ADD	A,(IY+01H)
	CP	12H
	JR	NC,.8754
	BIT	2,(IX+00H)
	JR	NZ,.874E
	BIT	5,(IX+00H)
	JP	NZ,L8FA3
.874E:	RES	7,(IY+03H)
	SUB	12H
.8754:	LD	(IY+01H),A
	LD	(IX+02H),00H
L875B:	CALL	L87D8
	JP	LB402

L8761:	LD	A,(IX+19H)
	INC	A
	AND	03H
	LD	(IX+19H),A
	LD	E,A
	LD	D,00H
	LD	HL,D8792
	ADD	HL,DE
	LD	A,(HL)
.8772:	LD	C,A
	BIT	7,(IX+02H)
	JR	Z,.877B
	NEG
.877B:	ADD	A,(IY+01H)
	AND	07H
	CP	01H
	JR	Z,.878C
	CP	04H
	JR	C,.8790
	CP	05H
	JR	Z,.8790
.878C:	LD	A,C
	INC	A
	JR	.8772

.8790:	LD	A,C
	RET

; ======================

D8792:	DB	03H,02H,01H,02H

; ======================

L8796:	BIT	7,(IX+04H)
	RET	Z
	LD	L,(IX+03H)
	LD	H,(IX+04H)
	CALL	L975F
	LD	(IX+03H),L
	LD	(IX+04H),H
	RET

; ======================

L87AB:	SUB	A
	LD	(IY+00H),A
	BIT	3,(IX+00H)
	JR	NZ,L8796
	JR	L87BA

L87B7:	LD	(IY+00H),C
L87BA:	LD	H,(IX+0DH)
	BIT	7,H
	RET	Z
	BIT	5,(IX+00H)
	JR	Z,.87CB
	LD	HL,0000H
	JR	.87D1

.87CB:	LD	L,(IX+0CH)
	CALL	L975F
.87D1:	LD	(IX+0DH),H
	LD	(IX+0CH),L
	RET

L87D8:	BIT	3,(IX+00H)
	JR	NZ,L87F9
	LD	A,(IX+1EH)
	LD	(D61CC),A
	CALL	L87F1
	BIT	7,(IX+00H)
	RET	NZ
	RES	4,(IX+00H)
	RET

; ======================

L87F1:	RES	1,(IX+1EH)
	RES	7,(IX+00H)
L87F9:	LD	A,(IY+00H)
	BIT	4,(IX+00H)
	JR	Z,.8804
	SUB	02H
.8804:	LD	D,(IY+01H)
	BIT	7,(IY+03H)
	JR	Z,.8813
	LD	B,A
	LD	A,D
	SUB	20H
	LD	D,A
	LD	A,B
.8813:	CP	0F0H
	JR	NC,L87AB
	CP	0A0H
	JR	C,L885F
	BIT	5,(IX+00H)
	JR	NZ,L885F
	BIT	3,(IX+00H)
	JR	Z,L883B
	CP	0A8H
	RET	C
	JP	LA076

L882D:	BIT	1,(IX+00H)
	JP	Z,L8FA3
	LD	(IY+20H),0EFH
	JP	L8FA3

L883B:	LD	A,(D61D7)
	AND	07H
	RET	NZ
L8841:	LD	A,(IY+00H)
	INC	A
	LD	(IY+00H),A
	CP	0ACH
	JR	NC,L882D
	CP	0A7H
	RET	NZ
	BIT	1,(IX+00H)
	RET	NZ
	LD	HL,D62AE
	BIT	6,(HL)
	CALL	Z,L8F9B
	JP	L8FD3

L885F:	LD	E,A
	LD	HL,D61C7
	CP	40H
	JR	C,.88B8
	CP	80H
	JR	C,.88CC
	CP	8FH
	RET	C
	LD	A,(IY+03H)
	AND	0FH
	CP	0DH
	RET	Z
	LD	A,(D61C2)		; get level
	CP	03H
	JR	C,.88AA
	JR	Z,.8887
.887F:	LD	A,D
	SUB	29H
	CP	0B0H
	JR	C,.88AA
	RET

.8887:	LD	A,(D61D9)
	BIT	0,A
	JR	Z,.88AA
	LD	A,(D61E4)
	BIT	0,A
	JR	Z,.887F
	BIT	7,(IY+03H)
	RET	NZ
	LD	A,(D6081)
	SUB	05H
	JR	C,.88A3
	CP	D
	RET	NC
.88A3:	LD	A,(D6089)
	SUB	03H
	CP	D
	RET	C
.88AA:	LD	A,8FH
	BIT	4,(IX+00H)
	JP	Z,L89A3
	ADD	A,02H
	JP	L89A3

.88B8:	CP	1FH
	RET	C
	LD	A,D
	CP	16H
	JR	C,.88ED
	CP	42H
	RET	C
	CP	9EH
	JR	C,.8905
	CP	0D2H
	JR	NC,.88F9
	RET

.88CC:	CP	4FH
	RET	C
	LD	A,D
	CP	36H
	JR	C,L891A
	CP	52H
	RET	C
	CP	96H
	JR	C,L8932
	CP	0AAH
	RET	C
	CP	0C0H
	JR	C,L8911
	CP	0E6H
	JR	NC,L8926
	PUSH	DE
	CALL	L8911
	POP	DE
	JR	L8926

.88ED:	LD	A,E
	CP	38H
	RET	NC
	BIT	1,(HL)
	RET	Z
	LD	HL,DD05B
	JR	L893C

.88F9:	LD	A,E
	CP	38H
	RET	NC
	BIT	2,(HL)
	RET	Z
	LD	HL,DD05E
	JR	L893C

.8905:	LD	A,E
	CP	27H
	RET	C
	BIT	3,(HL)
	RET	Z
	LD	HL,DD061
	JR	L893C

; ======================

L8911:	LD	A,E
	CP	68H
	RET	NC
	LD	HL,DD064
	JR	L893C

L891A:	LD	A,E
	CP	57H
	RET	C
	CP	70H
	RET	NC
	LD	HL,DD067
	JR	L893C

L8926:	LD	A,E
	CP	57H
	RET	C
	CP	70H
	RET	NC
	LD	HL,DD06A
	JR	L893C

L8932:	LD	A,E
	CP	67H
	RET	C
	BIT	0,(HL)
	RET	Z
	LD	HL,DD06D
L893C:	LD	BC,D61B7
	LD	A,E
	LD	(BC),A
	LD	A,D
	INC	BC
	LD	(BC),A
	LD	DE,D61B9
	LD	BC,0003H
	LDIR
	LD	H,00H
	BIT	7,(IX+00H)
	RET	NZ
	BIT	5,(IX+00H)
	JR	NZ,.8960
	BIT	3,(IX+00H)
	JP	NZ,L9EFA
.8960:	LD	A,(D61BB)
	LD	B,(IY+00H)
	SUB	B
	JP	C,L8A36
	CP	0AH
	JP	C,L8A36
	LD	HL,D61CC
	BIT	1,(HL)
	JP	NZ,L8B3E
	SUB	0BH
	CP	02H
	JR	NC,L8992
	BIT	7,(IX+0DH)
	JR	Z,L8992
	LD	A,(D61BB)
	SUB	0CH
	LD	(IY+00H),A
	SET	1,(IX+1EH)
	JP	L8B3E

L8992:	CALL	L8B22
	RET	C
	LD	A,(D61BB)
	SUB	11H
	BIT	4,(IX+00H)
	JR	Z,L89A3
	ADD	A,02H
L89A3:	BIT	5,(IX+00H)
	JR	NZ,.89B0
	BIT	3,(IX+00H)
	JP	NZ,L9EE5
.89B0:	LD	(IY+00H),A
	SUB	57H
	CP	03H
	JR	NC,.89FA
	LD	A,(IY+01H)
	CP	80H
	JR	C,.89FA
	CP	0E8H
	JR	C,.89DC
	SUB	0F0H
	CP	03H
	JR	NC,.89FA
	LD	A,(IX+1BH)
	CP	40H
	JR	NZ,.89FA
	LD	HL,0FFB0H
	LD	(IX+0DH),H
	LD	(IX+0CH),L
	JR	.89FA

.89DC:	BIT	6,(IY+03H)
	JR	NZ,.89FA
	LD	A,0E8H
	LD	(IY+01H),A
	LD	(D61B8),A
	BIT	4,(IX+00H)
	JR	Z,.89FA
	DEC	(IY+00H)
	DEC	(IY+00H)
	RES	4,(IX+00H)
.89FA:	BIT	7,(IX+0DH)
	JR	NZ,.8A08
	LD	(IX+0DH),00H
	LD	(IX+0CH),00H
.8A08:	BIT	5,(IX+00H)
	JR	Z,.8A1F
	BIT	1,(IX+00H)
	JR	NZ,.8A1F
	LD	HL,0FF70H
	LD	(IX+0DH),H
	LD	(IX+0CH),L
	JR	.8A23

.8A1F:	SET	7,(IX+00H)
.8A23:	LD	A,(IX+03H)
	AND	A
	RET	Z
	BIT	7,A
	JR	Z,.8A31
	RES	6,(IX+00H)
	RET

.8A31:	SET	6,(IX+00H)
	RET

; ======================

L8A36:	BIT	7,A
	JP	NZ,L8B61
L8A3B:	LD	A,(D61B8)
	BIT	7,A
	JR	Z,.8A44
	NEG
.8A44:	CP	08H
	JR	NC,.8A57
	LD	C,6CH
	LD	A,(D61B7)
	CP	50H
	JP	NC,L87B7
	LD	C,35H
	JP	L87B7

.8A57:	LD	(IX+0CH),00H
	LD	(IX+0DH),00H
	BIT	5,(IX+00H)
	JR	Z,.8A6E
	LD	HL,01F0H
	LD	(IX+0CH),L
	LD	(IX+0DH),H
.8A6E:	LD	HL,D61B8
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	LD	A,(HL)
	LD	C,A
	LD	A,D
	AND	A
	JR	Z,.8AB3
	CP	80H
	JR	C,.8AAF
	LD	A,(IY+00H)
	SUB	57H
	CP	03H
	JR	NC,.8AA8
	LD	A,(D61B8)
	SUB	0E4H
	CP	04H
	JR	NC,.8AA8
	BIT	6,(IY+03H)
	JR	NZ,.8AA8
	BIT	6,(IX+00H)
	JR	NZ,.8AA8
	LD	(IY+01H),0E9H
	LD	(IX+05H),01H
	JP	L8B01

.8AA8:	LD	A,C
	ADD	A,D
	JR	NZ,.8AB3
	DEC	A
	JR	.8AB3

.8AAF:	LD	A,C
	SRL	A
	ADD	A,D
.8AB3:	SUB	E
	PUSH	AF
	JR	NC,.8AB9
	NEG
.8AB9:	RRCA
	RRCA
	RRCA
	RRCA
	AND	07H
	ADD	A,01H
	LD	C,A
	POP	AF
	LD	A,C
	JR	C,.8AC8
	NEG
.8AC8:	LD	C,A
	ADD	A,(IY+01H)
	LD	(IY+01H),A
	INC	(IY+00H)
	LD	A,(IX+03H)
	AND	A
	RET	Z
	BIT	7,C
	LD	A,(IX+03H)
	JR	NZ,.8AEA
	BIT	7,A
	RET	Z
	NEG
	SRL	A
	LD	(IX+03H),A
	JR	.8AF4

.8AEA:	BIT	7,A
	RET	NZ
	SRL	A
	NEG
	LD	(IX+03H),A
.8AF4:	BIT	1,(IX+00H)
	RET	Z
	LD	HL,D61C0
	INC	(HL)
	LD	A,(HL)
	AND	03H
	RET	NZ
L8B01:	LD	A,(IX+03H)
	NEG
	LD	(IX+03H),A
	LD	A,(IX+00H)
	XOR	40H
	LD	(IX+00H),A
	BIT	1,(IX+00H)
	RET	Z
	BIT	6,A
	LD	A,02H
	JR	NZ,.8B1E
	LD	A,08H
.8B1E:	LD	(IX+04H),A
	RET

L8B22:	LD	HL,D61B8
	LD	A,(HL)
	INC	HL
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	CP	0F0H
	RET	NC
	CP	10H
	JR	NC,.8B33
.8B31:	CCF
	RET

.8B33:	ADD	A,08H
	CP	C
	RET	C
	LD	E,A
	LD	A,B
	ADD	A,C
	JR	Z,.8B31
	CP	E
	RET

; ======================

L8B3E:	LD	A,(D61BB)
	LD	B,(IY+00H)
	SUB	B
	CP	0FH
	JR	C,.8B50
	RES	1,(IX+1EH)
	JP	L8992

.8B50:	SET	1,(IX+1EH)
	CP	0CH
	RET	NZ
	LD	HL,0FFB0H
	LD	(IX+0DH),H
	LD	(IX+0CH),L
	RET

; ======================

L8B61:	BIT	7,(IY+03H)
	JR	Z,.8B7A
	LD	A,B
	CP	50H
	JR	C,.8B73
	LD	C,6CH
	CP	C
	RET	NC
	JP	L87B7

.8B73:	LD	C,35H
	CP	C
	RET	NC
	JP	L87B7

.8B7A:	LD	E,B
	INC	E
	LD	A,(D61B8)
	LD	D,A
	LD	HL,D8BF9
	AND	07H
	ADD	A,A
	LD	C,A
	LD	B,00H
	ADD	HL,BC
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	LD	(D61CC),BC
	CALL	LBC73
	LD	A,D
	AND	07H
	CP	04H
	JR	C,.8B9C
	INC	HL
.8B9C:	LD	A,E
	LD	BC,0000H
	CP	40H
	JR	C,.8BAE
	LD	BC,0800H
	CP	80H
	JR	C,.8BAE
	LD	BC,1000H
.8BAE:	CALL	LBD14
	SUB	3BH
	CP	20H
	JR	NC,.8BC9
	PUSH	HL
	ADD	A,3BH
	CALL	L8BE3
	CALL	LBD14
	LD	H,A
	LD	A,(D61CC)
	AND	H
	POP	HL
	JP	NZ,L8A3B
.8BC9:	INC	HL
	CALL	LBD14
	SUB	3BH
	CP	20H
	RET	NC
	ADD	A,3BH
	CALL	L8BE3
	CALL	LBD14
	LD	H,A
	LD	A,(D61CD)
	AND	H
	RET	Z
	JP	L8A3B

; ======================

L8BE3:	LD	L,A
	LD	H,00H
	SLA	L
	RL	H
	SLA	L
	RL	H
	SLA	L
	RL	H
	ADD	HL,BC
	LD	A,E
	AND	07H
	ADD	A,L
	LD	L,A
	RET

; ======================

D8BF9:	DW	0E007H,0F003H,0F801H,0FC00H,007EH,003FH,801FH,0C00FH
	DW	0F807H,0FC03H,0FE01H,0FF00H,807FH,0C03FH,0E01FH,0F00FH

; ======================

L8C19:	LD	IY,D6020
	LD	IX,D6090
	LD	B,07H
.8C23:	BIT	0,(IX+00H)
	JR	Z,.8C37
	BIT	5,(IX+00H)
	JR	NZ,.8C37
	PUSH	BC
	CALL	L8C44
	CALL	LA66E
	POP	BC
.8C37:	LD	DE,0004H
	ADD	IY,DE
	LD	DE,0022H
	ADD	IX,DE
	DJNZ	.8C23
	RET

; ======================

L8C44:	PUSH	IY
	PUSH	IX
	LD	C,(IX+00H)
	LD	L,(IY+00H)
	LD	H,(IY+01H)
	BIT	7,(IY+03H)
	JR	Z,.8C59
	RES	0,C
.8C59:	LD	DE,0022H
	ADD	IX,DE
	LD	DE,0004H
	ADD	IY,DE
L8C63:	BIT	0,(IX+00H)
	JR	Z,L8C8F
	BIT	5,(IX+00H)
	JR	NZ,L8C8F
	LD	A,(IY+01H)
	SUB	H
	BIT	7,A
	JR	Z,.8C79
	NEG
.8C79:	CP	0EH
	JR	NC,L8C8F
	LD	A,(IY+00H)
	SUB	L
	JP	Z,L8DAC
	BIT	7,A
	JR	Z,.8C8A
	NEG
.8C8A:	CP	0BH
	JP	C,L8CA0
L8C8F:	LD	DE,0022H
	ADD	IX,DE
	LD	DE,0004H
	ADD	IY,DE
	DJNZ	L8C63
	POP	IX
	POP	IY
	RET

L8CA0:	BIT	0,C
	JR	NZ,.8CAC
	BIT	7,(IY+03H)
	JR	Z,L8C8F
	JR	.8CCB

.8CAC:	BIT	7,(IY+03H)
	JR	NZ,L8C8F
	LD	A,(IY+01H)
	BIT	7,A
	JR	Z,.8CC3
	CP	0F0H
	JR	C,.8CCB
	BIT	7,H
	JR	Z,L8C8F
	JR	.8CCB

.8CC3:	CP	10H
	JR	NC,.8CCB
	BIT	7,H
	JR	NZ,L8C8F
.8CCB:	LD	A,(IX+00H)
	AND	C
	BIT	1,A
	JR	Z,.8D02
	LD	A,(IY+01H)
	SUB	H
	BIT	7,A
	JR	Z,.8CDD
	NEG
.8CDD:	CP	03H
	JP	NC,L8DDB
	LD	A,(IY+00H)
	CP	L
	JR	NC,.8CF5
	CALL	L8D96
	POP	IX
	POP	IY
	INC	(IY+00H)
	JP	L87BA

.8CF5:	INC	(IY+00H)
	CALL	L87BA
	POP	IX
	POP	IY
	JP	L8D96

.8D02:	LD	A,(IY+00H)
	CP	L
	JR	NC,L8D71
	CALL	L8D86
	LD	H,(IY+01H)
	LD	A,(IX+00H)
	POP	IX
	POP	IY
	BIT	1,(IX+00H)
	JR	NZ,L8D66
	BIT	1,A
	JP	NZ,L8EEE
	PUSH	HL
	LD	A,(D62A8)
	CP	02H
	JR	NZ,.8D2F
	LD	HL,D62C3
	LD	(HL),00H
	JR	.8D50

.8D2F:	CP	04H
	JR	NZ,.8D50
	LD	HL,D62C3
	BIT	6,(HL)
	JR	NZ,.8D50
	LD	(HL),0C1H
	LD	A,(D6020)
	LD	E,A
	LD	A,(D6021)
	ADD	A,04H
	LD	D,A
	LD	A,04H
	CALL	LB7AD
	LD	BC,5000H
	JR	.8D53

.8D50:	LD	BC,2000H
.8D53:	LD	HL,D61A0
	SET	1,(HL)
	CALL	LBC96
	POP	HL
	JP	L8EEE

; ======================

L8D5F:	BIT	1,(IX+00H)
	JP	Z,L8EEE
L8D66:	PUSH	HL
	CALL	L9C09
	POP	HL
	PUSH	HL
	CALL	L8F2C
	POP	HL
	RET

L8D71:	LD	C,(IY+00H)
	LD	B,(IY+01H)
	PUSH	BC
	CALL	L8D5F
	POP	HL
	LD	C,(IX+1BH)
	POP	IX
	POP	IY
	CALL	L8E94
L8D86:	LD	A,(IY+01H)
	LD	E,A
	SUB	H
	BIT	7,A
	JR	Z,.8D91
	NEG
.8D91:	CP	03H
	CALL	NC,L8DEE
L8D96:	DEC	(IY+00H)
	LD	H,(IX+0DH)
	BIT	7,H
	RET	NZ
	LD	L,(IX+0CH)
	CALL	L975F
	LD	(IX+0DH),H
	LD	(IX+0CH),L
	RET

L8DAC:	BIT	0,C
	JR	NZ,.8DB9
	BIT	7,(IY+03H)
	JP	Z,L8C8F
	JR	L8DDB

.8DB9:	BIT	7,(IY+03H)
	JP	NZ,L8C8F
	LD	A,(IY+01H)
	BIT	7,A
	JR	Z,.8DD2
	CP	0F0H
	JR	C,L8DDB
	BIT	7,H
	JP	Z,L8C8F
	JR	L8DDB

.8DD2:	CP	10H
	JR	NC,L8DDB
	BIT	7,H
	JP	NZ,L8C8F
L8DDB:	LD	E,(IY+01H)
	CALL	L8DEE
	LD	H,(IY+01H)
	LD	L,(IY+00H)
	POP	IX
	POP	IY
	LD	E,(IY+01H)
L8DEE:	BIT	1,(IX+00H)
	JR	NZ,.8DFB
	LD	A,(IX+04H)
	AND	0AH
	JR	NZ,.8E27
.8DFB:	LD	A,E
	SUB	H
	JR	NC,.8E14
	RES	6,(IX+00H)
	BIT	7,(IY+03H)
	JR	NZ,.8E27
	LD	A,(IY+01H)
	DEC	A
	JR	Z,.8E27
	LD	(IY+01H),A
	JR	.8E27

.8E14:	SET	6,(IX+00H)
	BIT	7,(IY+03H)
	JR	NZ,.8E27
	LD	A,(IY+01H)
	INC	A
	JR	Z,.8E27
	LD	(IY+01H),A
.8E27:	LD	A,E
	CP	H
	BIT	1,(IX+00H)
	JR	Z,L8E45
	LD	D,(IX+04H)
	JR	NC,.8E3A
	SET	3,D
	RES	1,D
	JR	.8E3E

.8E3A:	SET	1,D
	RES	3,D
.8E3E:	LD	(IX+04H),D
	LD	(IX+05H),64H
L8E45:	EX	AF,AF'
	LD	A,(IX+03H)
	AND	A
	JR	NZ,.8E5C
	BIT	1,(IX+00H)
	RET	Z
	LD	D,08H
	EX	AF,AF'
	JR	NC,.8E58
	LD	D,0F8H
.8E58:	LD	(IX+03H),D
	RET

.8E5C:	BIT	7,A
	JR	Z,.8E64
	EX	AF,AF'
	RET	C
	JR	.8E66

.8E64:	EX	AF,AF'
	RET	NC
.8E66:	BIT	1,(IX+00H)
	JR	NZ,.8E76
	BIT	7,(IX+00H)
	JR	Z,L8E7F
	LD	(IX+05H),0DH
.8E76:	LD	A,(IX+03H)
	NEG
	LD	(IX+03H),A
	RET

; ======================

L8E7F:	LD	A,(IX+03H)
	BIT	7,A
	JR	NZ,.8E8C
	SRL	A
	NEG
	JR	.8E90

.8E8C:	NEG
	SRL	A
.8E90:	LD	(IX+03H),A
	RET

; ======================

L8E94:	PUSH	HL
	LD	HL,D61A0
	RES	1,(HL)
	LD	A,(IX+10H)
	CP	0C8H
	JR	C,.8EA3
	SET	1,(HL)
.8EA3:	LD	A,C
	LD	BC,0500H
	CP	60H
	JR	Z,.8EE9
	LD	BC,0750H
	CP	0E0H
	JR	Z,.8EE9
	LD	BC,1500H
	CP	40H
	JR	Z,.8EE9
	LD	BC,2000H
	LD	A,(D62A8)
	CP	02H
	JR	NZ,.8ECA
	LD	HL,D62C3
	LD	(HL),00H
	JR	.8EE9

.8ECA:	CP	04H
	JR	NZ,.8EE9
	LD	HL,D62C3
	BIT	6,(HL)
	JR	NZ,.8EE9
	LD	(HL),41H
	LD	A,(D6024)
	LD	E,A
	LD	A,(D6025)
	ADD	A,04H
	LD	D,A
	LD	A,04H
	CALL	LB7AD
	LD	BC,5000H
.8EE9:	CALL	LBC96
	POP	HL
	RET

; ======================

L8EEE:	CALL	L8F2C
	PUSH	HL
	LD	A,(D62A8)
	CP	02H
	JR	NZ,.8F05
	LD	A,(D61A0)
	AND	0C0H
	JR	Z,.8F05
	LD	HL,D62C3
	RES	0,(HL)
.8F05:	LD	BC,0050H
	LD	HL,D61A0
	LD	A,(IX+10H)
	RES	1,(HL)
	CP	0C8H
	JR	C,.8F16
	SET	1,(HL)
.8F16:	CALL	LBC96
	LD	(IX+21H),0FFH
	CALL	L8FD3
	LD	HL,D62AE
	BIT	6,(HL)
	JR	NZ,.8F2A
	CALL	L8F9B
.8F2A:	POP	HL
	RET

; ======================

L8F2C:	SET	5,(IX+00H)
	LD	A,(IY+01H)
	CP	H
	JR	NC,.8F53
	LD	A,08H
	LD	(IX+04H),A
	LD	A,(IX+03H)
	BIT	7,A
	JP	NZ,L93DF
	NEG
	LD	(IX+03H),A
	LD	(IX+0CH),00H
	LD	(IX+0DH),00H
	JP	L93DF

.8F53:	LD	A,02H
	LD	(IX+04H),A
	LD	A,(IX+03H)
	BIT	7,A
	JP	Z,L93DF
	NEG
	LD	(IX+03H),A
	JP	L93DF

; ======================

L8F68:	BIT	0,(IX+1EH)
	JR	Z,.8F76
	RES	0,(IX+1EH)
	LD	HL,D628D
	DEC	(HL)
.8F76:	RES	7,(IY+03H)
	LD	(IX+00H),00H
	CALL	LBB7B
	LD	HL,D62C8
	DEC	(HL)
	LD	HL,D61C3
	DEC	(HL)
L8F89:	LD	A,(D61C3)
	AND	A
	RET	NZ
	LD	A,(D628C)
	AND	A
	RET	NZ
	LD	HL,D62AE
	BIT	0,(HL)
	JP	Z,L80E6
L8F9B:	SET	3,(HL)
	LD	HL,D62B3
	LD	(HL),02H
	RET

; ======================

L8FA3:	BIT	1,(IX+00H)
	JR	NZ,L8F68
	RES	7,(IY+03H)
	LD	HL,DB037
	LD	DE,D6090
	LD	C,40H
	LD	A,(D61A0)
	BIT	1,A
	JR	Z,.8FC1
	LD	DE,D60B2
	LD	C,80H
.8FC1:	AND	C
	PUSH	AF
	LD	BC,0022H
	LDIR
	LD	(IY+00H),0EFH
	POP	AF
	RET	NZ
	LD	(IX+00H),04H
	RET

; ======================

L8FD3:	LD	A,(IY+03H)
	AND	0FH
	CP	04H
	LD	DE,D61ED
	LD	HL,D61EA
	JR	Z,.8FE3
	EX	DE,HL
.8FE3:	LD	A,(DE)
	BIT	0,A
	JR	Z,.8FEF
	LD	(IY+20H),0EFH
	JP	L9070

.8FEF:	SET	0,(HL)
	INC	HL
	LD	(HL),00H
	INC	HL
	LD	(HL),06H
	PUSH	IY
	POP	HL
	LD	DE,0020H
	ADD	HL,DE
	LD	A,(IY+00H)
	SUB	10H
	JR	NC,.9006
	SUB	A
.9006:	LD	(HL),A
	INC	HL
	SUB	A
	BIT	7,(IY+03H)
	JR	NZ,.9017
	LD	A,(IY+01H)
	SUB	04H
	JR	NC,.9017
	SUB	A
.9017:	LD	(HL),A
	INC	HL
	LD	(HL),84H
	INC	HL
	LD	(HL),0DH
	LD	DE,DCA68
L9021:	LD	A,20H
	LD	HL,3C20H
	JP	LB6B8

; ======================

L9029:	LD	HL,D61EA
	BIT	0,(HL)
	CALL	NZ,.9033
	JR	.9060

.9033:	INC	HL
	INC	HL
	DEC	(HL)
	RET	NZ
	LD	IY,D6040
.903B:	DEC	HL
	LD	A,(HL)
	INC	A
	CP	03H
	JR	NZ,.904C
	DEC	HL
	RES	0,(HL)
	LD	(IY+00H),0EFH
	JP	L9070

.904C:	LD	(HL),A
	DEC	A
	JR	NZ,.9058
	INC	HL
	LD	(HL),07H
	LD	DE,DCA88
	JR	L9021

.9058:	INC	HL
	LD	(HL),09H
	LD	DE,DCAA8
	JR	L9021

.9060:	LD	HL,D61ED
	BIT	0,(HL)
	RET	Z
	INC	HL
	INC	HL
	DEC	(HL)
	RET	NZ
	LD	IY,D6044
	JR	.903B

L9070:	CALL	LBB19
	LD	DE,0FFE0H
	ADD	IY,DE
	LD	A,(IY+03H)
	AND	0FH
	CP	04H
	LD	HL,D61A1
	LD	C,A
	JR	Z,.9088
	LD	HL,D61A2
.9088:	LD	A,(D61D6)
	CP	0A0H
	RET	Z
	CP	21H
	RET	Z
	DEC	(HL)
	JP	NZ,LAFA1
	PUSH	BC
	CALL	L93B5
	POP	BC
	LD	HL,D61A0
	LD	A,C
	CP	04H
	JR	NZ,.90B0
	SET	6,(HL)
	BIT	7,(HL)
	JR	NZ,.90C2
	LD	HL,DD0D7 ; "PLAYER 1"
	CALL	L90D1
	JR	.90BC

.90B0:	SET	7,(HL)
	BIT	6,(HL)
	JR	NZ,.90C2
	LD	HL,DD0E2 ; "PLAYER 2"
	CALL	L90D1
.90BC:	LD	HL,DD0ED ; "GAME OVER"
	JP	L90D1

.90C2:	LD	HL,DD0F9 ; "THY GAME IS OVER"
	LD	C,50H
	CALL	LB68F
	LD	HL,(D61BD)
	SET	6,(HL)
	JR	L90D7

; ======================

L90D1:	CALL	LB68D
	LD	HL,(D61BD)
L90D7:	SET	7,(HL)
	RET

; ======================

L90DA:	LD	A,(IY+00H)
	INC	A
	AND	07H
	LD	C,A
	LD	A,(IY+01H)
	AND	07H
	LD	B,A
	BIT	6,(IX+00H)
	JR	Z,.90EF
	XOR	04H
.90EF:	CP	05H
	LD	A,C
	JR	C,.90FD
	CP	03H
	LD	E,03H
	JR	C,.9104
	INC	E
	JR	.9104

.90FD:	CP	03H
	LD	E,02H
	JR	NC,.9104
	DEC	E
.9104:	LD	(IX+13H),E
	LD	HL,D96BC
	BIT	6,(IX+00H)
	JR	Z,.9113
	LD	HL,D96CC
.9113:	LD	A,B
	SLA	A
	LD	E,A
	LD	D,00H
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	LD	A,C
	NEG
	JR	Z,.9127
	LD	D,0FFH
	LD	E,A
	ADD	HL,DE
.9127:	EX	DE,HL
	LD	HL,0000H
	LD	A,(IY+00H)
	INC	A
	CP	40H
	JR	C,.913D
	LD	HL,0800H
	CP	80H
	JR	C,.913D
	LD	HL,1000H
.913D:	LD	A,(IX+11H)
	XOR	04H
	LD	B,00H
	LD	C,A
	SLA	C
	RL	B
	SLA	C
	RL	B
	SLA	C
	RL	B
	ADD	HL,BC
	LD	A,(IX+13H)
	LD	B,08H
	DEC	A
	JP	Z,L96AB		; write data at HL to VRAM at DE, length B
	LD	B,10H
	DEC	A
	JR	Z,.916A
	LD	B,20H
	DEC	A
	JR	NZ,.916A
	LD	B,18H
	JP	L96AB		; write data at HL to VRAM at DE, length B

.916A:	LD	A,(IY+00H)
	INC	A
	CP	38H		; < 38H
	JP	C,L96AB		; write data at HL to VRAM at DE, length B
	CP	40H		; < 40H
	JR	C,.9181		; branch if 38..3F
	CP	78H		; < 78H
	JP	C,L96AB		; write data at HL to VRAM at DE, length B
	CP	80H		; > 80H
	JP	NC,L96AB	; do not branch if 78..7F
.9181:	BIT	4,B
	JR	NZ,.91A7
	LD	B,08H		; 8 bytes
	CALL	L96AB		; write data at HL to VRAM at DE, length B
	PUSH	HL
	LD	BC,0808H
	ADD	HL,BC
	LD	B,08H		; 8 bytes
	CALL	L96AB		; write data at HL to VRAM at DE, length B
	POP	HL
	LD	BC,0010H
	ADD	HL,BC
	LD	B,08H		; 8 bytes
	CALL	L96AB		; write data at HL to VRAM at DE, length B
	LD	BC,0808H
	ADD	HL,BC
	LD	B,08H		; 8 bytes
	JP	L96AB		; write data at HL to VRAM at DE, length B

.91A7:	LD	B,08H		; 8 bytes
	CALL	L96AB		; write data at HL to VRAM at DE, length B
	LD	BC,0808H
	ADD	HL,BC
	LD	B,08H		; 8 bytes
	JP	L96AB		; write data at HL to VRAM at DE, length B

; ======================

L91B5:	LD	A,(IX+18H)
	AND	A
	JR	NZ,.91CA
	BIT	7,(IX+00H)
	RET	Z
	BIT	5,(IX+00H)
	RET	NZ
	CALL	L92BC
	JR	.91E6

.91CA:	BIT	7,(IX+00H)
	JP	Z,L9302
	CALL	L92BC
	LD	E,(IX+16H)
	LD	D,(IX+17H)
	EX	DE,HL
	AND	A
	SBC	HL,DE
	EX	DE,HL
	JR	Z,.91E6
	PUSH	HL
	CALL	L9302
	POP	HL
.91E6:	LD	(IX+18H),01H
	LD	(IX+16H),L
	LD	(IX+17H),H
	LD	A,(IY+01H)
	AND	07H
	BIT	4,(IX+00H)
	JR	Z,.9207
	LD	C,0A0H
	BIT	6,(IX+00H)
	JR	NZ,.9231
	LD	C,0B0H
	JR	.9231

.9207:	LD	C,A
	LD	A,(IX+03H)
	AND	A
	LD	A,C
	JR	Z,.9227
	AND	07H
	LD	C,70H
	JR	Z,.9236
	INC	C
	INC	C
	CP	02H
	JR	Z,.9236
	INC	C
	INC	C
	CP	03H
	JR	Z,.9236
	INC	C
	INC	C
	CP	05H
	JR	Z,.9236
.9227:	LD	C,80H
	BIT	6,(IX+00H)
	JR	NZ,.9231
	LD	C,90H
.9231:	ADD	A,A
	ADD	A,C
	LD	C,A
	JR	.9240

.9236:	BIT	6,(IX+00H)
	JR	NZ,.9240
	LD	A,C
	ADD	A,08H
	LD	C,A
.9240:	LD	B,00H
	CALL	L929D
	JR	C,L9278
	INC	HL
	LD	A,L
	AND	1FH
	JR	NZ,.9251
	LD	DE,0FFE0H
	ADD	HL,DE
.9251:	CALL	L929D
	JR	C,.925A
	LD	(IX+1BH),B
	RET

.925A:	LD	A,01H
	INC	C
	SET	1,B
	LD	(IX+1BH),B
L9262:	EX	DE,HL
	LD	HL,(D61D2)
	LD	(HL),A
	INC	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	LD	(HL),C
	INC	HL
	DEC	A
	JR	Z,.9274
	INC	C
	LD	(HL),C
	INC	HL
.9274:	LD	(D61D2),HL
	RET

L9278:	SET	0,B
	INC	HL
	LD	A,L
	AND	1FH
	JR	Z,.9295
	CALL	L929D
	DEC	HL
	LD	A,01H
	JR	C,.928D
	LD	(IX+1BH),B
	JR	L9262

.928D:	SET	1,B
	LD	(IX+1BH),B
	INC	A
	JR	L9262

.9295:	DEC	HL
	LD	A,01H
	LD	(IX+1BH),B
	JR	L9262

L929D:	BIT	7,(IY+03H)
	JR	Z,L92A9
	LD	A,L
	AND	1FH
	CP	10H
	RET

; ======================

L92A9:	BIT	7,(IY+01H)
	JR	NZ,L92B5
	LD	A,L
	AND	1FH
	CP	1CH
	RET

; ======================

L92B5:	LD	A,L
	AND	1FH
	CP	03H
	CCF
	RET

; ======================

L92BC:	LD	A,(IY+00H)
	ADD	A,09H
	LD	E,A
	LD	D,(IY+01H)
	BIT	7,(IY+03H)
	JR	Z,.92CF
	LD	A,D
	SUB	20H
	LD	D,A
.92CF:	CALL	LBC73
	BIT	4,(IX+00H)
	JR	Z,.92ED
	LD	A,D
	AND	07H
	BIT	6,(IX+00H)
	JR	NZ,.92E7
	CP	05H
	RET	C
	INC	HL
	JR	.92F9

.92E7:	CP	04H
	RET	C
	INC	HL
	JR	.92F9

.92ED:	BIT	6,(IX+00H)
	RET	NZ
	LD	A,D
	AND	07H
	CP	03H
	RET	C
	INC	HL
.92F9:	LD	A,L
	AND	1FH
	RET	NZ
	LD	DE,0FFE0H
	ADD	HL,DE
	RET

; ======================

L9302:	LD	(IX+18H),00H
	LD	B,(IX+1BH)
	LD	L,(IX+16H)
	LD	H,(IX+17H)
	BIT	0,B
	JR	NZ,L9339
	INC	HL
	LD	A,L
	AND	1FH
	JR	NZ,.931D
	LD	DE,0FFE0H
	ADD	HL,DE
.931D:	BIT	1,B
	RET	Z
	LD	A,01H
L9322:	EX	DE,HL
	LD	HL,(D61D2)
	LD	(HL),A
	INC	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	LD	(HL),20H
	INC	HL
	DEC	A
	JR	Z,.9335
	LD	(HL),20H
	INC	HL
.9335:	LD	(D61D2),HL
	RET

L9339:	INC	HL
	LD	A,L
	AND	1FH
	JR	Z,.9349
	DEC	HL
	LD	A,01H
	BIT	1,B
	JR	Z,L9322
	INC	A
	JR	L9322

.9349:	DEC	HL
	LD	A,01H
	JR	L9322

; ======================

L934E:	LD	IY,D6020
	LD	IX,D6090
	BIT	0,(IX+00H)
	JR	Z,.9365
	CALL	L90DA
	CALL	L944C
	CALL	L91B5
.9365:	LD	IX,D60B2
	BIT	0,(IX+00H)
	JR	Z,.937C
	LD	IY,D6024
	CALL	L90DA
	CALL	L944C
	CALL	L91B5
.937C:	LD	HL,D61E3
	INC	(HL)
	LD	IY,D6028
	LD	IX,D60D4
	LD	B,06H
	LD	A,(D62C8)
	LD	C,A
.938E:	BIT	0,(IX+00H)
	JR	Z,.93A8
	PUSH	BC
	LD	A,C
	CP	06H
	JR	C,.93A1
	LD	HL,D61E3
	BIT	0,(HL)
	JR	NZ,.93A7
.93A1:	CALL	L90DA
	CALL	L944C
.93A7:	POP	BC
.93A8:	LD	DE,0022H
	ADD	IX,DE
	LD	DE,0004H
	ADD	IY,DE
	DJNZ	.938E
	RET

; ======================

L93B5:	LD	IX,D60D4
	LD	IY,D6028
	LD	B,06H
.93BF:	PUSH	BC
	BIT	0,(IX+00H)
	CALL	NZ,L93DF
	LD	DE,0004H
	ADD	IY,DE
	LD	DE,0022H
	ADD	IX,DE
	POP	BC
	DJNZ	.93BF
L93D4:	LD	IX,D6090
	CALL	L93DF
	LD	IX,D60B2
L93DF:	LD	L,(IX+14H)
	LD	H,(IX+15H)
	LD	B,(IX+1AH)
	BIT	0,B
	JR	Z,.940C
	BIT	1,B
	JR	Z,.942D
	LD	A,02H
	CALL	L9322
	EX	DE,HL
.93F6:	LD	DE,0020H
	ADD	HL,DE
	BIT	2,B
	JR	Z,.9435
	BIT	3,B
	JR	Z,.9448
	LD	A,02H
.9404:	CALL	L9322
	LD	(IX+1AH),00H
	RET

.940C:	BIT	1,B
	JR	Z,.93F6
	INC	HL
	LD	A,L
	AND	1FH
	JR	NZ,.9424
	PUSH	HL
	LD	DE,0FFE0H
	ADD	HL,DE
	LD	A,01H
	CALL	L9322
	POP	HL
	DEC	HL
	JR	.93F6

.9424:	LD	A,01H
	CALL	L9322
	EX	DE,HL
	DEC	HL
	JR	.93F6

.942D:	LD	A,01H
	CALL	L9322
	EX	DE,HL
	JR	.93F6

.9435:	BIT	3,B
	RET	Z
	LD	A,01H
	INC	HL
	LD	A,L
	AND	1FH
	LD	A,01H
	JR	NZ,.9404
	LD	DE,0FFE0H
	ADD	HL,DE
	JR	.9404

.9448:	LD	A,01H
	JR	.9404

; ======================

L944C:	BIT	5,(IX+00H)
	RET	NZ
	CALL	L93DF
	CALL	L9653
	LD	A,(IX+11H)
	XOR	04H
	LD	(IX+11H),A
	LD	A,(IX+13H)
	LD	(IX+12H),A
	LD	(IX+15H),H
	LD	(IX+14H),L
	LD	C,(IX+11H)
	LD	A,(IX+12H)
	LD	B,00H
	LD	DE,(D61D2)
	PUSH	DE
	CALL	L94A2
	POP	DE
	BIT	1,(IX+00H)
	JR	NZ,.9488
	LD	A,(IY+00H)
	CP	0A0H
	RET	NC
.9488:	LD	A,(D61CC)
	CP	(IX+1AH)
	JR	NZ,.9495
	LD	(IY+20H),0EFH
	RET

.9495:	LD	(D61D2),DE
	SUB	A
	LD	(DE),A
	LD	(IX+1AH),00H
	JP	L9609

; ======================

L94A2:	DEC	A
	JP	Z,.953C
	DEC	A
	JP	Z,.954E
	DEC	A
	JP	Z,L95B4
	LD	A,0FH
	LD	(D61CC),A
	CALL	L958C
	JR	NC,.94DC
	SET	0,B
	LD	A,L
	AND	1FH
	CP	1FH
	JR	NZ,.94CA
.94C1:	LD	A,01H
	CALL	L9575
	INC	C
	EX	DE,HL
	JR	.94F7

.94CA:	INC	HL
	CALL	L958C
	DEC	HL
	JR	NC,.94C1
	SET	1,B
	LD	A,02H
	CALL	L9575
	EX	DE,HL
	DEC	C
	JR	.94F7

.94DC:	INC	C
	INC	C
	PUSH	HL
	INC	HL
	LD	A,L
	AND	1FH
	JR	NZ,.94E9
	LD	DE,0FFE0H
	ADD	HL,DE
.94E9:	CALL	L958C
	JR	NC,.94F5
	SET	1,B
	LD	A,01H
	CALL	L9575
.94F5:	DEC	C
	POP	HL
.94F7:	LD	DE,0020H
	ADD	HL,DE
	CALL	L958C
	JR	NC,.9520
	SET	2,B
	LD	A,L
	AND	1FH
	CP	1FH
	JR	NZ,.9510
.9509:	LD	A,01H
	CALL	L9575
	JR	.9538

.9510:	INC	HL
	CALL	L958C
	DEC	HL
	JR	NC,.9509
	SET	3,B
	LD	A,02H
	CALL	L9575
	JR	.9538

.9520:	INC	HL
	LD	A,L
	AND	1FH
	JR	NZ,.952A
	LD	DE,0FFE0H
	ADD	HL,DE
.952A:	CALL	L958C
	JR	NC,.9538
	SET	3,B
	LD	A,01H
	INC	C
	INC	C
	CALL	L9575
.9538:	LD	(IX+1AH),B
	RET

.953C:	LD	A,01H
	LD	(D61CC),A
	CALL	L958C
	JR	NC,.9538
	LD	A,01H
	LD	(IX+1AH),A
	JP	L9575

.954E:	LD	A,05H
	LD	(D61CC),A
	CALL	L958C
	JR	NC,.9560
	LD	A,01H
	SET	0,B
	CALL	L9575
	EX	DE,HL
.9560:	LD	DE,0020H
	ADD	HL,DE
	CALL	L958C
	JR	NC,.9571
	SET	2,B
	LD	A,01H
	INC	C
	CALL	L9575
.9571:	LD	(IX+1AH),B
	RET

; ======================

L9575:	EX	DE,HL
	LD	HL,(D61D2)
	LD	(HL),A
	INC	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	LD	(HL),C
	INC	HL
	DEC	A
	JR	Z,.9588
	INC	C
	INC	C
	LD	(HL),C
	INC	HL
.9588:	LD	(D61D2),HL
	RET

; ======================

L958C:	BIT	7,(IY+03H)
	JR	Z,.959A
	LD	A,L
	AND	1FH
	CP	10H
	RET	NC
	JR	.95A7

.959A:	BIT	7,(IY+01H)
	JR	Z,.95A7
	LD	A,L
	AND	1FH
	CP	03H
	CCF
	RET	NC
.95A7:	CALL	LBD14
	CP	20H
	CCF
	RET	Z
	SUB	(IX+10H)
	CP	08H
	RET

; ======================

L95B4:	LD	A,03H
	LD	(D61CC),A
	CALL	L958C
	JR	NC,L95C0
	SET	0,B
L95C0:	INC	HL
	LD	A,L
	AND	1FH
	JR	NZ,.95E7
	BIT	0,B
	JR	Z,.95D2
	LD	A,01H
	DEC	HL
	CALL	L9575
	JR	.9605

.95D2:	DEC	HL
	LD	A,L
	AND	0E0H
	LD	L,A
	CALL	L958C
	JR	NC,.9605
	SET	1,B
.95DE:	INC	C
	INC	C
	LD	A,01H
	CALL	L9575
	JR	.9605

.95E7:	CALL	L958C
	DEC	HL
	JR	NC,.95FC
	SET	1,B
	BIT	0,B
	INC	HL
	JR	Z,.95DE
	DEC	HL
	LD	A,02H
	CALL	L9575
	JR	.9605

.95FC:	BIT	0,B
	JR	Z,.9605
	LD	A,01H
	CALL	L9575
.9605:	LD	(IX+1AH),B
	RET

; ======================

L9609:	BIT	1,(IX+00H)
	JR	NZ,.961E
	LD	A,(IY+03H)
	AND	0FH
	CP	04H
	LD	C,0AH
	JR	Z,.962A
	LD	C,04H
	JR	.962A

.961E:	LD	A,(IX+1BH)
	LD	HL,D61CE
	LD	(HL),A
	RLD
	AND	0FH
	LD	C,A
.962A:	PUSH	IY
	POP	HL
	LD	DE,0020H
	ADD	HL,DE
	LD	A,(IY+00H)
	SUB	09H
	LD	(HL),A
	INC	HL
	LD	A,(IY+01H)
	LD	(HL),A
	INC	HL
	LD	A,0ACH
	BIT	6,(IX+00H)
	JR	NZ,.9647
	LD	A,0FCH
.9647:	LD	(HL),A
	INC	HL
	BIT	7,(IY+03H)
	JR	Z,.9651
	SET	7,C
.9651:	LD	(HL),C
	RET

; ======================

L9653:	LD	E,(IY+00H)
	INC	E
	LD	D,(IY+01H)
	BIT	7,(IY+03H)
	JR	Z,.9664
	LD	A,D
	SUB	20H
	LD	D,A
.9664:	CALL	LBC73
	BIT	6,(IX+00H)
	JR	Z,.9675
	LD	A,(IY+01H)
	AND	07H
	CP	04H
	RET	C
.9675:	INC	HL
	LD	A,L
	AND	1FH
	RET	NZ
	LD	DE,0FFE0H
	ADD	HL,DE
	RET

; ======================

L967F:	LD	HL,(D61D2)
	LD	(HL),00H
	LD	HL,D62CA
.9687:	LD	A,(HL)
	AND	A
	JR	Z,.96A4
	INC	HL
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	LD	B,A
	DEC	A
	JR	NZ,.969D
	LD	A,(HL)
	EX	DE,HL
	CALL	LBD1F
	EX	DE,HL
	INC	HL
	JR	.9687

.969D:	EX	DE,HL
	CALL	L96AB		; write data at HL to VRAM at DE, length B
	EX	DE,HL
	JR	.9687

.96A4:	LD	HL,D62CA
	LD	(D61D2),HL
	RET

; ======================

; write data at HL to VRAM at DE, length B
L96AB:	LD	C,0BEH		; VDP I/O port
	LD	A,L		; output HL as VDP address
	OUT	(O_BF),A
	LD	A,H
	OR	40H
	OUT	(O_BF),A
	EX	DE,HL		; DE -> HL
.96B6:	OUTI			; output B bytes one at a time
	JR	NZ,.96B6
	EX	DE,HL		; restore HL
	RET

; ======================

D96BC:	DW	DC603,DC612,DC621,DC630,DC63F,DC64E,DC66D,DC68C
D96CC:	DW	DC6AB,DC6BA,DC6D9,DC6F8,DC717,DC726,DC735,DC744

; ======================

L96DC:	LD	H,(IX+0DH)
	LD	L,(IX+0CH)
	BIT	7,(IX+00H)
	JR	NZ,.96F6
	LD	DE,0006H
	BIT	2,(IX+1EH)
	JR	Z,.96F5
	LD	DE,(D62C0)
.96F5:	ADD	HL,DE
.96F6:	BIT	6,B
	JR	NZ,.9708
	BIT	6,A
	LD	B,A
	JR	Z,.9708
	LD	(IX+1FH),18H
	LD	DE,0FFB8H
	JR	.971E

.9708:	LD	D,(IX+0FH)
	LD	E,(IX+0EH)
	LD	A,D
	OR	E
	JR	Z,.9725
	PUSH	HL
	LD	HL,0010H
	ADD	HL,DE
	EX	DE,HL
	POP	HL
	JR	NC,.971E
	LD	DE,0000H
.971E:	LD	(IX+0FH),D
	LD	(IX+0EH),E
	ADD	HL,DE
.9725:	BIT	7,H
	JR	NZ,.973B
	LD	DE,0180H
	BIT	6,B
	JR	NZ,.9733
	LD	DE,0200H
.9733:	PUSH	HL
	AND	A
	SBC	HL,DE
	POP	HL
	JR	C,.973B
	EX	DE,HL
.973B:	LD	(IX+0DH),H
	LD	(IX+0CH),L
	LD	E,(IX+06H)
	LD	D,(IX+07H)
	ADD	HL,DE
	LD	(IX+06H),L
	SUB	A
	BIT	7,H
	JR	Z,.9752
	DEC	A
	INC	H
.9752:	LD	(IX+07H),A
	LD	A,(IY+00H)
	ADD	A,H
	LD	(IY+00H),A
	JP	LAA23

; ======================

L975F:	LD	A,H
	CPL
	LD	H,A
	LD	A,L
	CPL
	LD	L,A
	INC	HL
	RET

; ======================

L9767:	LD	HL,D60EF
	LD	DE,0022H
	LD	B,06H
	SUB	A
.9770:	LD	(HL),A
	ADD	HL,DE
	DJNZ	.9770
	RET

; ======================

L9775:	SUB	A
	LD	(D61E9),A
	LD	IX,D60D4
	LD	HL,2680H
	LD	A,(D61C3)
	AND	A
	JR	Z,L9767
	LD	A,(D61C4)
	AND	A
	JR	Z,.979E
	LD	C,60H
	LD	E,18H
	LD	B,A
	LD	A,(D61C2)		; get level
	CP	03H
	LD	A,B
	JR	NC,.979B
	LD	E,1EH
.979B:	CALL	L97B4
.979E:	LD	A,(D61C5)
	AND	A
	JR	Z,.97AB
	LD	C,0E0H
	LD	E,16H
	CALL	L97B4
.97AB:	LD	A,(D61C6)
	AND	A
	RET	Z
	LD	C,40H
	LD	E,09H

L97B4:	LD	B,A
.97B5:	LD	(IX+00H),06H
	LD	(IX+0AH),E
	LD	(IX+1BH),C
	LD	(IX+05H),1EH
	PUSH	DE
	LD	DE,0022H
	ADD	IX,DE
	POP	DE
	DJNZ	.97B5
	PUSH	HL
	EX	DE,HL
	PUSH	DE
	LD	DE,0040H
	LD	HL,0000H
	LD	B,A
.97D6:	ADD	HL,DE
	DJNZ	.97D6
	POP	DE
	LD	A,C
	PUSH	HL
	POP	BC
	ADD	HL,DE
	EX	DE,HL
	POP	HL
	PUSH	DE
	PUSH	BC
	CALL	LBE5B		; write A to VRAM at HL, length BC
	LD	DE,0800H
	ADD	HL,DE
	POP	BC
	PUSH	BC
	CALL	LBE5B		; write A to VRAM at HL, length BC
	LD	DE,0800H
	ADD	HL,DE
	POP	BC
	CALL	LBE5B		; write A to VRAM at HL, length BC
	POP	HL
	RET

; ======================

L97F8:	EX	DE,HL
	CALL	LBD14
	CP	C
	RET	Z
	CALL	LBC51
	LD	A,C
	LD	D,A
	PUSH	HL
	LD	BC,0040H
	CALL	LBE5B		; write A to VRAM at HL, length BC
	POP	HL
	LD	A,D
	LD	BC,0800H
	ADD	HL,BC
	PUSH	HL
	LD	BC,0040H
	CALL	LBE5B		; write A to VRAM at HL, length BC
	POP	HL
	LD	A,D
	LD	BC,0800H
	ADD	HL,BC
	LD	BC,0040H
	CALL	LBE5B		; write A to VRAM at HL, length BC
	JP	LBC4A

; ======================

L9826:	LD	IX,D60D4
	LD	IY,D6028
	CALL	L991E
	CALL	L9BC9
	LD	A,(D62C8)
	LD	C,A
	LD	B,06H
.983A:	PUSH	BC
	LD	A,(IY+00H)
	CP	0A0H
	JR	NC,.984E
	LD	A,C
	CP	06H
	JR	C,.984E
	LD	A,(D61E3)
	BIT	0,A
	JR	Z,.9851
.984E:	CALL	L99F1
.9851:	POP	BC
	LD	DE,0022H
	ADD	IX,DE
	LD	DE,0004H
	ADD	IY,DE
	DJNZ	.983A
	RET

; ======================

L985F:	LD	HL,D61CA
	DEC	(HL)
	RET	NZ
	CALL	LBAF9
	AND	1FH
	ADD	A,0AH
	LD	(HL),A
	AND	03H
	ADD	A,A
	ADD	A,A
	ADD	A,A
	LD	E,A
	LD	D,00H
	LD	HL,D98FE
	ADD	HL,DE
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	E,(HL)
	LD	A,(D61E8)
	AND	E
	RET	NZ
	DEC	(IX+05H)
	JR	Z,.98C0
	LD	A,(D6020)
	SUB	C
	BIT	7,A
	JR	Z,.9891
	NEG
.9891:	CP	20H
	JR	NC,.98A2
	LD	A,(D6021)
	SUB	B
	BIT	7,A
	JR	Z,.989F
	NEG
.989F:	CP	50H
	RET	C
.98A2:	LD	A,(D60B2)
	BIT	0,A
	JR	Z,.98C0
	LD	A,(D6024)
	SUB	C
	JR	NC,.98B1
	NEG
.98B1:	CP	20H
	JR	NC,.98C0
	LD	A,(D6025)
	SUB	B
	JR	NC,.98BD
	NEG
.98BD:	CP	50H
	RET	C
.98C0:	LD	A,(D61E8)
	OR	E
	LD	(D61E8),A
	LD	(IX+08H),E
	LD	(IY+00H),C
	LD	(IY+01H),B
	LD	(IY+02H),70H
	LD	(IY+03H),0EH
	LD	(IX+00H),4AH
	INC	HL
	INC	HL
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	(IX+17H),D
	LD	(IX+16H),E
	LD	(IX+05H),3CH
	LD	(IX+01H),01H
	LD	A,(D6006)
	BIT	4,A
	LD	C,08H
	JR	Z,.98FA
	LD	C,02H
.98FA:	LD	(IX+04H),C
	RET

; ======================

D98FE:	DW	6E8FH
	DB	01H
	DW	4000H
	DB	31H
	DW	0000H
	DB	4FH
	DW	04CEH
	DB	00H
	DW	29E8H
	DB	00H
	DW	5700H
	DB	16H
	DW	0002H
	DB	18H
	DW	002AH
	DB	00H
	DW	6627H
	DB	08H
	DW	2000H
	DB	22H
	DW	0000H

; ======================

L991E:	LD	A,(D61E9)
	BIT	0,A
	RET	NZ
	LD	A,(D62AA)
	AND	A
	RET	NZ
	PUSH	IY
	PUSH	IX
	LD	B,06H
L992F:	BIT	5,(IX+00H)
	JR	NZ,.993B
	BIT	2,(IX+00H)
	JR	NZ,L9951
.993B:	LD	DE,0022H
	ADD	IX,DE
	LD	DE,0004H
	ADD	IY,DE
	DJNZ	L992F
	LD	HL,D61E9
	SET	0,(HL)
	POP	IX
	POP	IY
	RET

; ======================

L9951:	DEC	B
	JR	NZ,.9962
	LD	A,(D61A0)
	AND	0C0H
	JR	NZ,.9962
	LD	A,(D61C3)
	CP	06H
	JR	Z,.9965
.9962:	CALL	L985F
.9965:	POP	IX
	POP	IY
	RET

; ======================

L996A:	LD	A,(IX+05H)
	DEC	A
	JR	NZ,.9992
	LD	A,0E0H
	LD	L,(IX+16H)
	LD	H,(IX+17H)
	CALL	L99DC
	LD	(IX+00H),03H
	LD	(IY+02H),0C8H
	LD	(IY+03H),0CH
	LD	A,(D61E8)
	LD	E,(IX+08H)
	XOR	E
	LD	(D61E8),A
	RET

.9992:	LD	(IX+05H),A
	DEC	(IX+01H)
	RET	NZ
	LD	L,(IX+16H)
	LD	H,(IX+17H)
	SRL	A
	SRL	A
	SRL	A
	JR	NZ,.99C4
	LD	(IX+01H),01H
	LD	A,(IY+03H)
	CP	0CH
	JR	Z,.99BB
	LD	(IY+03H),0CH
	LD	A,0F0H
	JP	L99DC

.99BB:	LD	(IY+03H),0FH
	LD	A,0C0H
	JP	L99DC

.99C4:	LD	(IX+01H),A
	LD	A,(IY+03H)
	CP	0EH
	JR	NZ,.99D6
	LD	(IY+03H),0CH
	LD	A,0E0H
	JR	L99DC

.99D6:	LD	(IY+03H),0EH
	LD	A,0C0H
L99DC:	PUSH	HL
	CALL	LB18C
	POP	HL
	LD	DE,0008H
	ADD	HL,DE
	PUSH	HL
	CALL	LB18C
	POP	HL
	LD	DE,0008H
	ADD	HL,DE
	JP	LB18C

; ======================

L99F1:	BIT	3,(IX+00H)
	JP	NZ,L996A
	BIT	0,(IX+00H)
	RET	Z
	LD	C,(IX+04H)
	BIT	5,(IX+00H)
	JP	Z,.9AB3
	BIT	2,(IX+00H)
	JP	Z,.9AAD
	LD	H,(IX+17H)
	LD	L,(IX+16H)
	LD	DE,0001H
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	H,(IY+01H)
	LD	L,(IY+00H)
	BIT	7,(IY+03H)
	JR	Z,.9A29
	LD	H,00H
.9A29:	BIT	6,(IY+03H)
	JR	NZ,.9A7A
	BIT	7,(IX+03H)
	JR	NZ,.9A40
	LD	A,0CH
	ADD	A,D
	BIT	7,A
	JR	NZ,.9A48
	LD	A,0FFH
	JR	.9A48

.9A40:	LD	A,0E8H
	ADD	A,D
	BIT	7,A
	JR	Z,.9A48
	SUB	A
.9A48:	LD	D,A
	LD	A,H
	SUB	D
	JR	NC,.9A4F
	LD	A,D
	SUB	H
.9A4F:	CP	30H
	JR	NC,.9AAD
	CP	03H
	JR	NC,.9A6B
	SET	6,(IY+03H)
	BIT	7,(IX+03H)
	LD	C,02H
	JR	NZ,.9A65
	LD	C,08H
.9A65:	LD	(IX+04H),C
	JP	.9B9D

.9A6B:	CP	10H
	JP	C,.9B9D
	LD	A,L
	SUB	E
	CP	0F6H
	JP	NC,.9BA5
	JP	.9B9D

.9A7A:	LD	A,(IX+03H)
	INC	A
	CP	03H
	JP	NC,.9A97
	AND	A
	JR	NZ,.9A8A
	LD	A,0F0H
	ADD	A,D
	LD	D,A
.9A8A:	LD	A,H
	SUB	D
	JR	NC,.9A90
	LD	A,D
	SUB	H
.9A90:	SUB	07H
	CP	03H
	JP	C,LA2C2
.9A97:	LD	A,L
	SUB	E
	ADD	A,0EH
	CP	04H
	JR	C,.9AAD
	CP	1EH
	LD	DE,0025H
	JP	C,.9B7F
	LD	DE,0090H
	JP	.9B7F

.9AAD:	LD	DE,0057H
	JP	.9B7F

.9AB3:	DEC	(IX+0BH)
	JR	NZ,.9AD4
	CALL	LBAF9
	AND	7FH
	ADD	A,3CH
	LD	(IX+0BH),A
	BIT	0,A
	JR	Z,.9AD4
	BIT	1,A
	JR	Z,.9AD0
	SET	3,C
	RES	1,C
	JR	.9AD4

.9AD0:	SET	1,C
	RES	3,C
.9AD4:	DEC	(IX+09H)
	JP	NZ,.9BA1
	LD	A,(IX+0AH)
	BIT	2,(IX+1EH)
	JR	Z,.9AED
	SRL	A
	SRL	A
	LD	(IX+09H),A
	JP	.9BA5

.9AED:	LD	(IX+09H),A
	LD	A,(IX+0DH)
	DEC	A
	JR	NZ,.9AFE
	LD	A,(IY+00H)
	CP	78H
	JP	NC,.9BA5
.9AFE:	BIT	0,(IX+1EH)
	JR	NZ,.9B09
.9B04:	CALL	L9BB6
	JR	.9B3B

.9B09:	LD	HL,D61A0
	BIT	6,(HL)
	JR	NZ,.9B24
	BIT	7,(HL)
	LD	A,(D6020)
	LD	B,A
	JR	NZ,.9B2D
	PUSH	IY
	POP	DE
	LD	A,E
	AND	07H
	LD	A,(D6020)
	LD	B,A
	JR	Z,.9B2D
.9B24:	LD	A,(D6024)
	LD	B,A
	LD	A,(D60B2)
	JR	.9B30

.9B2D:	LD	A,(D6090)
.9B30:	BIT	0,A
	JR	Z,.9B04
	BIT	5,A
	JR	NZ,.9B04
	LD	A,B
	SUB	04H
.9B3B:	LD	B,(IY+00H)
	SUB	B
	JR	NC,.9B61
	CP	0FEH
	JR	NC,.9B57
	BIT	7,(IX+00H)
	JR	NZ,.9BA5
	LD	A,(D61C2)		; get level
	CP	03H
	JR	NC,.9BA5
	LD	DE,0000H
	JR	.9B7F

.9B57:	LD	DE,0025H
	JR	Z,.9B7F
	LD	DE,0050H
	JR	.9B7F

.9B61:	LD	DE,0057H
	JR	Z,.9B7F
	CP	03H
	JR	C,.9B76
	LD	A,(D61C2)		; get level
	CP	03H
	JR	NC,.9B9D
	LD	DE,0090H
	JR	.9B7F

.9B76:	DEC	A
	LD	DE,0070H
	JR	Z,.9B7F
	LD	DE,0090H
.9B7F:	LD	H,(IX+0DH)
	LD	L,(IX+0CH)
	BIT	7,H
	JR	Z,.9B94
	BIT	7,D
	JR	Z,.9B9D
	AND	A
	SBC	HL,DE
	JR	C,.9B9D
	JR	.9BA5

.9B94:	BIT	7,D
	JR	NZ,.9BA5
	AND	A
	SBC	HL,DE
	JR	NC,.9BA5
.9B9D:	LD	(IX+09H),01H
.9BA1:	RES	6,C
	JR	.9BB0

.9BA5:	SET	6,C
	LD	A,40H
	CPL
	AND	(IX+08H)
	LD	(IX+08H),A
.9BB0:	LD	(IX+04H),C
	JP	L8401

; ======================

L9BB6:	LD	A,(IY+00H)
	CP	30H
	LD	B,1CH
	JR	C,.9BC7
	LD	B,48H
	CP	68H
	JR	C,.9BC7
	LD	B,88H
.9BC7:	LD	A,B
	RET

; ======================

L9BC9:	LD	A,(D61C3)
	LD	C,A
	LD	A,(D628D)
	CP	C
	RET	Z
	LD	B,A
	LD	A,(D61C8)
	LD	C,A
	LD	A,(D61D8)
	CP	06H
	JR	C,.9BE4
	INC	C
	CP	0CH
	JR	C,.9BE4
	INC	C
.9BE4:	LD	A,B
	CP	C
	RET	NC
	LD	HL,D60D4
	LD	B,06H
.9BEC:	BIT	0,(HL)
	LD	DE,0022H
	JR	Z,.9BFE
	LD	DE,001EH
	ADD	HL,DE
	BIT	0,(HL)
	JR	Z,.9C02
	LD	DE,0004H
.9BFE:	ADD	HL,DE
	DJNZ	.9BEC
	RET

.9C02:	SET	0,(HL)
	LD	HL,D628D
	INC	(HL)
	RET

; ======================

L9C09:	LD	HL,D628C
	INC	(HL)
	LD	HL,D61E3
	LD	DE,000DH
.9C13:	ADD	HL,DE
	BIT	0,(HL)
	JR	NZ,.9C13
	LD	A,09H
	LD	(HL),A
	INC	HL
	LD	A,(IX+03H)
	AND	A
	JR	NZ,.9C41
	LD	A,01H
	BIT	7,(IY+03H)
	JR	NZ,.9C41
	LD	A,(IY+01H)
	LD	C,A
	AND	07H
	SUB	03H
	CP	03H
	LD	A,01H
	JR	NC,.9C41
	LD	A,C
	AND	0F8H
	OR	04H
	LD	(IY+01H),A
	SUB	A
.9C41:	LD	C,A
	LD	A,(D62C8)
	CP	06H
	LD	A,C
	JR	C,.9C5C
	BIT	7,A
	JR	Z,.9C50
	NEG
.9C50:	CP	01H
	JR	Z,.9C56
	SRL	A
.9C56:	BIT	7,C
	JR	Z,.9C5C
	NEG
.9C5C:	LD	(HL),A
	INC	HL
	LD	A,(IX+02H)
	LD	(HL),A
	INC	HL
	LD	E,(IX+0CH)
	LD	D,(IX+0DH)
	BIT	7,D
	JR	NZ,.9C70
	LD	DE,0FFE2H
.9C70:	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	LD	E,(IX+06H)
	LD	D,(IX+07H)
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	LD	(HL),0AH
	INC	HL
	EX	DE,HL
	PUSH	IY
	POP	HL
	LD	BC,0020H
	ADD	HL,BC
	EX	DE,HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	LD	(HL),00H
	INC	HL
	LD	A,(IX+1BH)
	LD	(HL),A
	EX	DE,HL
	LD	A,(IY+00H)
	LD	(HL),A
	INC	HL
	LD	A,(IY+01H)
	BIT	7,(IY+03H)
	JR	Z,.9CA5
	SUB	A
.9CA5:	LD	(HL),A
	INC	HL
	LD	(HL),88H
	INC	HL
	LD	(HL),03H
	RET

; ======================

L9CAD:	LD	A,(D628C)
	AND	A
	RET	Z
	LD	IX,D61F0
	LD	B,0CH
L9CB8:	BIT	0,(IX+00H)
	JR	Z,.9CC9
	BIT	1,(IX+00H)
	JR	NZ,.9CC9
	PUSH	BC
	CALL	L9E65
	POP	BC
.9CC9:	LD	DE,000DH
	ADD	IX,DE
	DJNZ	L9CB8
	LD	A,(D6090)
	BIT	0,A
	JR	Z,.9D0C
	BIT	5,A
	JR	NZ,.9D0C
	LD	HL,D6090
	LD	A,(D62C4)
	LD	(D61B7),A
	LD	C,05H
	BIT	7,A
	JR	Z,.9CEC
	LD	C,08H
.9CEC:	PUSH	HL
	EXX
	POP	HL
	EXX
	LD	HL,D61A0
	RES	1,(HL)
	LD	DE,D6020
	LD	A,(DE)
	ADD	A,C
	LD	L,A
	INC	DE
	LD	A,(DE)
	ADD	A,07H
	LD	H,A
	INC	DE
	INC	DE
	LD	A,(DE)
	BIT	7,A
	JR	Z,.9D09
	LD	H,03H
.9D09:	CALL	L9D43
.9D0C:	LD	A,(D60B2)
	BIT	0,A
	RET	Z
	BIT	5,A
	RET	NZ
	LD	HL,D60B2
	LD	A,(D62C5)
	LD	(D61B7),A
	LD	C,05H
	BIT	7,A
	JR	Z,.9D26
	LD	C,09H
.9D26:	PUSH	HL
	EXX
	POP	HL
	EXX
	LD	HL,D61A0
	SET	1,(HL)
	LD	DE,D6024
	LD	A,(DE)
	ADD	A,C
	LD	L,A
	INC	DE
	LD	A,(DE)
	ADD	A,07H
	LD	H,A
	INC	DE
	INC	DE
	LD	A,(DE)
	BIT	7,A
	JR	Z,L9D43
	LD	H,03H
L9D43:	LD	IX,D61F0
	LD	B,0CH
.9D49:	PUSH	BC
	BIT	0,(IX+00H)
	JR	Z,.9DB5
	BIT	1,(IX+00H)
	JR	Z,.9D6F
	LD	A,(D61B7)
	BIT	7,A
	JR	Z,.9D82
	PUSH	IX
	EXX
	PUSH	HL
	EXX
	POP	IX
	BIT	1,(IX+1EH)
	JP	Z,.9DBE
	POP	IX
	JR	.9D82

.9D6F:	LD	E,(IX+08H)
	LD	D,(IX+09H)
	LD	A,(DE)
	ADD	A,08H
	PUSH	AF
	INC	DE
	LD	A,(DE)
	ADD	A,08H
	LD	D,A
	POP	AF
	LD	E,A
	JR	.9D88

.9D82:	LD	E,(IX+01H)
	LD	D,(IX+02H)
.9D88:	LD	BC,0806H
	LD	A,(D61B7)
	BIT	7,A
	JR	Z,.9D94
	LD	C,0EH
.9D94:	BIT	4,(IX+00H)
	JR	Z,.9D9E
	LD	A,E
	SUB	08H
	LD	E,A
.9D9E:	LD	A,L
	SUB	E
	BIT	7,A
	JR	Z,.9DA6
	NEG
.9DA6:	CP	C
	JR	NC,.9DB5
	LD	A,H
	SUB	D
	BIT	7,A
	JR	Z,.9DB1
	NEG
.9DB1:	CP	B
	CALL	C,L9DF2
.9DB5:	POP	BC
	LD	DE,000DH
	ADD	IX,DE
	DJNZ	.9D49
	RET

.9DBE:	LD	E,(IX+16H)
	LD	D,(IX+17H)
	POP	IX
	LD	A,(IX+0CH)
	CP	02H
	JR	Z,.9DB5
	LD	A,(IX+05H)
	CP	D
	JR	NZ,.9DB5
	LD	A,E
	AND	1FH
	CP	1EH
	JR	C,.9DDE
	BIT	7,H
	JR	Z,.9DB5
.9DDE:	LD	A,(IX+04H)
	SUB	E
	JR	Z,.9DE7
	DEC	A
	JR	NZ,.9DB5
.9DE7:	LD	E,(IX+01H)
	LD	D,(IX+02H)
	CALL	L9DF2
	JR	.9DB5

; ======================

L9DF2:	PUSH	BC
	LD	A,(D61A0)
	BIT	1,A
	LD	HL,D60B1
	JR	Z,.9E00
	LD	HL,D60D3
.9E00:	LD	A,(HL)
	CP	03H
	JR	Z,.9E07
	INC	A
	LD	(HL),A
.9E07:	PUSH	AF
	BIT	0,(IX+0AH)
	JR	NZ,.9E10
	SET	7,A
.9E10:	CALL	LB7AD
	POP	AF
	LD	HL,0250H
	AND	A
	JR	Z,.9E29
	LD	HL,0500H
	DEC	A
	JR	Z,.9E29
	LD	HL,0750H
	DEC	A
	JR	Z,.9E29
	LD	HL,1000H
.9E29:	BIT	0,(IX+0AH)
	JR	NZ,.9E34
	LD	A,H
	ADD	A,05H
	DAA
	LD	H,A
.9E34:	PUSH	HL
	POP	BC
	CALL	LBC96
	BIT	1,(IX+00H)
	JR	Z,.9E55
	LD	L,(IX+04H)
	LD	H,(IX+05H)
	LD	A,01H
	PUSH	HL
	CALL	L9322
	POP	HL
	LD	DE,0FFE0H
	ADD	HL,DE
	LD	A,01H
	CALL	L9322
.9E55:	CALL	LA076
	POP	BC
	RET

; ======================

L9E5A:	LD	H,(IX+05H)
	LD	L,(IX+04H)
	LD	A,01H
	JP	L9262

; ======================

L9E65:	LD	E,(IX+08H)
	LD	D,(IX+09H)
	PUSH	DE
	POP	IY
	LD	A,(IX+01H)
	LD	B,(IX+02H)
	ADD	A,B
	BIT	7,A
	JR	Z,.9E81
	CP	0F8H
	JR	NC,.9E87
	LD	A,0F8H
	JR	.9E87

.9E81:	CP	09H
	JR	C,.9E87
	LD	A,08H
.9E87:	LD	(IX+02H),A
	BIT	7,A
	JR	Z,.9E90
	NEG
.9E90:	SRL	A
	SRL	A
	JR	Z,.9EA8
	BIT	7,(IX+02H)
	JR	Z,.9E9E
	NEG
.9E9E:	ADD	A,(IY+01H)
	LD	(IY+01H),A
	LD	(IX+02H),00H
.9EA8:	LD	H,(IX+04H)
	LD	L,(IX+03H)
	LD	DE,0004H
	ADD	HL,DE
	BIT	7,H
	JR	NZ,.9EC1
	LD	DE,0158H
	PUSH	HL
	AND	A
	SBC	HL,DE
	POP	HL
	JR	C,.9EC1
	EX	DE,HL
.9EC1:	LD	(IX+03H),L
	LD	(IX+04H),H
	LD	E,(IX+05H)
	LD	D,(IX+06H)
	ADD	HL,DE
	LD	(IX+05H),L
	SUB	A
	BIT	7,H
	JR	Z,.9ED8
	DEC	A
	INC	H
.9ED8:	LD	(IX+06H),A
	LD	A,(IY+00H)
	ADD	A,H
	LD	(IY+00H),A
	JP	L87D8

; ======================

L9EE5:	LD	A,0A0H
	LD	(D61BB),A
	LD	E,(IY+00H)
	SUB	E
	JR	C,.9EF5
	CP	0DH
	RET	NC
	JR	L9F3E

.9EF5:	CP	0FDH
	RET	C
	JR	L9F3E

L9EFA:	LD	A,(D61BB)
	LD	E,(IY+00H)
	SUB	E
	JR	C,.9F08
	CP	0DH
	RET	NC
	JR	.9F0B

.9F08:	CP	0FDH
	RET	C
.9F0B:	LD	A,(IY+01H)
	LD	D,A
	LD	H,00H
	LD	A,E
	SUB	53H
	CP	07H
	LD	A,D
	JR	C,.9F23
	CP	0D0H
	JR	C,.9F23
	LD	HL,D61BA
	DEC	(HL)
	LD	H,0FFH
.9F23:	LD	A,(D61B9)
	LD	B,A
	SUB	D
	JR	C,.9F2F
	CP	0BH
	RET	NC
	JR	L9F3E

.9F2F:	LD	A,(D61BA)
	ADD	A,B
	SUB	D
	JR	Z,L9F3E
	RET	C
	BIT	0,H
	JR	NZ,L9F3E
	CP	05H
	RET	C
L9F3E:	LD	A,(D61BB)
	SUB	E
	SUB	08H
	CP	05H
	JP	NC,L9FFA
	LD	(IX+0AH),0FFH
	LD	A,(D61BB)
	SUB	0CH
	LD	(IY+00H),A
	LD	A,E
	CP	5CH
	JR	NZ,.9F6A
	LD	A,D
	CP	80H
	JR	C,.9F6A
	CP	0E4H
	JR	NC,.9F6A
	LD	(IY+01H),0E4H
	JP	LA010

.9F6A:	LD	H,(IX+04H)
	LD	L,(IX+03H)
	BIT	7,H
	RET	NZ
	SRL	H
	RR	L
	CALL	L975F
	LD	A,L
	CP	0E0H
	JR	C,.9F82
	LD	HL,0FFF9H
.9F82:	LD	(IX+04H),H
	LD	(IX+03H),L
	LD	A,L
	CP	0B0H
	JR	C,.9F91
	DEC	(IX+07H)
	RET	NZ
.9F91:	LD	A,(IX+01H)
	BIT	7,A
	JR	Z,.9F9A
	NEG
.9F9A:	LD	C,01H
	AND	A
	JR	Z,.9FAB
	LD	C,0DH
	DEC	A
	JR	Z,.9FAB
	LD	C,06H
	DEC	A
	JR	Z,.9FAB
	LD	C,02H
.9FAB:	LD	(IX+07H),C
	LD	A,(IX+01H)
	LD	C,A
	EX	AF,AF'
	LD	A,C
	BIT	7,A
	JR	Z,L9FD6
	NEG
	SRL	A
	NEG
	JR	Z,.9FC4
	LD	(IX+01H),A
	RET

.9FC4:	LD	A,(IY+01H)
	AND	07H
	CP	04H
	JR	Z,L9FEA
L9FCD:	LD	(IX+01H),0FFH
	LD	(IX+07H),01H
	RET

L9FD6:	AND	A
	JR	Z,.9FE1
	SRL	A
	JR	Z,.9FE1
	LD	(IX+01H),A
	RET

.9FE1:	LD	A,(IY+01H)
	AND	07H
	CP	04H
	JR	NZ,L9FF1
L9FEA:	LD	A,L
	CP	0F9H
	RET	C
	JP	LA010

; ======================

L9FF1:	LD	(IX+07H),01H
	LD	(IX+01H),01H
	RET

; ======================

L9FFA:	INC	(IY+00H)
	LD	H,(IX+04H)
	LD	L,(IX+03H)
	BIT	7,H
	RET	Z
	CALL	L975F
	LD	(IX+03H),L
	LD	(IX+04H),H
	RET

; ======================

LA010:	LD	A,(IY+01H)
	ADD	A,08H
	LD	D,A
	LD	A,(IY+00H)
	ADD	A,08H
	LD	E,A
	LD	A,(D61E4)
	BIT	0,A
	JR	Z,.A02F
	LD	A,E
	CP	80H
	JR	C,.A02F
	LD	A,D
	SUB	30H
	CP	0B0H
	JR	NC,.A06D
.A02F:	CALL	LBC73
	CALL	LBD14
	CP	20H
	JR	Z,.A04A
	LD	DE,199CH
	AND	A
	SBC	HL,DE
	JR	NZ,.A06D
	INC	(IY+01H)
	INC	(IY+01H)
	JP	L9FF1

.A04A:	LD	A,L
	AND	1FH
	JR	Z,.A06D
	LD	(IX+02H),D
	LD	(IX+01H),E
	SET	1,(IX+00H)
	LD	(IX+03H),30H
	LD	(IX+05H),H
	LD	(IX+04H),L
	LD	A,01H
	LD	C,1DH
	CALL	L9262
	JP	LBB7B

.A06D:	EX	AF,AF'
	BIT	7,A
	JP	NZ,L9FCD
	JP	L9FF1

; ======================

LA076:	BIT	4,(IX+00H)
	JR	NZ,.A082
	BIT	1,(IX+00H)
	JR	NZ,.A08B
.A082:	LD	E,(IX+08H)
	LD	D,(IX+09H)
	LD	A,0EFH
	LD	(DE),A
.A08B:	BIT	1,(IX+00H)
	JR	Z,LA099
	LD	A,(IX+03H)
	CP	07H
	CALL	C,LA0A4
LA099:	LD	(IX+00H),00H
	LD	HL,D628C
	DEC	(HL)
	JP	L8F89

; ======================

LA0A4:	LD	H,(IX+07H)
	LD	L,(IX+06H)
	RES	2,(HL)
	LD	DE,001CH
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	INC	HL
	INC	HL
	INC	HL
	RES	6,(HL)
	LD	HL,D61C3
	INC	(HL)
	RET

; ======================

LA0BE:	LD	IX,D61F0
	LD	B,0CH
.A0C4:	PUSH	BC
	LD	A,(IX+00H)
	BIT	0,A
	JR	Z,.A111
	BIT	6,A
	JR	NZ,.A111
	BIT	4,A
	JR	Z,.A0D9
	CALL	LA25A
	JR	.A111

.A0D9:	BIT	1,A
	JR	Z,.A111
	LD	A,(D61D7)
	AND	0FH
	CP	B
	JR	NZ,.A111
	LD	A,(IX+03H)
	DEC	A
	LD	(IX+03H),A
	CP	06H
	JR	NZ,.A0F5
	CALL	LA11A
	JR	.A111

.A0F5:	CP	05H
	JR	NZ,.A100
	LD	C,6AH
	CALL	L9E5A
	JR	.A111

.A100:	CP	04H
	JR	NZ,.A10B
	LD	C,1DH
	CALL	L9E5A
	JR	.A111

.A10B:	AND	A
	JR	NZ,.A111
	CALL	LA217
.A111:	POP	BC
	LD	DE,000DH
	ADD	IX,DE
	DJNZ	.A0C4
	RET

; ======================

LA11A:	LD	IY,D6028
	LD	HL,D60D4
	LD	DE,2680H
	LD	B,06H
	LD	A,(D62C8)
	CP	05H
	JR	NC,.A14B
.A12D:	LD	A,(HL)
	AND	A
	JR	NZ,.A138
	LD	A,(IY+20H)
	CP	0EFH
	JR	Z,.A150
.A138:	PUSH	BC
	LD	BC,0022H
	ADD	HL,BC
	EX	DE,HL
	LD	BC,0040H
	ADD	HL,BC
	EX	DE,HL
	LD	BC,0004H
	ADD	IY,BC
	POP	BC
	DJNZ	.A12D
.A14B:	LD	(IX+03H),1AH
	RET

.A150:	LD	A,(D62C8)
	INC	A
	LD	(D62C8),A
	LD	A,27H
	LD	(HL),A
	PUSH	IX
	LD	C,(IX+0BH)
	LD	A,C
	CP	0E0H
	JR	NZ,.A16A
	LD	(IX+0CH),00H
	JR	.A179

.A16A:	CP	40H
	JR	NZ,.A179
	LD	A,(IX+0CH)
	INC	A
	CP	03H
	JR	Z,.A179
	LD	(IX+0CH),A
.A179:	LD	(IX+06H),L
	LD	(IX+07H),H
	PUSH	HL
	LD	L,(IX+01H)
	LD	H,(IX+02H)
	POP	IX
	LD	A,C
	AND	A
	LD	C,60H
	LD	B,18H
	JR	Z,.A19C
	CP	60H
	LD	C,0E0H
	LD	B,16H
	JR	Z,.A19C
	LD	C,40H
	LD	B,09H
.A19C:	LD	A,C
	LD	(D61BA),A
	LD	(IX+1BH),C
	LD	(IX+0AH),B
	PUSH	HL
	CALL	L97F8
	POP	DE
	LD	A,D
	CP	80H
	LD	C,08H
	LD	B,0FCH
	LD	A,0FFH
	JR	C,.A1BB
	SUB	A
	LD	C,02H
	LD	B,04H
.A1BB:	LD	(IX+04H),C
	LD	(IY+01H),A
	LD	(IX+03H),B
	LD	(IX+0CH),00H
	LD	(IX+0DH),00H
	LD	A,E
	CP	80H
	LD	C,88H
	JR	NC,.A1DB
	LD	C,50H
	CP	50H
	JR	NC,.A1DB
	LD	C,18H
.A1DB:	LD	(IY+00H),C
	POP	HL
	LD	(IX+16H),L
	LD	(IX+17H),H
	PUSH	HL
	POP	IX
	LD	A,(D61BA)
	LD	(IX+0BH),A
	PUSH	IY
	POP	DE
	LD	HL,0020H
	ADD	HL,DE
	LD	(IX+08H),L
	LD	(IX+09H),H
	LD	C,69H
	CALL	L9E5A
	LD	A,(IX+0CH)
	CP	02H
	RET	NZ
	LD	L,(IX+06H)
	LD	H,(IX+07H)
	LD	(HL),00H
	LD	HL,D62C8
	DEC	(HL)
	LD	(IY+00H),0EFH
	RET

LA217:	SET	4,(IX+00H)
	LD	A,(IX+0CH)
	CP	02H
	JR	Z,.A245
	LD	(IX+03H),03H
	LD	C,6BH
	CALL	L9E5A
	LD	H,(IX+09H)
	LD	L,(IX+08H)
	LD	A,(IX+01H)
	SUB	05H
	LD	(HL),A
	LD	A,(IX+02H)
	SUB	08H
	INC	HL
	LD	(HL),A
	INC	HL
	LD	(HL),8CH
	INC	HL
	LD	(HL),03H
	RET

.A245:	LD	(IX+03H),0FFH
	LD	C,68H
	JP	L9E5A

LA24E:	LD	C,20H
	CALL	L9E5A
	LD	(IX+0CH),00H
	JP	LA099

LA25A:	DEC	(IX+03H)
	RET	NZ
	LD	A,(IX+0CH)
	CP	02H
	JR	Z,LA24E
	LD	(IX+03H),03H
	LD	E,(IX+08H)
	LD	D,(IX+09H)
	PUSH	DE
	POP	IY
	LD	A,(IY+02H)
	ADD	A,04H
	CP	98H
	JR	NZ,.A2B4
	LD	L,(IX+06H)
	LD	H,(IX+07H)
	LD	DE,001BH
	ADD	HL,DE
	LD	A,(HL)
	LD	C,6FH
	CP	60H
	JR	Z,.A294
	LD	C,61H
	CP	0E0H
	JR	Z,.A294
	LD	C,63H
.A294:	LD	L,(IX+04H)
	LD	H,(IX+05H)
	PUSH	HL
	LD	A,01H
	PUSH	BC
	CALL	L9262
	POP	BC
	POP	HL
	LD	DE,0FFE0H
	ADD	HL,DE
	DEC	C
	LD	A,01H
	CALL	L9262
	SET	6,(IX+00H)
	JP	LBB7B

.A2B4:	LD	(IY+02H),A
	LD	C,6CH
	CP	90H
	JP	Z,L9E5A
	INC	C
	JP	L9E5A

; ======================

LA2C2:	RES	6,(IY+03H)
	RES	5,(IX+00H)
	RES	2,(IX+00H)
	LD	L,(IX+16H)
	LD	H,(IX+17H)
	PUSH	IX
	PUSH	HL
	POP	IX
	LD	(IX+00H),00H
	LD	L,(IX+04H)
	LD	H,(IX+05H)
	LD	A,01H
	PUSH	HL
	CALL	L9322
	POP	HL
	LD	DE,0FFE0H
	ADD	HL,DE
	LD	A,01H
	CALL	L9322
	LD	HL,D628C
	DEC	(HL)
	LD	HL,D61C3
	INC	(HL)
	POP	IX
	RET

; ======================

LA2FE:	LD	HL,D628C
	LD	(HL),0CH
	LD	IX,DA38C
	LD	L,3BH
	LD	H,0CH
	LD	(D61CC),HL
	LD	IY,D61F0
.A312:	LD	L,(IX+00H)
	LD	H,(IX+01H)
	LD	E,(IX+02H)
	LD	D,(IX+03H)
	LD	B,(IX+04H)
.A321:	LD	A,(D61CC)
	LD	C,A
	CALL	LBAF1
	LD	C,A
	LD	A,(D61CD)
	CP	C
	JR	C,.A33A
	CALL	LA34F
	LD	A,(D61CD)
	DEC	A
	RET	Z
	LD	(D61CD),A
.A33A:	LD	A,(D61CC)
	DEC	A
	LD	(D61CC),A
	INC	HL
	LD	A,D
	ADD	A,08H
	LD	D,A
	DJNZ	.A321
	LD	DE,0005H
	ADD	IX,DE
	JR	.A312

; ======================

LA34F:	LD	(IY+00H),0BH
	LD	(IY+01H),E
	LD	(IY+02H),D
	LD	(IY+04H),L
	LD	(IY+05H),H
	LD	C,10H
	CALL	LBAF1
	ADD	A,28H
	LD	(IY+03H),A
	LD	(IY+0AH),0FFH
	PUSH	HL
	EXX
	LD	A,(D61C2)		; get level
	LD	C,00H
	CP	0BH
	JR	C,.A37A
	LD	C,60H
.A37A:	LD	(IY+0BH),C
	POP	HL
	LD	A,01H
	LD	C,1DH
	CALL	L9262
	LD	DE,000DH
	ADD	IY,DE
	EXX
	RET

; ======================

DA38C:	DW	18A1H,0C2CH
	DB	02H
	DW	18CAH,5434H
	DB	0AH
	DW	18BCH,0E42CH
	DB	04H
	DW	1981H,0C64H
	DB	06H
	DW	19CCH,6474H
	DB	07H
	DW	1977H,0BC5CH
	DB	06H
	DW	199DH,0EC64H
	DB	03H
	DW	1A66H,349CH
	DB	16H

; ======================

LA3B4:	BIT	6,C
	JR	NZ,.A3C5
	LD	A,(D61C3)
	CP	04H
	JR	C,.A3C5
	LD	HL,00FAH
	LD	(D62B5),HL
.A3C5:	LD	DE,0FF50H
	LD	A,(D6020)
	ADD	A,03H
	CP	93H
	JR	C,.A3D3
	LD	A,92H
.A3D3:	CP	68H
	JR	NC,.A3DA
	LD	DE,0FF8CH
.A3DA:	LD	HL,D62AE
	BIT	0,(HL)
	RET	NZ
	LD	(HL),C
	INC	HL
	LD	(HL),A
	INC	HL
	LD	(HL),50H
	INC	HL
	LD	(HL),50H
	INC	HL
	LD	(HL),00H
	INC	HL
	LD	(HL),00H
	INC	HL
	LD	A,(D6021)
	CP	80H
	LD	A,01H
	JR	NC,.A3FB
	LD	A,03H
.A3FB:	LD	(HL),A
	LD	IY,D6060
	PUSH	DE
	CALL	LA5C9
	POP	DE
	LD	(IY+03H),0DH
	LD	(IY+07H),0DH
	LD	(IY+02H),7CH
	LD	(IY+06H),80H
	LD	(IY+01H),D
	LD	A,D
	ADD	A,1EH
	LD	D,A
	LD	(IY+05H),D
	LD	(IY+00H),E
	LD	(IY+04H),E
	SET	7,(IY+07H)
	RET

; ======================

LA42A:	LD	IX,D62AE
	LD	A,(IX+00H)
	BIT	0,A
	RET	Z
	LD	IY,D6060
	BIT	2,A
	JP	NZ,LA732
	BIT	3,A
	JR	NZ,.A48A
	BIT	1,A
	JR	Z,.A48A
	LD	A,(IX+02H)
	DEC	A
	LD	(IX+02H),A
	JR	Z,.A458
	CP	27H
	JR	NZ,.A48A
	LD	(IX+05H),00H
	JR	.A48A

.A458:	RES	1,(IX+00H)
	LD	(IX+05H),00H
	LD	HL,D61A0
	BIT	7,(HL)
	JR	NZ,.A477
	BIT	6,(HL)
	JR	NZ,.A472
	LD	HL,D61D7
	BIT	0,(HL)
	JR	Z,.A477
.A472:	LD	A,(D6024)
	JR	.A47A

.A477:	LD	A,(D6020)
.A47A:	ADD	A,03H
	CP	93H
	JR	C,.A487
	CP	0E0H
	SUB	A
	JR	C,.A487
	LD	A,92H
.A487:	LD	(IX+01H),A
.A48A:	LD	D,(IY+01H)
	LD	A,(IX+06H)
	CP	01H
	LD	A,(IX+05H)
	JR	Z,.A4A9
	AND	A
	JR	Z,.A49E
	NEG
	JR	.A4B5

.A49E:	LD	HL,D61D7
	BIT	0,(HL)
	JR	Z,.A4CB
	LD	A,0FFH
	JR	.A4B5

.A4A9:	AND	A
	JR	NZ,.A4B5
	LD	HL,D61D7
	BIT	0,(HL)
	JR	Z,.A4CB
	LD	A,01H
.A4B5:	PUSH	AF
	CALL	LA5FD
	JR	Z,.A4BD
	POP	AF
	RET

.A4BD:	POP	AF
	PUSH	IY
	LD	BC,0004H
	ADD	IY,BC
	CALL	LA5FD
	POP	IY
	RET	NZ
.A4CB:	BIT	3,(IX+00H)
	JP	NZ,.A521
	LD	E,(IY+00H)
	BIT	1,(IX+00H)
	JR	NZ,.A521
	LD	A,(D61D7)
	AND	03H
	CP	03H
	JR	NZ,.A521
	LD	A,(IX+01H)
	CP	E
	JR	NC,.A4EE
	LD	A,0FFH
	JR	.A4F0

.A4EE:	LD	A,01H
.A4F0:	ADD	A,E
	LD	E,A
	LD	A,(IX+01H)
	ADD	A,02H
	SUB	E
	CP	02H
	JR	NC,.A50E
	SET	1,(IX+00H)
	CALL	LBAF9
	AND	7FH
	ADD	A,28H
	LD	(IX+02H),A
	LD	(IX+05H),02H
.A50E:	LD	A,E
	CP	93H
	JR	C,.A51B
	LD	E,00H
	CP	0E0H
	JR	NC,.A51B
	LD	E,92H
.A51B:	LD	(IY+00H),E
	LD	(IY+04H),E
.A521:	CALL	L87F9
	SUB	A
	CP	H
	JR	NZ,.A5A6
	LD	E,(IY+00H)
	LD	D,(IY+01H)
	LD	A,D
	CP	0DDH
	JR	NZ,.A558
	LD	A,E
	SUB	5BH
	CP	04H
	JR	NC,.A558
	LD	A,E
	ADD	A,0AH
	LD	(IY+00H),A
	LD	A,D
	ADD	A,0F8H
	LD	(IY+01H),A
	LD	A,(IY+04H)
	ADD	A,0AH
	LD	(IY+04H),A
	LD	A,(IY+05H)
	ADD	A,0F8H
	LD	(IY+05H),A
	JR	.A5A6

.A558:	LD	A,(D61BB)
	LD	B,E
	SUB	B
	JR	C,.A576
	CP	06H
	JR	C,.A576
	LD	A,(D61BB)
	SUB	0BH
	LD	B,(IY+00H)
	CP	B
	JR	NC,.A5A6
	LD	(IY+00H),A
	LD	(IY+04H),A
	JR	.A5A6

.A576:	INC	(IY+00H)
	INC	(IY+04H)
	BIT	3,(IX+00H)
	JR	NZ,.A5A6
	LD	A,D
	SUB	0F0H
	CP	20H
	JR	C,.A5A6
	LD	A,(D61B9)
	LD	C,A
	LD	B,D
	CP	B
	JR	NC,.A5A0
	LD	A,(D61BA)
	ADD	A,C
	SUB	B
	CP	10H
	JR	NC,.A5A6
	LD	(IX+06H),01H
	JR	LA5C9

.A5A0:	LD	(IX+06H),03H
	JR	LA5C9

.A5A6:	LD	A,(IX+05H)
	AND	A
	JR	Z,.A5B8
	LD	A,(IX+04H)
	CP	02H
	RET	Z
	LD	(IX+04H),02H
	JR	LA5C9

.A5B8:	LD	A,(D61D7)
	SUB	06H
	AND	07H
	RET	NZ
	LD	A,(IX+04H)
	INC	A
	AND	03H
	LD	(IX+04H),A
LA5C9:	LD	A,(IX+06H)
	CP	01H
	LD	A,(IX+04H)
	JR	NZ,LA5EB
	BIT	0,A
	LD	DE,DA81E
	JR	NZ,LA5E3
	AND	A
	LD	DE,DA7F4
	JR	Z,LA5E3
	LD	DE,DA848
LA5E3:	LD	HL,3BE0H
	LD	A,NA7F4
	JP	LB6B8

LA5EB:	BIT	0,A
	LD	DE,DA89C
	JR	NZ,LA5E3
	LD	DE,DA872
	AND	A
	JR	Z,LA5E3
	LD	DE,DA8C6
	JR	LA5E3

LA5FD:	LD	D,(IY+01H)
	BIT	7,A
	JR	NZ,.A628
	BIT	7,(IY+03H)
	JR	NZ,.A61B
	ADD	A,D
	JR	NC,.A64A
	BIT	3,(IX+00H)
	JR	NZ,.A64F
	SET	7,(IY+03H)
	ADD	A,0EH
	JR	.A64A

.A61B:	ADD	A,D
	CP	20H
	JR	C,.A64A
	RES	7,(IY+03H)
	SUB	20H
	JR	.A64A

.A628:	BIT	7,(IY+03H)
	JR	NZ,.A63F
	ADD	A,D
	JR	C,.A64A
	BIT	3,(IX+00H)
	JR	NZ,.A64F
	SET	7,(IY+03H)
	ADD	A,20H
	JR	.A64A

.A63F:	ADD	A,D
	CP	0EH
	JR	NC,.A64A
	RES	7,(IY+03H)
	SUB	0EH
.A64A:	LD	(IY+01H),A
	SUB	A
	RET

.A64F:	RES	0,(IX+00H)
	LD	A,0EFH
	LD	(D6060),A
	LD	(D6064),A
	LD	HL,0400H
	LD	(D62B5),HL
	LD	A,(D61C3)
	AND	A
	RET	NZ
	LD	A,(D628C)
	AND	A
	RET	NZ
	JP	L80E6

; ======================

LA66E:	LD	HL,D62AE
	BIT	0,(HL)
	RET	Z
	BIT	2,(HL)
	RET	NZ
	LD	A,(D6063)
	LD	B,(IY+03H)
	XOR	B
	BIT	7,A
	RET	NZ
	LD	HL,(D6060)
	LD	A,(IY+01H)
	BIT	7,A
	JR	Z,.A694
	CP	0F0H
	JR	C,.A69B
	BIT	7,H
	RET	Z
	JR	.A69B

.A694:	CP	10H
	JR	NC,.A69B
	BIT	7,H
	RET	NZ
.A69B:	LD	A,H
	ADD	A,04H
	LD	H,A
	LD	A,(IY+01H)
	SUB	H
	BIT	7,A
	JR	Z,.A6A9
	NEG
.A6A9:	CP	10H
	RET	NC
	INC	L
	LD	A,(IY+00H)
	SUB	L
	BIT	7,A
	JR	Z,.A6B7
	NEG
.A6B7:	CP	09H
	RET	NC
	BIT	1,(IX+00H)
	JP	NZ,L8D86
	LD	A,(IY+00H)
	ADD	A,02H
	SUB	L
	CP	04H
	JP	NC,L8EEE
	LD	A,(D62B4)
	CP	01H
	JR	NZ,.A6E3
	BIT	6,(IX+00H)
	JP	NZ,L8EEE
	LD	A,H
	CP	(IY+01H)
	JP	NC,L8EEE
	JR	.A6F1

.A6E3:	BIT	6,(IX+00H)
	JP	Z,L8EEE
	LD	A,H
	CP	(IY+01H)
	JP	C,L8EEE
.A6F1:	LD	HL,D61A0
	LD	A,(IY+03H)
	AND	0FH
	CP	04H
	RES	1,(HL)
	JR	Z,.A701
	SET	1,(HL)
.A701:	LD	BC,1000H
	CALL	LBC96
	SUB	A
	LD	(D62B1),A
	LD	HL,D62AE
	SET	2,(HL)
	INC	HL
	LD	(HL),14H
	INC	HL
	LD	(HL),07H
	CALL	L8E7F
	LD	A,40H
	XOR	(IX+00H)
	LD	(IX+00H),A
	LD	A,(D62B4)
	LD	DE,DA848
	CP	01H
	JP	Z,LA5E3
	LD	DE,DA8C6
	JP	LA5E3

; ======================

LA732:	LD	A,(IX+01H)
	AND	07H
	LD	C,0DH
	JR	NZ,.A73D
	LD	C,0FH
.A73D:	LD	A,(IY+03H)
	AND	0F0H
	OR	C
	LD	(IY+03H),A
	LD	A,(IY+07H)
	AND	0F0H
	OR	C
	LD	(IY+07H),A
	DEC	(IX+01H)
	JR	NZ,.A792
	LD	A,(IX+02H)
	SUB	07H
	NEG
	SLA	A
	ADD	A,1CH
	LD	(IX+01H),A
	DEC	(IX+02H)
	JR	NZ,.A792
	LD	A,(IY+01H)
	BIT	0,(IX+06H)
	JR	Z,.A772
	ADD	A,10H
.A772:	LD	D,A
	LD	A,(IY+00H)
	ADD	A,08H
	LD	E,A
	LD	A,03H
	CALL	LB7AD
	LD	A,06H
	LD	(D6073),A
	RES	0,(IX+00H)
	LD	(IY+00H),0EFH
	LD	(IY+04H),0EFH
	JP	L8F89

.A792:	LD	C,(IX+02H)
	LD	HL,DA7DC
	LD	A,(D62B4)
	BIT	1,A
	JR	Z,.A7A2
	LD	HL,DA7E8
.A7A2:	LD	A,(IX+03H)
	INC	A
	CP	03H
	JR	NZ,.A7AB
	SUB	A
.A7AB:	LD	(IX+03H),A
	ADD	A,A
	ADD	A,A
	LD	E,A
	LD	D,00H
	ADD	HL,DE
	PUSH	HL
	POP	IX
	LD	L,(IX+00H)
	LD	H,(IX+01H)
	LD	B,07H
	LD	DE,D61B7
.A7C2:	LD	A,C
	EXX
	CALL	LA8F0
	EXX
	AND	(HL)
	LD	(DE),A
	INC	HL
	INC	DE
	DJNZ	.A7C2
	LD	A,07H
	LD	DE,D61B7
	LD	L,(IX+02H)
	LD	H,(IX+03H)
	JP	LB6B8

; ======================

	; rightward bite slices
DA7DC:	DW	DA84B,3BE3H
	DW	DA85B,3BF3H
	DW	DA868,3C00H

	; leftward bite slices
DA7E8:	DW	DA8C6,3BE0H
	DW	DA8D9,3BF3H
	DW	DA8E9,3C03H

	; pteradactyl graphics
	; blocks of size 2AH copied to 3BE0

DA7F4:	; _XXXXX__________________
	; ____XXXXXX______________
	; ______XXXXXXXXX_________
	; ________XXXXX___________
	; _______XXXXX___XXXXXX___
	; ___XXXXXXXX_XX______XXXX
	; _XXXXXXXXXXXXXXXXXXXXXX_
	; ___XXXXXXXXXXXXXXXX_____
	; _______XXXXXXX__________
	; ________________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________

	HEX	7C 0F 03 00 01 1F 7F 1F
	HEX	01 00 00 00 00 00 00 00
	HEX	00 C0 FE F8 F1 EC FF FF
	HEX	FC 00 00 00 00 00 00 00
	HEX	00 00 00 00 F8 0F FE E0
	HEX	00 00
NA7F4	EQU	$-DA7F4

DA81E:	; ________________________
	; ________________________
	; ________________XXXXX___
	; _______XXXXXXXX___X_XXXX
	; ____XXXXXXXXXXX___XXXX__
	; ___XXX_XXXXXX_XXXXXXXX__
	; ____X_XXXXX__XXXXXX___XX
	; _XXXXXXXX_XXXX__________
	; ________________________
	; ________________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________

	HEX	00 00 00 01 0F 1D 0B 7F
	HEX	00 00 00 00 00 00 00 00
	HEX	00 00 00 FE FE FB E7 BC
	HEX	00 00 00 00 00 00 00 00
	HEX	00 00 F8 2F 3C FC E3 00
	HEX	00 00

DA848:	; _______________________X
	; __________________XXXXX_
	; ________________XXX_XX__
	; ______XXXXXX______XXXXXX
	; ___XXXXXXXXXXX____XX_X__
	; __XXXXXXXXXXXXXXXXX___X_
	; ___X_XXXXXX_XXXXX_______
	; ______XXXXX_____________
	; ___XXXXXXXXX____________
	; XXXXXXXX________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________

	HEX	00 00 00
DA84B:	HEX	03 1F 3F 17 03 1F FF 00
	HEX	00 00 00 00 00 00 00 00
DA85B:	HEX	F0 FC FF EF E0 F0 00 00
	HEX	00 00 00 00 00
DA868:	HEX	01 3E EC 3F 34 E2 80 00
	HEX	00 00

DA872:	; __________________XXXXX_
	; ______________XXXXXX____
	; _________XXXXXXXXX______
	; ___________XXXXX________
	; ___XXXXXX___XXXXX_______
	; XXXX______XX_XXXXXXXX___
	; _XXXXXXXXXXXXXXXXXXXXXX_
	; _____XXXXXXXXXXXXXXXX___
	; __________XXXXXXX_______
	; ________________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________

	HEX	00 00 00 00 1F F0 7F 07
	HEX	00 00 00 00 00 00 00 00
	HEX	00 03 7F 1F 8F 37 FF FF
	HEX	3F 00 00 00 00 00 00 00
	HEX	3E F0 C0 00 80 F8 FE F8
	HEX	80 00

DA89C:	; ________________________
	; ________________________
	; ___XXXXX________________
	; XXXX_X___XXXXXXX________
	; __XXXX___XXXXXXXX_______
	; __XXXXXXXX_XXXXXXXXX____
	; XX___XXXXXX__XXXX_XXX___
	; __________XXXX_XXX_X____
	; ________________XXXXXXX_
	; ________________________
	; ________________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________

	HEX	00 00 1F F4 3C 3F C7 00
	HEX	00 00 00 00 00 00 00 00
	HEX	00 00 00 7F 7F DF E7 3D
	HEX	00 00 00 00 00 00 00 00
	HEX	00 00 00 80 F0 B8 D0 FE
	HEX	00 00

DA8C6:	; X_______________________
	; _XXXXX__________________
	; __XX_XXX________________
	; XXXXXX______XXXXXX______
	; __X_XX____XXXXXXXXXXX___
	; _X___XXXXXXXXXXXXXXXXX__
	; _______XXXXX_XXXXXX_X___
	; _____________XXXXX______
	; ____________XXXXXXXXX___
	; ________________XXXXXXXX
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________

DA8C6:	HEX	80 7C 37 FC 2C 47 01 00
	HEX	00 00 00 00 00 00 00 00
	HEX	00 00 00
DA8D9:	HEX	0F 3F FF F7 07 0F 00 00
	HEX	00 00 00 00 00 00 00 00
DA8E9:	HEX	C0 F8 FC E8 C0 F8 FF

; ======================

LA8F0:	DEC	A
	PUSH	DE
	PUSH	HL
	CALL	LA8F9
	POP	HL
	POP	DE
	RET

LA8F9:	ADD	A,A
	LD	E,A
	LD	D,00H
	LD	HL,DA910
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	LD	C,(HL)
	INC	HL
	CALL	LBAF1
	LD	E,A
	LD	D,00H
	ADD	HL,DE
	LD	A,(HL)
	RET

; ======================

DA910:	DW	DA91E,DA927,DA944,DA97D,DA9C4,DA9FD,DAA1A

DA91E:	DB	NA91E-2
	HEX	01 02 04 08 10 20 40 80
NA91E	EQU	$-DA91E

DA927:	DB	NA927-2
	HEX	03 05 06 09 0A 0C 11 12
	HEX	14 18 21 22 24 28 30 41
	HEX	42 44 48 50 60 81 82 84
	HEX	88 90 A0 C0
NA927	EQU	$-DA927

DA944:	DB	NA944-2
	HEX	07 0B 0D 0E 13 15 16 19
	HEX	1A 1C 23 25 26 29 2A 2C
	HEX	31 32 34 38 43 45 46 49
	HEX	4A 4C 51 52 54 58 61 62
	HEX	64 68 70 83 85 86 89 8A
	HEX	8C 91 92 94 98 A1 A2 A4
	HEX	A8 B0 C1 C2 C4 C8 D0 E0
NA944	EQU	$-DA944

DA97D:	DB	NA97D-2
	HEX	0F 17 1B 1D 1E 27 2B 2D
	HEX	2E 33 35 36 39 3A 3C 47
	HEX	4B 4D 4E 53 55 56 59 5A
	HEX	5C 63 65 66 69 6A 6C 71
	HEX	72 74 78 87 8B 8D 8E 93
	HEX	95 96 99 9A 9C A3 A5 A6
	HEX	A9 AA AC B1 B2 B4 B8 C3
	HEX	C5 C6 C9 CA CC D1 D2 D4
	HEX	D8 E1 E2 E4 E8 F0
NA97D	EQU	$-DA97D

; 3FH should have been 37H?
DA9C4:	HEX	3F
	HEX	1F 2F 37 3B 3D 3E 4F 57
	HEX	5B 5D 5E 67 6B 6D 6E 73
	HEX	75 76 79 7A 7C 8F 97 9B
	HEX	9D 9E A7 AB AD AE B3 B5
	HEX	B6 B9 BA BC C7 CB CD CE
	HEX	D3 D5 D6 D9 DA DC E3 E5
	HEX	E6 E9 EA EC F1 F2 F4 F8

DA9FD:	DB	NA9FD-2
	HEX	3F 5F 6F 77 7B 7D 7E 9F
	HEX	AF B7 BB BD BE CF D7 DB
	HEX	DD DE E7 EB ED EE F3 F5
	HEX	F6 F9 FA FC
NA9FD	EQU	$-DA9FD

DAA1A:	DB	NAA1A-2
	HEX	7F BF DF EF F7 FB FD FE
NAA1A	EQU	$-DAA1A

; ======================

LAA23:	CP	87H
	RET	C
	CP	0E8H
	RET	NC
	LD	HL,D62B7
	BIT	0,(HL)
	RET	NZ
	BIT	5,(IX+00H)
	RET	NZ
	LD	A,(IY+01H)
	CP	27H
	JR	C,.AA3E
	CP	0E0H
	RET	C
.AA3E:	LD	A,(D61C2)		; get level
	CP	04H
	RET	C
	LD	(HL),01H
	INC	HL
	LD	(HL),00H
	INC	HL
	LD	(HL),06H
	PUSH	IY
	POP	BC
	PUSH	IX
	POP	DE
	INC	HL
	LD	(HL),C
	INC	HL
	LD	(HL),B
	INC	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	LD	HL,D6068
	LD	(HL),95H
	INC	HL
	LD	A,(IY+01H)
	LD	(HL),A
	INC	HL
	LD	(HL),74H
	INC	HL
	LD	(HL),06H
	LD	HL,D606E
	LD	(HL),78H
	INC	HL
	LD	(HL),0BH
	LD	DE,DABF1
LAA75:	LD	HL,3BA0H
	LD	A,20H
	JP	LB6B8

; ======================

LAA7D:	PUSH	AF
	ADD	A,A
	LD	E,A
	LD	D,00H
	LD	HL,DAA9B
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	CALL	LAA75
	POP	AF
	CP	05H
	RET	C
	LD	DE,DACB1
	LD	HL,3BC0H
	LD	A,20H
	JP	LB6B8

; ======================

DAA9B:	DW	DABF1,DAC11,DAC31,DAC51,DAC71,DAC91

; ======================

LAAA7:	LD	IX,D62B7
	BIT	0,(IX+00H)
	RET	Z
	LD	IY,D6068
	LD	A,(IY+03H)
	AND	0FH
	CP	06H
	LD	C,06H
	JR	NZ,.AAC1
	LD	C,0CH
.AAC1:	LD	(IY+03H),C
	BIT	1,(IX+00H)
	JR	NZ,.AADC
	LD	H,(IX+06H)
	LD	L,(IX+05H)
	BIT	5,(HL)
	JP	NZ,.AB89
	LD	A,(IX+01H)
	CP	04H
	JR	NC,.AB0D
.AADC:	DEC	(IX+02H)
	JP	NZ,LABB1
	LD	(IX+02H),06H
	BIT	1,(IX+00H)
	LD	A,(IX+01H)
	JR	NZ,.AAF9
	INC	A
	LD	(IX+01H),A
	CALL	LAA7D
	JP	LABB1

.AAF9:	AND	A
	JR	NZ,.AB03
.AAFC:	LD	(IX+00H),00H
	JP	LBB7B

.AB03:	DEC	A
	LD	(IX+01H),A
	CALL	LAA7D
	JP	LABB1

.AB0D:	LD	L,(IX+03H)
	LD	H,(IX+04H)
	JR	NZ,.AB7F
	LD	A,(IX+02H)
	AND	A
	JR	Z,.AB21
	DEC	(IX+02H)
	JP	LABB1

.AB21:	LD	A,(HL)
	CP	84H
	JR	NC,.AB3D
	LD	(IX+02H),06H
	SET	1,(IX+00H)
	INC	HL
	INC	HL
	INC	HL
	BIT	7,(HL)
	RET	Z
	SET	7,(IY+03H)
	SET	7,(IY+07H)
	RET

.AB3D:	ADD	A,0BH
	LD	B,(IY+00H)
	CP	B
	JR	NZ,.AB73
	LD	H,(IX+04H)
	LD	L,(IX+03H)
	INC	HL
	LD	A,(HL)
	INC	HL
	INC	HL
	BIT	7,(HL)
	JR	Z,.AB57
	CP	15H
	JR	C,LABB1
.AB57:	LD	A,05H
	LD	(IX+01H),A
	CALL	LAA7D
	LD	L,(IX+05H)
	LD	H,(IX+06H)
	LD	DE,0003H
	ADD	HL,DE
	LD	(HL),00H
	LD	DE,001BH
	ADD	HL,DE
	SET	2,(HL)
	JR	LABB1

.AB73:	JR	NC,.AB7A
	DEC	(IY+00H)
	JR	LABB1

.AB7A:	INC	(IY+00H)
	JR	LABB1

.AB7F:	LD	A,(HL)
	ADD	A,0BH
	LD	(IY+00H),A
	CP	84H
	JR	NC,.AB8E
.AB89:	CALL	LAB98
	JR	LABB1

.AB8E:	CP	0ACH
	JR	C,LABB1
	CALL	LAB98
	JP	.AAFC

; ======================

LAB98:	LD	(IX+02H),01H
	SET	1,(IX+00H)
	LD	L,(IX+05H)
	LD	H,(IX+06H)
	LD	DE,001EH
	ADD	HL,DE
	RES	2,(HL)
	LD	(IY+04H),0EFH
	RET

; ======================

LABB1:	LD	L,(IX+03H)
	LD	H,(IX+04H)
	INC	HL
	LD	A,(HL)
	INC	HL
	INC	HL
	BIT	7,(HL)
	JR	Z,.ABC9
	SET	7,(IY+03H)
	SET	7,(IY+07H)
	JR	.ABCD

.ABC9:	RES	7,(IY+07H)
.ABCD:	CP	27H
	JR	C,.ABD5
	CP	0E0H
	JR	C,LAB98
.ABD5:	LD	(IY+01H),A
	LD	A,(IX+01H)
	CP	05H
	JR	C,.ABEC
	LD	A,(IY+00H)
	LD	(IY+04H),A
	LD	A,(IY+01H)
	LD	(IY+05H),A
	RET

.ABEC:	LD	(IY+04H),0EFH
	RET

; ======================

	; lava flames

DABF1:	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; XXX_____________
	; _XXX____________
	; __XXX___________
	; ___XX___________
	; ____X___________
	; ____X___________

	HEX	00 00 00 00 00 00 00 00
	HEX	00 00 E0 70 38 18 08 08
	HEX	00 00 00 00 00 00 00 00
	HEX	00 00 00 00 00 00 00 00

DAC11:	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; _____X__________
	; _____X__________
	; ____XX__________
	; ___XXX__________
	; _XXXX___________
	; XXX_____________
	; XX______________
	; X_______________
	; X_______________

	HEX	00 00 00 00 00 00 00 04
	HEX	04 0C 1C 78 E0 C0 80 80
	HEX	00 00 00 00 00 00 00 00
	HEX	00 00 00 00 00 00 00 00

DAC31:	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ______X_X_______
	; ____X_X_X_______
	; ____X_X_XX______
	; ____X_X_XX______
	; ____XXXXX_______
	; ___XXXXX________
	; __XXXX__________
	; _XXX____________
	; X_______________

	HEX     00 00 00 00 00 00 00 02
	HEX     0A 0A 0A 0F 1F 3C 70 80
	HEX     00 00 00 00 00 00 00 80
	HEX     80 C0 C0 80 00 00 00 00

DAC51:	; ________________
	; ________________
	; ____X___X_______
	; ____X__XX_______
	; _X_XX__XX_XX____
	; _X__X_XXX_XX____
	; XX__XXXX_XXX____
	; XX_XXXXXXXX_____
	; XXXXXXXXXX______
	; _XXXXXXXX_______
	; __XXXXXX________
	; __XXXXX_________
	; __XXXX__________
	; __XXX___________
	; _XXX____________
	; XX______________

	HEX	00 00 08 09 59 4B CF DF
	HEX	FF 7F 3F 3E 3C 38 70 C0
	HEX	00 00 80 80 B0 B0 70 E0
	HEX	C0 80 00 00 00 00 00 00

DAC71:	; ________________
	; _____X__XX______
	; _____X__X_______
	; _X__XX_XX__XX___
	; XX__XX_XX_XX____
	; XX__XX_X_XX_____
	; XXX_XXXXXX__X___
	; _XXX_XXXX__XX___
	; _XXXX_XXXXXX____
	; _XXXX_XXXXX_____
	; __XXXXXXXX______
	; __XXXXXX________
	; _XXXXXX_________
	; _XXXXX__________
	; _XXXX___________
	; XX_X____________

	HEX	00 04 04 4D CD CD EF 77
	HEX	7B 7B 3F 3F 7E 7C 78 D0
	HEX	00 C0 80 98 B0 60 C8 98
	HEX	F0 E0 C0 00 00 00 00 00

DAC91:	; ______XXXX______
	; _____XXXXXX_____
	; ____XXX_________
	; ___XXX_XXXXX____
	; ___XX_X_________
	; ___XXX_XXXXX____
	; __XXXXX_________
	; _XXXXXXX_XX_____
	; _XXXX___________
	; XXXX____________
	; XXX_____________
	; _XXX____________
	; __XX____________
	; _XXX____________
	; XXXX____________
	; XXX_____________

	HEX	03 07 0E 1D 1A 1D 3E 7F
	HEX	78 F0 E0 70 30 70 F0 E0
	HEX	C0 E0 00 F0 00 F0 00 60
	HEX	00 00 00 00 00 00 00 00

DACB1:	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________________
	; ________X_______
	; _______XX_______
	; _______XXX______
	; _______X_XX_____
	; ______XX_X_X____
	; _____X_X________
	; ________________
	; ________________
	; ________________

	HEX	00 00 00 00 00 00 00 00
	HEX	01 01 01 03 05 00 00 00
	HEX	00 00 00 00 00 00 00 80
	HEX	80 C0 60 50 00 00 00 00

; ======================

LACD1:	LD	HL,DD078
	CALL	LAE93
	CALL	LADFD
	LD	DE,DC754
	LD	HL,3800H
	CALL	LAD24
	CALL	LAD43
	CALL	LBB80
	LD	HL,2000H
	LD	DE,2800H
	LD	BC,0800H
	CALL	LBD2C
	LD	HL,2000H
	LD	DE,3000H
	LD	BC,0800H
	CALL	LBD2C
	LD	IX,DADA1
LAD05:	LD	C,(IX+00H)
	LD	B,(IX+01H)
	LD	A,B
	OR	C
	RET	Z
	LD	L,(IX+02H)
	LD	H,(IX+03H)
	LD	E,(IX+04H)
	LD	D,(IX+05H)
	CALL	LBD02	; write DE to VRAM at HL, size BC
	LD	DE,0006H
	ADD	IX,DE
	JR	LAD05

; ======================

LAD24:	LD	A,(DE)
	AND	A
	RET	Z
	LD	C,A
	LD	B,00H
	INC	DE
	PUSH	HL
	PUSH	BC
	CALL	LBD02	; write DE to VRAM at HL, size BC
	POP	BC
	POP	HL
	ADD	HL,BC
	LD	A,(DE)
	LD	C,A
	LD	B,00H
	PUSH	DE
	PUSH	BC
	SUB	A
	CALL	LBE5B		; write A to VRAM at HL, length BC
	POP	BC
	ADD	HL,BC
	POP	DE
	INC	DE
	JR	LAD24

; ======================

LAD43:	LD	IX,DAD96
.AD47:	LD	A,(IX+00H)
	AND	A
	RET	Z
	LD	L,(IX+01H)
	LD	H,(IX+02H)
	LD	E,(IX+03H)
	LD	D,(IX+04H)
	LD	B,A
.AD59:	PUSH	BC
	LD	BC,0010H
	EX	DE,HL
	ADD	HL,BC
	EX	DE,HL
	CALL	LAD7C
	EX	DE,HL
	LD	BC,0FFE0H
	ADD	HL,BC
	EX	DE,HL
	CALL	LAD7C
	EX	DE,HL
	LD	BC,0010H
	ADD	HL,BC
	EX	DE,HL
	POP	BC
	DJNZ	.AD59
	LD	DE,0005H
	ADD	IX,DE
	JR	.AD47

; ======================

LAD7C:	LD	B,10H
.AD7E:	PUSH	BC
	CALL	LBD14
	INC	HL
	LD	B,08H
.AD85:	SRL	A
	RL	C
	DJNZ	.AD85
	EX	DE,HL
	LD	A,C
	CALL	LBD1F
	EX	DE,HL
	INC	DE
	POP	BC
	DJNZ	.AD7E
	RET

; ======================

DAD96:	DB	13H
	DW	3800H,3D80H
	DB	01H
	DW	3D60H,3FE0H
	DB	00H

DADA1:	DW	0030H,29D8H,DC34C
	DW	0038H,2A08H,DC37C
	DW	0040H,2A40H,DC3B4
	DW	00B0H,3108H,DC0EC
	DW	0018H,31B8H,DC19C
	DW	0010H,31D0H,DC1B4
	DW	0018H,31E0H,DC1C4
	DW	0018H,31F8H,DC1DC
	DW	0010H,3210H,DC1F4
	DW	0018H,3220H,DC204
	DW	00A8H,3238H,DC21C
DADE3:	DW	0038H,2A78H,DC3EC
	DW	0018H,21D8H,DC2C4
	DW	0020H,21F0H,DC2DC
	DW	0050H,2210H,DC2FC
	DW	0000H

; ======================

	; DCAD8 -> char 00-3C, text and dingbats
LADFD:	LD	HL,0000H*8
	LD	DE,DCAD8	; '0'-'9'
	LD	BC,NCAD8	; 3DH*8
	CALL	LBD02		; write to VRAM

	; DCD00 -> char 70-BF, walking birds
	LD	HL,0070H*8
	LD	DE,DCD00
	LD	BC,NCD00	; 50H*8
	CALL	LBD02		; write DE to VRAM at HL, size BC

	; DCC00 -> char 68-6F, eggs and waiting riders
	LD	HL,0068H*8
	LD	DE,DCCC0
	LD	BC,NCCC0	; 08H*8
	CALL	LBD02		; write DE to VRAM at HL, size BC

	; DCCF0 -> char 60/61, standing man
	LD	HL,0060H*8
	LD	DE,DCCF0
	LD	BC,NCCF0
	CALL	LBD02		; write to VRAM

	; DCCF0 -> char 62/63, standing man
	LD	HL,0062H*8
	LD	DE,DCCF0
	LD	BC,NCCF0
	CALL	LBD02		; write to VRAM

	; DCB28 -> char 64, lives counter man
	LD	HL,0064H*8
	LD	DE,DCB28
	LD	BC,0008H
	CALL	LBD02		; write DE to VRAM at HL, size BC

	LD	HL,0000H
	LD	DE,0800H
	LD	BC,0800H
	CALL	LBD2C

	LD	HL,0000H
	LD	DE,1000H
	LD	BC,0800H
	CALL	LBD2C

	; DC424 -> char 221-25B, platforms
	LD	HL,0221H*8
	LD	DE,DC424
	LD	BC,NC424	; 3BH*8 = 01D8
	CALL	LBD02		; write DE to VRAM at HL, size BC

	; DBF8C -> char 3B-4B, platforms
	LD	DE,DBF8C
	LD	HL,003BH*8
	LD	BC,NBF8C	; 11H*8
	CALL	LBD02		; write DE to VRAM at HL, size BC

	; DC014 -> char 138-152, platforms
	LD	DE,DC014
	LD	HL,013BH*8
	LD	BC,NC014	; 1BH*8 = 00D8
	JP	LBD02		; write DE to VRAM at HL, size BC

; ======================

LAE81:	LD	HL,DD080
	CALL	LAE93
	LD	HL,2000H
	LD	DE,DCFFF
	LD	BC,XCFFF-DCFFF
	JP	LBD02	; write DE to VRAM at HL, size BC

; ======================

LAE93:	CALL	LBE46
	CALL	LBC64
	LD	HL,D6001
	LD	DE,D6002
	LD	BC,D63CA-D6001
	LD	(HL),00H
	LDIR
	LD	HL,0000H
	SUB	A
	LD	BC,5000H
	CALL	LBE5B		; write A to VRAM at HL, length BC
	CALL	LADFD
	JP	LBC37

; ======================

LAEB6:	LD	A,(D61A0)
	LD	B,05H
	LD	HL,0100H
	CP	90H
	JR	Z,.AED6
	CP	11H
	JR	Z,.AED6
	DEC	B
	LD	HL,0120H
	CP	0A0H
	JR	Z,.AED6
	CP	21H
	JR	Z,.AED6
	DEC	B
	LD	HL,0140H
.AED6:	LD	(D61B5),HL
	LD	(D61B1),HL
	LD	(D61B3),HL
	LD	HL,D61A1
	LD	(HL),B
	INC	HL
	BIT	0,A
	JR	NZ,.AEEA
	LD	B,00H
.AEEA:	LD	(HL),B
	RET

; ======================

LAEEC:	LD	HL,1A80H
	LD	BC,0006H
	LD	A,0CH
	CALL	LBE5B		; write A to VRAM at HL, length BC
	LD	HL,1A9CH
	LD	BC,0004H
	LD	A,0CH
	CALL	LBE5B		; write A to VRAM at HL, length BC
	LD	HL,DAF20
.AF05:	LD	A,(HL)
	AND	A
	RET	Z
	LD	E,A
	INC	HL
	LD	D,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,(HL)
	INC	HL
	PUSH	HL
	EX	DE,HL
	CALL	LAF18
	POP	HL
	JR	.AF05

; ======================

LAF18:	CALL	LBD1F
	INC	A
	INC	HL
	DJNZ	LAF18
	RET

; ======================

DAF20:	DW	1A86H
	DB	16H,21H

	DW	1AA7H
	DB	03H,37H

	DW	1AB0H
	DB	02H,3AH

	DW	1AB8H
	DB	03H,3CH

	DW	1AC8H
	DB	03H,3FH

	DW	1AD0H
	DB	02H,42H

	DW	1AD7H
	DB	03H,44H

	DW	1AE6H
	DB	15H,47H

	DB	00H

; ======================

LAF41:	CALL	LBC37
	LD	HL,1AE0H
	LD	A,0DH
	LD	BC,0020H
	PUSH	BC
	CALL	LBE5B		; write A to VRAM at HL, length BC
	LD	HL,1AC0H
	POP	BC
	PUSH	BC
	LD	A,0EH
	CALL	LBE5B		; write A to VRAM at HL, length BC
	POP	BC
	LD	A,0FH
	LD	HL,1AA0H
	CALL	LBE5B		; write A to VRAM at HL, length BC
	CALL	LAEEC
	LD	HL,DD018
.AF69:	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	LD	A,E
	OR	D
	RET	Z
	EX	DE,HL
.AF71:	LD	A,(DE)
	AND	A
	JR	Z,.AF7C
	CALL	LBD1F
	INC	HL
	INC	DE
	JR	.AF71

.AF7C:	INC	DE
	EX	DE,HL
	JR	.AF69

; ======================

LAF80:	LD	HL,1AAFH
	SUB	A
	CALL	LBD1F
	LD	A,(D61A0)
	BIT	0,A
	JR	NZ,.AF99
	LD	HL,1AB2H
	LD	A,20H
	LD	BC,0006H
	JP	LBE5B		; write A to VRAM at HL, length BC

.AF99:	LD	HL,1AB7H
	LD	A,00H
	JP	LBD1F

; ======================

LAFA1:	LD	HL,1ACBH
	LD	A,(D61A1)
	LD	E,0AH
	CALL	LAFB4
	LD	HL,1AD2H
	LD	A,(D61A2)
	LD	E,64H
LAFB4:	DEC	A
	CP	0FFH
	JR	NZ,.AFBA
	SUB	A
.AFBA:	CP	06H
	JR	C,.AFC0
	LD	A,05H
.AFC0:	LD	B,A
	LD	C,05H
	AND	A
	JR	Z,.AFCE
	LD	A,E
.AFC7:	CALL	LBD1F
	INC	HL
	DEC	C
	DJNZ	.AFC7
.AFCE:	LD	B,C
	LD	A,C
	AND	A
	RET	Z
	CP	06H
	RET	NC
	LD	A,0BH
.AFD7:	CALL	LBD1F
	INC	HL
	DJNZ	.AFD7
	RET

; ======================

LAFDE:	LD	B,08H
	LD	HL,DB037
	LD	DE,D6090
.AFE6:	PUSH	BC
	PUSH	HL
	LD	BC,0022H
	LDIR
	POP	HL
	POP	BC
	DJNZ	.AFE6
	LD	B,08H
	LD	IX,D6090
	LD	A,0C0H
	LD	HL,D6020
.AFFC:	LD	(IX+10H),A
	LD	(IX+11H),A
	LD	(IX+1DH),H
	LD	(IX+1CH),L
	ADD	A,08H
	LD	DE,0022H
	ADD	IX,DE
	LD	DE,0004H
	ADD	HL,DE
	DJNZ	.AFFC
	LD	HL,D6090
	SET	0,(HL)
	LD	HL,D6023
	LD	(HL),04H
	LD	A,(D61A0)
	BIT	0,A
	JR	Z,.B031
	LD	HL,D60B2
	SET	0,(HL)
	LD	HL,D6027
	LD	(HL),0BH
	RET

.B031:	LD	A,0EFH
	LD	(D6024),A
	RET

; ======================

; Initialization data copied to D6090
DB037:	HEX	00 00 00 00 00 01 00 00
	HEX	00 01 09 01 00 00 00 00
	HEX	00 00 01 01 00 00 00 00
	HEX	00 00 00 00 00 00 00 01
	HEX	01 FF

; ======================

LB059:	LD	A,(D61C2)		; get level
	CP	03H
	RET	C
	LD	IX,D61E4
	JP	NZ,.B131
	BIT	0,(IX+00H)
	RET	Z
	DEC	(IX+01H)
	RET	NZ
	LD	(IX+01H),06H
	LD	IY,D6080
	DEC	(IX+02H)
	JP	NZ,.B165
	LD	(IX+02H),05H
	LD	A,(IY+01H)
	CP	2DH
	JP	Z,.B117
	PUSH	IY
	POP	HL
	INC	HL
	LD	DE,0004H
	INC	(HL)
	ADD	HL,DE
	INC	(HL)
	CP	09H
	JR	C,.B09B
	ADD	HL,DE
	DEC	(HL)
	ADD	HL,DE
	DEC	(HL)
.B09B:	LD	HL,D6081
	LD	A,(HL)
	BIT	0,A
	JP	NZ,.B165
	ADD	A,04H
	AND	07H
	JR	NZ,.B0CD
	LD	A,(IX+03H)
	INC	(IX+03H)
	LD	B,A
	LD	HL,1A80H
	ADD	A,L
	LD	L,A
	LD	A,01H
	CALL	L9322
	LD	A,B
	SUB	02H
	JP	C,.B165
	LD	HL,1A9FH
	LD	B,A
	LD	A,L
	SUB	B
	LD	L,A
	LD	A,01H
	JP	L9322

.B0CD:	CP	02H
	JR	NZ,.B0F4
	LD	A,(IX+03H)
	LD	B,A
	LD	HL,1A80H
	ADD	A,L
	LD	L,A
	LD	C,1CH
	LD	A,01H
	CALL	L9262
	LD	A,B
	SUB	02H
	JR	C,.B0F4
	LD	HL,1A9FH
	LD	B,A
	LD	A,L
	SUB	B
	LD	L,A
	LD	C,1BH
	LD	A,01H
	CALL	L9262
.B0F4:	LD	A,(D6081)
	ADD	A,04H
	AND	07H
	SUB	02H
	LD	E,A
	LD	D,00H
	LD	HL,DB186
	ADD	HL,DE
	LD	A,(HL)
	INC	HL
	PUSH	HL
	LD	HL,10E0H
	CALL	LB18C
	POP	HL
	LD	A,(HL)
	LD	HL,10D8H
	CALL	LB18C
	JR	.B165

.B117:	LD	A,(IY+00H)
	CP	0ACH
	JR	NZ,.B123
	RES	0,(IX+00H)
	RET

.B123:	PUSH	IY
	POP	HL
	LD	B,04H
	LD	DE,0004H
.B12B:	INC	(HL)
	ADD	HL,DE
	DJNZ	.B12B
	JR	.B165

.B131:	DEC	(IX+01H)
	RET	NZ
	LD	IY,D6080
	LD	(IX+01H),06H
	BIT	1,(IX+00H)
	JR	Z,.B165
	DEC	(IX+02H)
	JR	NZ,.B165
	LD	(IX+02H),05H
	LD	A,(IY+00H)
	CP	9CH
	JR	NZ,.B159
	RES	1,(IX+00H)
	JR	.B165

.B159:	PUSH	IY
	POP	HL
	LD	B,04H
	LD	DE,0004H
.B161:	DEC	(HL)
	ADD	HL,DE
	DJNZ	.B161
.B165:	LD	A,(IY+02H)
	CP	64H
	JR	NZ,.B16E
	LD	A,44H
.B16E:	ADD	A,08H
	PUSH	IY
	POP	HL
	INC	HL
	INC	HL
	LD	DE,0004H
	LD	(HL),A
	ADD	HL,DE
	ADD	A,04H
	LD	(HL),A
	ADD	HL,DE
	SUB	04H
	LD	(HL),A
	ADD	HL,DE
	ADD	A,04H
	LD	(HL),A
	RET

; ======================

DB186:	HEX	3F FC 0F F0 03 C0

; ======================

LB18C:	EX	DE,HL
	LD	HL,(D61D2)
	LD	(HL),03H
	INC	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	LD	(HL),A
	INC	HL
	LD	(HL),A
	INC	HL
	LD	(HL),A
	INC	HL
	LD	(D61D2),HL
	RET

; ======================

LB1A1:	CALL	LB2FE
	LD	HL,D61D9
	BIT	1,(HL)
	JP	NZ,LB2C3
	BIT	0,(HL)
	JP	NZ,LB270
	LD	HL,(D61D7)
	LD	A,(D61C2)	; get level
	DEC	A
	JR	Z,.B1F8		; branch if level = 1
	DEC	A
	JR	Z,.B210		; branch if level = 2
	LD	A,H
	CP	01H
	JR	NZ,.B1E7
	LD	HL,D61D9
	SET	0,(HL)
	LD	HL,D61E4
	SET	0,(HL)
	INC	HL
	LD	(HL),01H
	INC	HL
	LD	(HL),01H
	LD	DE,D6080
	LD	HL,DB4EC
	LD	BC,0010H
	LDIR
	LD	A,01H
	LD	HL,1A80H
	LD	C,1CH
	JP	L9262

.B1E7:	LD	A,L
	AND	1FH
	RET	NZ
	LD	A,L
	LD	HL,DB265
	CP	80H
	JR	NC,.B22A
	LD	HL,DB25E
	JR	.B22A

; level = 1
.B1F8:	LD	A,H
	CP	01H
	JR	NZ,.B203
	LD	HL,D61D9
	SET	0,(HL)
	RET

.B203:	LD	A,L
	CP	80H
	RET	C
	AND	1FH
	RET	NZ
	LD	A,L
	LD	HL,DB257
	JR	.B22A

; level = 2
.B210:	LD	A,H
	CP	01H
	JR	NZ,.B21B
	LD	HL,D61D9
	SET	0,(HL)
	RET

.B21B:	LD	A,L
	AND	1FH
	RET	NZ
	LD	A,L
	LD	HL,DB25E
	CP	80H
	JR	NC,.B22A
	LD	HL,DB24C
.B22A:	RLCA
	RLCA
	RLCA
	ADD	A,04H
	AND	07H
	SUB	07H
	NEG
	AND	07H
	LD	C,A
.B238:	LD	A,(HL)
	AND	07H
	RET	NZ
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	EX	DE,HL
	LD	A,L
	ADD	A,C
	LD	L,A
	LD	A,0A6H
	CALL	LBD1F
	EX	DE,HL
	JR	.B238

; ======================

DB24C:	DW	3068H,3238H,32D8H,3240H,32D0H
	DB	07H

DB257:	DW	3068H,3238H,32D8H
	DB	07H

DB25E:	DW	3070H,31F8H,3230H
	DB	07H

DB265:	DW	3078H,31B8H,31C0H,31F0H,31E8H
	DB	07H

; ======================

LB270:	BIT	1,(HL)
	JR	NZ,LB2C3
	LD	A,(D61D7)
	SUB	0BH
	AND	03H
	RET	NZ
	CALL	LBAF9
	CP	30H
	RET	NC
	SET	1,(HL)
	LD	A,(D61C2)		; get level
	LD	HL,1AE1H
	LD	B,0DH
	DEC	A
	JR	Z,.B29A
	LD	HL,1AC1H
	INC	B
	DEC	A
	JR	Z,.B29A
	LD	HL,1AA1H
	INC	B
.B29A:	LD	C,09H
	CALL	LBAF1
	CP	05H
	JR	C,.B2A9
	LD	DE,001BH
	ADD	HL,DE
	SUB	05H
.B2A9:	ADD	A,L
	LD	L,A
	LD	IX,D61DA
	LD	(IX+04H),B
	LD	(IX+00H),L
	LD	(IX+01H),H
	LD	A,10H
	LD	(IX+03H),A
	LD	(IX+02H),06H
	JR	LB2F8

LB2C3:	LD	IX,D61DA
	DEC	(IX+02H)
	RET	NZ
	LD	L,(IX+00H)
	LD	H,(IX+01H)
	LD	(IX+02H),06H
	LD	A,(IX+03H)
	CP	15H
	JR	NZ,LB2F4
	LD	A,(D61D9)
	RES	1,A
	LD	(D61D9),A
	BIT	0,A
	JR	NZ,.B2EF
	LD	DE,0FFFFH
	LD	(D61D7),DE
.B2EF:	LD	A,(IX+04H)
	JR	LB2F8

LB2F4:	INC	A
	LD	(IX+03H),A
LB2F8:	LD	C,A
	LD	A,01H
	JP	L9262

; ======================

LB2FE:	LD	HL,D61D9
	BIT	2,(HL)
	JR	NZ,.B350
	BIT	0,(HL)
	RET	Z
	LD	A,(D61D7)
	AND	07H
	RET	NZ
	LD	A,(D61C2)		; get level
	DEC	A
	RET	Z
	LD	C,A
	CALL	LBAF9
	CP	30H
	RET	NC
	SET	2,(HL)
	DEC	C
	LD	HL,1AE1H
	JR	Z,.B329
	BIT	0,A
	JR	Z,.B329
	LD	HL,1AC1H
.B329:	LD	C,09H
.B32B:	SUB	C
	JR	NC,.B32B
	ADD	A,C
	CP	05H
	JR	C,.B339
	LD	DE,001BH
	ADD	HL,DE
	SUB	05H
.B339:	ADD	A,L
	LD	L,A
	LD	IX,D61DF
	LD	(IX+00H),L
	LD	(IX+01H),H
	LD	(IX+02H),04H
	LD	A,16H
	LD	(IX+03H),A
	JR	LB2F8

.B350:	LD	IX,D61DF
	DEC	(IX+02H)
	RET	NZ
	LD	H,(IX+01H)
	LD	L,(IX+00H)
	LD	A,(IX+03H)
	CP	1AH
	JR	NZ,.B371
	LD	A,(D61D9)
	RES	2,A
	LD	(D61D9),A
	LD	A,0DH
	JR	LB2F8

.B371:	LD	(IX+02H),04H
	INC	A
	LD	(IX+03H),A
	JP	LB2F8

; ======================

LB37C:	CALL	LB3B9
	LD	IX,D60B2
	LD	HL,D61A0
	SET	1,(HL)
	JR	LB3B9

; ======================

LB38A:	LD	HL,D61A0
	RES	1,(HL)
	LD	IX,D6090
	LD	A,0C0H
	LD	B,A
	AND	(HL)
	CP	B
	JR	Z,LB37C
	BIT	5,(IX+00H)
	JR	NZ,LB3D0
	BIT	6,(HL)
	JR	NZ,.B3A7
	CALL	LB3B9
.B3A7:	LD	IX,D60B2
	LD	HL,D61A0
	SET	1,(HL)
	BIT	5,(IX+00H)
	JR	NZ,LB3D0
	BIT	7,(HL)
	RET	NZ
LB3B9:	BIT	5,(IX+00H)
	JR	NZ,LB3D0
	CALL	LBE2F
	LD	(IX+04H),A
	CALL	LBE14
	CP	3FH
	RET	NZ
	SET	6,(IX+04H)
	RET

LB3D0:	LD	A,(D61D7)
	INC	A
	AND	03H
	RET	NZ
	LD	A,(IX+04H)
	BIT	7,(IX+00H)
	JR	NZ,.B3F2
	LD	H,(IX+0DH)
	BIT	7,H
	JR	NZ,.B3FC
	LD	L,(IX+0CH)
	LD	DE,0057H
	AND	A
	SBC	HL,DE
	JR	C,.B3FC
.B3F2:	SET	6,A
	LD	(IX+04H),A
	RES	6,(IX+08H)
	RET

.B3FC:	RES	6,A
	LD	(IX+04H),A
	RET

; ======================

LB402:	LD	B,(IX+00H)
	LD	C,(IX+04H)
	BIT	1,B
	JR	NZ,.B465
	BIT	7,B
	JR	NZ,.B444
	BIT	5,B
	JR	NZ,.B42C
	BIT	6,B
	JR	Z,.B422
	LD	A,08H
	BIT	6,C
	JR	Z,.B461
	LD	A,0CH
	JR	.B461

.B422:	LD	A,0B8H
	BIT	6,C
	JR	Z,.B461
	LD	A,0BCH
	JR	.B461

.B42C:	BIT	6,B
	JR	Z,.B43A
	LD	A,10H
	BIT	6,C
	JR	Z,.B461
	LD	A,14H
	JR	.B461

.B43A:	LD	A,0C0H
	BIT	6,C
	JR	Z,.B461
	LD	A,0C4H
	JR	.B461

.B444:	BIT	4,B
	JR	NZ,.B459
	LD	A,(IX+19H)
	CP	02H
	JR	C,.B459
	BIT	6,B
	LD	A,04H
	JR	NZ,.B461
	LD	A,0B4H
	JR	.B461

.B459:	LD	A,0B0H
	BIT	6,B
	JR	Z,.B461
	LD	A,00H
.B461:	LD	(IY+02H),A
	RET

.B465:	BIT	7,B
	JR	NZ,.B4A1
	BIT	5,B
	JR	NZ,.B487
	LD	A,(IX+0EH)
	AND	A
	JR	Z,.B47D
	LD	C,30H
	BIT	6,B
	JR	NZ,.B4BB
	LD	C,0E0H
	JR	.B4BB

.B47D:	LD	C,2CH
	BIT	6,B
	JR	NZ,.B4BB
	LD	C,0DCH
	JR	.B4BB

.B487:	LD	A,(IX+0EH)
	AND	A
	JR	Z,.B497
	LD	C,38H
	BIT	6,B
	JR	NZ,.B4BB
	LD	C,0E8H
	JR	.B4BB

.B497:	LD	C,34H
	BIT	6,B
	JR	NZ,.B4BB
	LD	C,0E4H
	JR	.B4BB

.B4A1:	BIT	4,B
	JR	NZ,.B4BF
	BIT	5,B
	JR	NZ,.B4C9
	BIT	6,B
	LD	HL,DB4E4
	JR	NZ,.B4B3
	LD	HL,DB4E8
.B4B3:	LD	A,(IX+19H)
	LD	E,A
	LD	D,00H
	ADD	HL,DE
	LD	C,(HL)
.B4BB:	LD	(IY+02H),C
	RET

.B4BF:	BIT	6,B
	LD	C,28H
	JR	NZ,.B4BB
	LD	C,0D8H
	JR	.B4BB

.B4C9:	BIT	6,B
	LD	HL,DB4DC
	JR	NZ,.B4D3
	LD	HL,DB4E0
.B4D3:	LD	E,(IX+19H)
	LD	D,00H
	ADD	HL,DE
	LD	C,(HL)
	JR	.B4BB

; ======================

DB4DC:	HEX	3C 40 44 48
DB4E0:	HEX	EC F0 F4 F8
DB4E4:	HEX	18 1C 20 24
DB4E8:	HEX	C8 CC D0 D4

; data copied to D6080
DB4EC:	HEX	9C 00 4C 06 9C 00 50 0A
	HEX	9C FF 4C 06 9C FF 50 0A
DB4FC:	HEX	AC 12 4C 06 AC 12 50 0A
	HEX	AC F0 4C 06 AC F0 50 0A

; ======================

; start a new level?
LB50C:	LD	A,(D61A0)	; D62C2 = D61A0
	LD	(D62C2),A
	LD	HL,0000H
	LD	(D61D7),HL	; D61D7 = 0x0000
	SUB	A
	LD	(D628D),A	; D628D = 0x00
	LD	A,0B4H
	LD	(D61CA),A	; D61CA = 0xB4
	LD	A,0FFH
	LD	(D60B1),A	; D60B1 = 0xFF
	LD	(D60D3),A	; D60B3 = 0xFF
	LD	A,(D61C2)	; increment level?
	INC	A
	LD	(D61C2),A
	CP	04H
	LD	HL,D61D9
	SET	0,(HL)
	JR	NC,.B53B	; branch if level > 4
	RES	0,(HL)		; set low bit of D61D9
.B53B:	CP	04H
	JR	NZ,.B555
	LD	DE,D6080
	LD	HL,DB4FC
	LD	BC,0010H
	LDIR
	LD	HL,D61E4
	SET	1,(HL)
	INC	HL
	LD	(HL),01H
	INC	HL
	LD	(HL),01H
.B555:	CP	32H		; branch if level < 50
	JR	C,.B55F
.B559:	SUB	0AH		; subtract 10 from level
	CP	32H
	JR	NC,.B559	; until level < 50
.B55F:	LD	HL,DB99A-7
	LD	DE,0007H	; cheesy method of DE = A * 7
	LD	B,A
.B566:	ADD	HL,DE
	DJNZ	.B566		; now HL points to 7 bytes of level info
	LD	A,(D61C7)	; D62AD = old D61C7
	LD	(D62AD),A
	LD	DE,D61C3	; copy level info to D61C3
	LD	BC,0007H	; copy 7 bytes
	LDIR
	LD	HL,1500H
	LD	A,(D61C2)	; get level
	SRL	A
	LD	C,A		; C = level / 2
	SRL	A		; A = level / 4
	CP	07H
	JR	NC,.B588	; branch if A < 7
	LD	A,06H		; cap A at 6
.B588:	NEG			; A = H - A
	ADD	A,H		; is the result ignored?
	LD	(D62B5),HL	; store 1500H in D62B5 (pteradactyl timer?)
	LD	A,C
	LD	HL,(D62BE)
	ADD	A,L
	LD	L,A
	LD	(D62C0),HL
	LD	A,(D61C3)
	LD	C,A
	INC	C
	LD	A,(D61A0)
	AND	0C0H
	JR	NZ,.B5A4
	INC	C
.B5A4:	LD	A,C
	LD	(D62C8),A
	CALL	LBC51
	CALL	L967F
	CALL	L93D4
	LD	A,(D61C7)
	BIT	3,A
	LD	HL,D61E8
	JR	NZ,.B5F6
	PUSH	AF
	LD	IX,D6090
	BIT	3,(IX+00H)
	JR	Z,.B5D6
	LD	IY,D6020
	LD	A,(IY+00H)
	CP	27H
	JR	NZ,.B5D6
	CALL	L834D
	JR	.B5EE

.B5D6:	LD	IX,D60B2
	BIT	3,(IX+00H)
	JR	Z,.B5EE
	LD	IY,D6024
	LD	A,(IY+00H)
	CP	27H
	JR	NZ,.B5EE
	CALL	L834D
.B5EE:	POP	AF
	LD	HL,D61E8
	SET	3,(HL)
	JR	.B5F8

.B5F6:	LD	(HL),00H
.B5F8:	CP	0FH
	CALL	NZ,LB888
	CALL	LB6F4
	LD	A,(D61C2)		; get level
	DEC	A
	JR	NZ,.B610		; branch if level != 1
	LD	HL,DD271 ; "PREPARE TO JOUST"
	LD	C,12H
	CALL	LB68F
	JR	.B63A

.B610:	LD	A,(D62A8)
	CP	03H
	JR	NZ,.B632
	LD	A,(D61C2)		; get level
	CP	03H
	JR	Z,.B632			; branch if level = 3
	LD	HL,DD248 ; "BEWARE OF THE"
	CALL	LB68D
	LD	HL,DD258 ; "UNBEATABLE PTERADACTYL"
	CALL	LB68D
	LD	HL,00B4H
	LD	(D62B5),HL
	JR	.B63A

.B632:	AND	A
	JR	Z,.B643
	JR	.B64B

.B637:	CALL	LB68D
.B63A:	CALL	L967F
	CALL	LBC4A
	JP	LBD48

.B643:	CALL	LB84D
	LD	HL,DD29D ; "EGG WAVE"
	JR	.B637

.B64B:	CP	02H
	JR	NZ,.B669
	LD	HL,D62C3
	LD	(HL),01H
	LD	HL,DD2A8 ; "SURVIVAL WAVE"
	LD	A,(D61A0)
	AND	0C0H
	JR	NZ,.B637
	LD	HL,DD1E2 ; "TEAM WAVE"
	CALL	LB68D
	LD	HL,DD1EE ; "BONUS AWARDED FOR TEAM PLAY"
	JR	.B637

.B669:	CP	04H
	JR	NZ,.B63A
	LD	A,(D61A0)
	AND	0C0H
	JR	NZ,.B63A
	SUB	A
	LD	(D62C3),A
	LD	HL,DD1A4 ; "GLADIATOR WAVE"
	CALL	LB68D
	LD	HL,DD1B5 ; "3000 POINT BOUNTY"
	CALL	LB68D
	LD	HL,DD1C9 ; "FOR DISMOUNTING PLAYER"
	JR	.B637

; ======================

LB689:	LD	C,06H
	JR	LB68F

LB68D:	LD	C,09H
LB68F:	PUSH	HL
	LD	HL,D628F
	LD	B,05H
.B695:	BIT	0,(HL)
	JR	Z,.B6A0
	LD	DE,0005H
	ADD	HL,DE
	DJNZ	.B695
	RET

.B6A0:	LD	(D61BD),HL
	LD	(HL),01H
	INC	HL
	LD	(HL),C
	INC	HL
	POP	DE
	LD	A,(DE)
	LD	(HL),A
	INC	HL
	INC	DE
	LD	C,A
	LD	A,(DE)
	LD	(HL),A
	LD	B,A
	INC	DE
	INC	HL
	LD	A,(DE)
	LD	(HL),A
	INC	DE
	PUSH	BC
	POP	HL
LB6B8:	PUSH	DE
	EX	DE,HL
	LD	HL,(D61D2)
	LD	(HL),A
	INC	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	POP	DE
	EX	DE,HL
	LD	B,00H
	LD	C,A
	LDIR
	LD	(D61D2),DE
	RET

; ======================

LB6CF:	LD	DE,DB6D4
	JR	LB6B8

DB6D4:	DB	"                                " ; 32 blanks

; ======================

LB6F4:	LD	A,(D61C2)		; get level
	DEC	A
	LD	C,09H
	JR	NZ,.B6FE		; branch if level != 1
	LD	C,12H
.B6FE:	LD	HL,DD293 ; "WAVE   "
	CALL	LB68F
	LD	HL,1931H
	LD	A,(D61C2)		; get level
	LD	C,0FFH
.B70C:	INC	C
	SUB	0AH
	JR	NC,.B70C
	ADD	A,0AH
	LD	B,A
	LD	A,C
	AND	A
	JR	Z,.B723
	LD	C,A
	LD	A,01H
	PUSH	HL
	PUSH	BC
	CALL	L9262
	POP	BC
	POP	HL
	INC	HL
.B723:	LD	A,B
	LD	C,A
	CP	05H
	JR	C,.B72B
	SUB	05H
.B72B:	LD	(D62A8),A
	LD	A,01H
	JP	L9262

; ======================

LB733:	LD	A,(D61D7)
	SUB	03H
	AND	0FH
	RET	NZ
	SUB	A
	LD	(D61BC),A
	LD	IX,D628F
	LD	B,05H
.B745:	PUSH	BC
	BIT	0,(IX+00H)
	JR	Z,.B794
	LD	A,(D61C2)		; get level
	DEC	A
	JR	NZ,.B76D
	LD	A,B
	CP	05H
	JR	NZ,.B76D
	LD	A,(IX+01H)
	CP	0AH
	JR	NZ,.B76D
	PUSH	IX
	CALL	L93D4
	POP	IX
	LD	HL,DD284 ; "BUZZARD BAIT"
	LD	C,0AH
	CALL	LB68F
.B76D:	DEC	(IX+01H)
	JR	NZ,.B794
	LD	L,(IX+02H)
	LD	H,(IX+03H)
	LD	A,(IX+04H)
	CALL	LB6CF
	RES	0,(IX+00H)
	BIT	6,(IX+00H)
	JP	NZ,L802A
	BIT	7,(IX+00H)
	JR	NZ,.B794
	LD	A,0FFH
	LD	(D61BC),A
.B794:	POP	BC
	LD	DE,0005H
	ADD	IX,DE
	DJNZ	.B745
	LD	A,(D61BC)
	AND	A
	RET	Z
	LD	A,(D61D8)
	CP	02H
	RET	C
	CALL	L967F
	JP	L816D

; ======================

LB7AD:	BIT	7,A
	JR	Z,.B7D7
	PUSH	AF
	LD	HL,D6074
	LD	A,E
	SUB	14H
	LD	(HL),A
	INC	HL
	LD	A,D
	SUB	08H
	JR	NC,.B7C2
	SUB	A
	JR	.B7C8

.B7C2:	CP	0F0H
	JR	C,.B7C8
	LD	A,0F0H
.B7C8:	LD	(HL),A
	INC	HL
	LD	(HL),9CH
	INC	HL
	LD	(HL),03H
	LD	A,04H
	LD	(D62C7),A
	POP	AF
	RES	7,A
.B7D7:	LD	HL,D6070
	LD	C,A
	LD	A,04H
	LD	(D62C6),A
	LD	A,E
	SUB	0EH
	LD	(HL),A
	INC	HL
	LD	A,D
	SUB	08H
	JR	NC,.B7ED
	SUB	A
	JR	.B7F3

.B7ED:	CP	0F0H
	JR	C,.B7F3
	LD	A,0F0H
.B7F3:	LD	(HL),A
	INC	HL
	LD	A,C
	ADD	A,A
	ADD	A,A
	LD	C,98H
	ADD	A,C
	LD	(HL),A
	INC	HL
	LD	(HL),0BH
	RET

; ======================

LB800:	LD	A,(D61D7)
	SUB	06H
	AND	1FH
	RET	NZ
	LD	A,0EFH
	LD	HL,D62C6
	DEC	(HL)
	JR	NZ,.B813
	LD	(D6070),A
.B813:	INC	HL
	DEC	(HL)
	RET	NZ
	LD	(D6074),A
	RET

; ======================

LB81A:	LD	IY,D61C7
	BIT	1,(IY+00H)
	LD	HL,DB87C
	CALL	Z,LB844
	LD	HL,DB87F
	BIT	2,(IY+00H)
	CALL	Z,LB844
	LD	HL,DB882
	BIT	3,(IY+00H)
	CALL	Z,LB844
	LD	HL,DB885
	BIT	0,(IY+00H)
	RET	NZ
LB844:	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	LD	A,(HL)
	EX	DE,HL
	JP	LB6CF

; ======================

LB84D:	LD	HL,DD018
	LD	A,03H
	CALL	LB874
	LD	A,04H
	LD	HL,DD01E
	CALL	LB874
	LD	A,0AH
	LD	HL,DD025
	CALL	LB874
	LD	A,07H
	LD	HL,DD04F
	CALL	LB874
	LD	IX,DADE3
	JP	LAD05

; ======================

LB874:	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	EX	DE,HL
	JP	LB6B8

; ======================

DB87C:	DW	18C0H
	DB	03H

DB87F:	DW	18DCH
	DB	04H

DB882:	DW	18EAH
	DB	0AH

DB885:	DW	19ECH
	DB	07H

; ======================

LB888:	LD	HL,D62AA
	SET	0,(HL)
	INC	HL
	LD	(HL),00H
	INC	HL
	LD	(HL),00H
	LD	A,(D62AD)
	LD	B,A
	LD	A,(D61C7)
	LD	C,A
	XOR	B
	CPL
	OR	C
	LD	(D62AD),A
	RET

; ======================

DB8A2:	HEX	0F 0E 0E 0B 0B 0A 03 09
	HEX	0A 04 0C 01 07 0D 08 09
	HEX	04 01 05 06 02 0C 06 02
	HEX	01 01 0C 04 04 01 0C 04
	HEX	01 01 01 01 01 01 04 01
	HEX	01 01 01 01 01 01 01 01

DB8D2:	DW	21D8H
	DB	18H
	DW	DC2C4

DB8D7:	DW	21F0H
	DB	20H
	DW	DC2DC

DB8DC:	DW	2210H
	DB	50H
	DW	DC2FC

DB8E1:	DW	2A78H
	DB	38H
	DW	DC3EC

; ======================

LB8E6:	LD	HL,D62AA
	BIT	0,(HL)
	RET	Z
	INC	HL
	DEC	(HL)
	JR	NZ,.B8F9
	DEC	HL
	RES	0,(HL)
	CALL	LB81A
	JP	LBD48

.B8F9:	LD	IX,D62AD
	INC	HL
	LD	A,(HL)
	INC	A
	CP	06H
	JR	NZ,.B905
	SUB	A
.B905:	LD	(HL),A
	LD	C,A
	LD	HL,DB8D2
	BIT	1,(IX+00H)
	CALL	Z,LB930
	LD	HL,DB8D7
	BIT	2,(IX+00H)
	CALL	Z,LB930
	LD	HL,DB8DC
	BIT	3,(IX+00H)
	CALL	Z,LB930
	LD	HL,DB8E1
	BIT	0,(IX+00H)
	CALL	Z,LB930
	RET

; ======================

LB930:	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,(HL)
	INC	HL
	LD	H,(HL)
	LD	L,A
	LD	A,B
	SUB	C
	LD	B,A
	PUSH	BC
	LD	B,00H
	ADD	HL,BC
	EX	DE,HL
	ADD	HL,BC
	POP	BC
	EX	DE,HL
.B945:	PUSH	BC
	LD	B,(HL)
	LD	A,B
	AND	0FH
	CP	01H
	CALL	NZ,LB97E
	LD	C,A
	LD	A,B
	AND	0F0H
	CP	10H
	LD	A,01H
	CALL	NZ,LB97E
	SLA	A
	SLA	A
	SLA	A
	SLA	A
	OR	C
	PUSH	DE
	EXX
	POP	HL
	LD	C,A
	LD	A,01H
	CALL	L9262
	EXX
	LD	C,05H
	LD	B,00H
	ADD	HL,BC
	EX	DE,HL
	ADD	HL,BC
	EX	DE,HL
	POP	BC
	LD	A,B
	SUB	05H
	LD	B,A
	RET	Z
	RET	C
	JR	.B945

; ======================

LB97E:	LD	A,(D62AB)
	NEG
	RRCA
	RRCA
	RRCA
	AND	1FH
	EXX
	LD	HL,DB8A2
	LD	E,A
	CALL	LBAF9
	AND	0FH
	ADD	A,E
	LD	E,A
	LD	D,00H
	ADD	HL,DE
	LD	A,(HL)
	EXX
	RET

; ======================

; Note: if level = 0, the values used will be
;               5F 16 00 19 7E D9 C9

; level specs
; copied to  D61C3 C4 C5 C6 C7 C8 C9   level
DB99A:	HEX	03 03 00 00 0F 01 04 ; 01  1 
	HEX	04 04 00 00 0F 01 04 ; 02  2 
	HEX	06 06 00 00 0F 02 08 ; 03  3 
	HEX	06 04 02 00 0F 02 08 ; 04  4 
	HEX	00 00 00 00 0F 02 08 ; 05  5  egg wave
	HEX	06 03 03 00 07 02 08 ; 06  6 
	HEX	06 02 04 00 01 02 08 ; 07  7 
	HEX	06 02 04 00 01 02 08 ; 08  8 
	HEX	06 02 04 00 00 03 08 ; 09  9 
	HEX	00 00 00 00 0F 03 08 ; 0A 10  egg wave
	HEX	06 04 02 00 0F 03 08 ; 0B 11 
	HEX	06 03 03 00 0E 03 08 ; 0C 12 
	HEX	06 01 05 00 00 03 08 ; 0D 13 
	HEX	06 00 06 00 00 03 08 ; 0E 14 
	HEX	00 00 00 00 0F 03 08 ; 0F 15  egg wave
	HEX	06 03 02 01 0F 03 08 ; 10 16 
	HEX	06 02 03 01 0F 04 08 ; 11 17 
	HEX	06 02 03 01 0F 03 08 ; 12 18 
	HEX	06 02 02 02 0F 02 08 ; 13 19 
	HEX	00 00 00 00 0F 04 08 ; 14 20  egg wave
	HEX	06 01 03 02 09 03 08 ; 15 21 
	HEX	06 00 04 02 09 04 08 ; 16 22 
	HEX	06 00 04 02 08 04 08 ; 17 23 
	HEX	06 00 05 01 08 04 08 ; 18 24 
	HEX	00 00 00 00 0F 06 08 ; 19 25  egg wave
	HEX	06 00 00 06 08 05 08 ; 1A 26 
	HEX	06 00 01 05 00 04 08 ; 1B 27 
	HEX	06 00 01 05 00 05 08 ; 1C 28 
	HEX	06 00 00 06 00 06 08 ; 1D 29 
	HEX	00 00 00 00 0F 06 08 ; 1E 30  egg wave
	HEX	06 02 02 02 0F 06 08 ; 1F 31 
	HEX	06 01 02 03 0F 06 08 ; 20 32 
	HEX	06 00 02 04 0E 06 08 ; 21 33 
	HEX	06 00 01 05 0E 06 08 ; 22 34 
	HEX	00 00 00 00 0F 06 08 ; 23 35  egg wave
	HEX	06 06 00 00 07 06 08 ; 24 36 
	HEX	06 00 06 00 07 06 08 ; 25 37 
	HEX	06 00 00 06 06 06 08 ; 26 38 
	HEX	06 03 00 03 06 06 08 ; 27 39 
	HEX	00 00 00 00 0F 06 08 ; 28 40  egg wave
	HEX	06 01 01 04 09 06 08 ; 29 41 
	HEX	06 00 02 04 08 06 08 ; 2A 42 
	HEX	06 01 02 03 08 06 08 ; 2B 43 
	HEX	06 00 00 06 00 06 08 ; 2C 44 
	HEX	00 00 00 00 0F 06 08 ; 2D 45  egg wave
	HEX	06 00 01 05 0F 06 08 ; 2E 46 
	HEX	06 02 02 02 0F 06 08 ; 2F 47 
	HEX	06 01 01 04 0F 06 08 ; 30 48 
	HEX	06 00 00 06 0E 06 08 ; 31 49 

; ======================

LBAF1:	CALL	LBAF9
.BAF4:	SUB	C
	JR	NC,.BAF4
	ADD	A,C
	RET

; ======================

LBAF9:	PUSH	HL
	LD	HL,(D6006)
	LD	A,H
	RRCA
	RRCA
	XOR	H
	RRCA
	XOR	L
	RRCA
	RRCA
	RRCA
	RRCA
	XOR	L
	RRA
	ADC	HL,HL
	LD	A,R
	ADD	A,L
	LD	L,A
	LD	A,(D6021)
	ADD	A,L
	LD	L,A
	LD	(D6006),HL
	POP	HL
	RET

; ======================

LBB19:	LD	A,(D61D7)
	SUB	0CH
	AND	3FH
	RET	NZ
	LD	A,(D61A0)
	RES	1,A
	LD	HL,D61A9
	LD	BC,(D61B1)
	CALL	LBB61
	JR	C,.BB44
	LD	HL,D61A1
	INC	(HL)
	LD	HL,(D61B1)
	LD	DE,(D61B5)
	ADD	HL,DE
	LD	(D61B1),HL
	CALL	LAFA1
.BB44:	LD	BC,(D61B3)
	LD	HL,D61AC
	CALL	LBB61
	RET	C
	LD	HL,D61A2
	INC	(HL)
	LD	HL,(D61B3)
	LD	DE,(D61B5)
	ADD	HL,DE
	LD	(D61B3),HL
	JP	LAFA1

; ======================

LBB61:	SUB	A
	LD	E,(HL)
	DEC	HL
	LD	D,(HL)
	EX	DE,HL
	SBC	HL,BC
	RET

; ======================

LBB69:	LD	HL,2000H
	ADD	HL,DE
	LD	A,L
	OUT	(O_BF),A
	LD	A,H
	OR	40H
	OUT	(O_BF),A
	LD	A,C
.BB76:	OUT	(O_BE),A
	DJNZ	.BB76
	RET

; ======================

LBB7B:	LD	(IY+00H),0EFH
	RET

; ======================

LBB80:	LD	IX,DCF80
.BB84:	LD	L,(IX+00H)	; first word -> HL
	LD	H,(IX+01H)
	LD	A,L
	OR	H
	RET	Z		; end of list if zero
	LD	C,(IX+02H)	; second word -> BC
	LD	B,(IX+03H)
	LD	A,(IX+04H)	; fifth byte -> A
	CALL	LBE5B		; write A to VRAM at HL, length BC
	LD	DE,0005H	; point to next entry
	ADD	IX,DE
	JR	.BB84

; ======================

LBBA0:	LD	HL,1800H
	CALL	LBC37
	LD	HL,1888H
	LD	DE,DD096 ; " ONE PLAYER  "
	LD	BC,000DH
	CALL	LBD02	; write DE to VRAM at HL, size BC
	INC	HL
	INC	HL
	CALL	LBC2F
	LD	DE,DD0B0 ; "  EASY PLAY  STANDARD PLAY  HARD PLAY  "
	CALL	LBD02	; write DE to VRAM at HL, size BC
	LD	A,01H
	CALL	LBD1F
	CALL	LBC2F
	INC	HL
	INC	HL
	CALL	LBD02	; write DE to VRAM at HL, size BC
	DEC	HL
	DEC	HL
	LD	A,02H
	CALL	LBD1F
	CALL	LBC2F
	CALL	LBD02	; write DE to VRAM at HL, size BC
	LD	A,03H
	CALL	LBD1F
	LD	HL,1988H
	LD	DE,DD0A3 ; " TWO PLAYERS "
	LD	BC,000DH
	CALL	LBD02	; write DE to VRAM at HL, size BC
	INC	HL
	INC	HL
	CALL	LBC2F
	LD	DE,DD0B0
	CALL	LBD02	; write DE to VRAM at HL, size BC
	LD	A,04H
	CALL	LBD1F
	CALL	LBC2F
	INC	HL
	INC	HL
	CALL	LBD02	; write DE to VRAM at HL, size BC
	DEC	HL
	DEC	HL
	LD	A,05H
	CALL	LBD1F
	CALL	LBC2F
	CALL	LBD02	; write DE to VRAM at HL, size BC
	LD	A,06H
	CALL	LBD1F
	LD	HL,D6003
	INC	(HL)
	LD	A,(HL)
	CP	0EH
	JR	C,.BC1D
	SUB	A
	LD	(HL),A
.BC1D:	LD	HL,DD088
	LD	D,00H
	LD	E,A
	ADD	HL,DE
	LD	C,(HL)
	LD	B,08H
	LD	E,00H
	CALL	LBB69
	JP	LBC5D

; ======================

LBC2F:	LD	BC,0040H
	ADD	HL,BC
	LD	BC,000DH
	RET

; ======================

LBC37:	LD	HL,1800H
	LD	BC,0300H
	LD	A,20H
	CALL	LBE5B		; write A to VRAM at HL, length BC
	LD	HL,1B10H
	LD	A,0D0H
	JP	LBD1F

; ======================

LBC4A:	LD	A,(D6000)
	SET	5,A
	JR	LBC69

; ======================

LBC51:	CALL	LBC56
	IN	A,(I_BF)
LBC56:	LD	A,(D6000)
	RES	5,A
	JR	LBC69

; ======================

LBC5D:	LD	A,(D6000)
	SET	6,A
	JR	LBC69

; ======================

LBC64:	LD	A,(D6000)
	RES	6,A
LBC69:	LD	(D6000),A
	OUT	(O_BF),A
	LD	A,81H
	OUT	(O_BF),A
	RET

; ======================

LBC73:	LD	HL,0000H
	LD	A,E
	AND	0F8H
	LD	L,A
	SLA	L
	RL	H
	SLA	L
	RL	H
	LD	A,D
	AND	0F8H
	SRL	A
	SRL	A
	SRL	A
	ADD	A,L
	LD	L,A
	PUSH	DE
	LD	DE,1800H
	ADD	HL,DE
	POP	DE
	JP	LBD14

; ======================

LBC96:	LD	HL,D61A0
	BIT	1,(HL)
	JR	NZ,.BCA5
	LD	DE,D61AA
	LD	HL,1AAAH
	JR	.BCAB

.BCA5:	LD	DE,D61AD
	LD	HL,1AB2H
.BCAB:	LD	A,(DE)
	ADD	A,C
	DAA
	LD	(DE),A
	LD	(D61B0),A
	DEC	DE
	LD	A,(DE)
	ADC	A,B
	DAA
	LD	(DE),A
	LD	(D61AF),A
	DEC	DE
	LD	A,(DE)
	ADC	A,00H
	DAA
	LD	(DE),A
	LD	(D61AE),A
	PUSH	HL
	LD	HL,D61AE
	LD	C,00H
	LD	B,03H
	LD	DE,D61B7
.BCCE:	SUB	A
	RLD
	AND	A
	JR	NZ,.BCDF
	BIT	0,C
	JR	NZ,.BCDF
	LD	A,20H
	LD	(DE),A
	INC	DE
	SUB	A
	JR	.BCE3

.BCDF:	SET	0,C
	LD	(DE),A
	INC	DE
.BCE3:	RLD
	AND	A
	JR	NZ,.BCF2
	BIT	0,C
	JR	NZ,.BCF2
	LD	A,20H
	LD	(DE),A
	INC	DE
	JR	.BCF6

.BCF2:	SET	0,C
	LD	(DE),A
	INC	DE
.BCF6:	INC	HL
	DJNZ	.BCCE
	POP	HL
	LD	DE,D61B7
	LD	A,06H
	JP	LB6B8

; ======================

	; write DE to VRAM at HL, size BC

LBD02:	LD	A,L
	OUT	(O_BF),A
	LD	A,H
	OR	40H
	OUT	(O_BF),A
.BD0A:	LD	A,(DE)
	INC	DE
	OUT	(O_BE),A
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,.BD0A
	RET

; ======================

LBD14:	LD	A,L
	OUT	(O_BF),A
	LD	A,H
	OUT	(O_BF),A
	PUSH	BC
	POP	BC
	IN	A,(I_BE)
	RET

; ======================

LBD1F:	PUSH	AF
	LD	A,L
	OUT	(O_BF),A
	LD	A,H
	OR	40H
	OUT	(O_BF),A
	POP	AF
	OUT	(O_BE),A
	RET

; ======================

LBD2C:	CALL	LBD14
	EX	DE,HL
	CALL	LBD1F
	EX	DE,HL
	INC	DE
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,LBD2C
	RET

; ======================

LBD3C:	PUSH	AF
	LD	A,(D6004)
	INC	A
	LD	(D6004),A
	IN	A,(I_BF)
	POP	AF
	RET

; ======================

LBD48:	LD	A,(D6005)
	LD	B,A
	LD	A,(D6004)
	CP	B
	JR	Z,.BD5F
	LD	B,A
	LD	HL,1AAFH
	CALL	LBD14
	INC	A
	AND	07H
	CALL	LBD1F
.BD5F:	LD	A,(D6004)
	CP	B
	JR	Z,.BD5F
	LD	(D6005),A
	JP	LBEDB

; ======================

LBD6B:	LD	HL,1B10H
	LD	DE,D6020
	LD	B,08H
	CALL	L96AB		; write data at HL to VRAM at DE, length B
	LD	HL,D61D4
	BIT	0,(HL)
	JR	Z,.BD9F
	LD	HL,1B18H
	LD	DE,D6028
	LD	B,16H
.BD85:	PUSH	BC
	LD	A,(DE)
	CP	0EFH
	JR	Z,.BD96
	LD	B,04H
	CALL	L96AB		; write data at HL to VRAM at DE, length B
	LD	BC,0004H
	ADD	HL,BC
	JR	.BD9A

.BD96:	INC	DE
	INC	DE
	INC	DE
	INC	DE
.BD9A:	POP	BC
	DJNZ	.BD85
	JR	.BDC5

.BD9F:	LD	B,16H
	LD	HL,1B18H
	LD	DE,D607C
.BDA7:	PUSH	BC
	LD	A,(DE)
	CP	0EFH
	JR	Z,.BDBE
	LD	B,04H
	CALL	L96AB		; write data at HL to VRAM at DE, length B
	LD	BC,0004H
	ADD	HL,BC
	EX	DE,HL
	LD	BC,0FFF8H
	ADD	HL,BC
	EX	DE,HL
	JR	.BDC2

.BDBE:	DEC	DE
	DEC	DE
	DEC	DE
	DEC	DE
.BDC2:	POP	BC
	DJNZ	.BDA7
.BDC5:	LD	(D61CC),HL
	LD	A,(D61D7)
	AND	03H
	LD	HL,D6080
	LD	C,A
	SLA	A
	SLA	A
	LD	E,A
	LD	D,00H
	PUSH	DE
	ADD	HL,DE
	LD	A,04H
	SUB	C
	SLA	A
	SLA	A
	LD	B,A
	EX	DE,HL
	LD	HL,(D61CC)
	PUSH	BC
	CALL	L96AB		; write data at HL to VRAM at DE, length B
	POP	BC
	LD	C,B
	LD	B,00H
	ADD	HL,BC
	POP	BC
	LD	A,C
	AND	A
	RET	Z
	LD	B,C
	LD	DE,D6080
	CALL	L96AB		; write data at HL to VRAM at DE, length B
	LD	HL,(D61CC)
	LD	DE,0010H
	ADD	HL,DE
	LD	A,0D0H
	JP	LBD1F

; ======================

LBE06:	LD	HL,D6020
	LD	DE,D6021
	LD	(HL),0EFH
	LD	BC,0100H
	LDIR
	RET

; ======================

LBE14:	LD	A,80H
	OUT	(O_80),A
	NOP
	NOP
	LD	HL,D61A5
	LD	A,(D61A0)
	BIT	1,A
	JR	Z,.BE2B
	LD	HL,D62C9
	IN	A,(I_FF)
	JR	.BE2D

.BE2B:	IN	A,(I_FC)
.BE2D:	LD	(HL),A
	RET

; ======================

LBE2F:	LD	A,80H
	OUT	(O_C0),A
	NOP
	NOP
	LD	A,(D61A0)
	BIT	1,A
	JR	Z,.BE40
	IN	A,(I_FF)
	JR	.BE42

.BE40:	IN	A,(I_FC)
.BE42:	CPL
	AND	4FH
	RET

; ======================

LBE46:	INC	HL
	LD	A,(HL)
	LD	(D6000),A
	DEC	HL
	LD	B,08H
	LD	C,7FH
.BE50:	LD	A,(HL)
	OUT	(O_BF),A
	INC	C
	LD	A,C
	OUT	(O_BF),A
	INC	HL
	DJNZ	.BE50
	RET

; ======================

; write A to VRAM at HL, length BC
LBE5B:	LD	E,A		; save A in E
	LD	A,L		; HL -> VDP address
	OUT	(O_BF),A
	LD	A,H
	OR	40H
	OUT	(O_BF),A
.BE64:	LD	A,E		; restore A
	OUT	(O_BE),A	; A -> VDP data
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,.BE64
	LD	A,E		; restore A again
	RET

; ======================

LBE6E:	CALL	LBE73
	IN	A,(I_BF)
LBE73:	LD	A,(DD079)
	OUT	(O_BF),A
	LD	A,81H
	OUT	(O_BF),A
	RET

; ======================

DBE7D:	DB	00H,00H

; ======================

LBE7F:	LD	A,9FH
	OUT	(O_FF),A
	LD	A,0BFH
	OUT	(O_FF),A
	LD	A,0DFH
	OUT	(O_FF),A
	LD	A,0FFH
	OUT	(O_FF),A
	LD	B,18H
	LD	HL,D6008
	SUB	A
.BE95:	LD	(HL),A
	INC	HL
	DJNZ	.BE95
	RET

; ======================

LBE9A:	PUSH	AF
	RES	7,A
	ADD	A,A
	LD	E,A
	LD	D,00H
	LD	HL,DBE7D
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	A,(DE)
	ADD	A,A
	LD	B,A
	ADD	A,A
	ADD	A,B
	LD	C,A
	LD	B,00H
	LD	HL,D6008
	ADD	HL,BC
	LD	C,(HL)
	INC	HL
	POP	AF
	BIT	7,A
	JR	NZ,.BEC8
	LD	B,(HL)
	LD	A,B
	OR	C
	JR	Z,.BEC8
	PUSH	DE
	EX	DE,HL
	AND	A
	SBC	HL,BC
	EX	DE,HL
	POP	DE
	RET	NC
.BEC8:	INC	DE
	LD	A,(DE)
	INC	DE
	LD	(HL),D
	DEC	HL
	LD	(HL),E
	INC	HL
	INC	HL
	LD	(HL),A
	INC	HL
	LD	(HL),01H
	INC	HL
	LD	(HL),00H
	INC	HL
	LD	(HL),00H
	RET

; ======================

LBEDB:	LD	HL,D6008
	CALL	LBEF0
	LD	HL,D600E
	CALL	LBEF0
	LD	HL,D6014
	CALL	LBEF0
	LD	HL,D601A
LBEF0:	PUSH	HL
	POP	BC
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	A,D
	OR	E
	RET	Z
	INC	HL
	LD	A,(HL)
	INC	HL
	DEC	(HL)
	RET	NZ
	LD	(HL),A
	LD	A,(DE)
	BIT	7,A
	JR	Z,LBF35
	INC	DE
	CP	0E8H
	JR	NZ,.BF0D
	SUB	A
	LD	(BC),A
	INC	BC
	LD	(BC),A
	RET

.BF0D:	OUT	(0FFH),A
	AND	70H
	JR	Z,.BF1B
	CP	20H
	JR	Z,.BF1B
	CP	40H
	JR	NZ,LBF2F
.BF1B:	PUSH	BC
	POP	BC
	NOP
	LD	A,(DE)
	BIT	6,A
	RES	6,A
	OUT	(O_FF),A
	INC	DE
	JR	Z,LBF2F
	CALL	LBF2F
	LD	(HL),01H
	JR	LBF45

; ======================

LBF2F:	LD	A,E
	LD	(BC),A
	INC	BC
	LD	A,D
	LD	(BC),A
	RET

; ======================

LBF35:	BIT	6,A
	JR	NZ,LBF64
	AND	A
	JR	NZ,LBF4A
LBF3C:	INC	DE
	LD	A,(DE)
	LD	(BC),A
	INC	DE
	INC	BC
	LD	A,(DE)
	LD	(BC),A
LBF43:	LD	(HL),01H
LBF45:	DEC	BC
	PUSH	BC
	POP	HL
	JR	LBEF0

LBF4A:	INC	HL
	EX	AF,AF'
	LD	A,(HL)
	AND	A
	JR	NZ,.BF55
	EX	AF,AF'
	LD	(HL),A
	DEC	HL
	JR	LBF3C

.BF55:	DEC	A
	LD	(HL),A
	DEC	HL
	JR	NZ,LBF3C
	INC	DE
	INC	DE
LBF5C:	INC	DE
	LD	A,E
	LD	(BC),A
	INC	BC
	LD	A,D
	LD	(BC),A
	JR	LBF43

LBF64:	INC	HL
	INC	HL
	EX	AF,AF'
	LD	A,(HL)
	AND	A
	JR	NZ,.BF70
	EX	AF,AF'
	AND	1FH
	LD	(HL),A
	RET

.BF70:	DEC	A
	LD	(HL),A
	RET	NZ
	DEC	HL
	DEC	HL
	JR	LBF5C

; ======================

;BF77
	HEX	03 01 E0 FF E8 00 01 9F
	HEX	E8 00 01 9F E8 01 01 BF
	HEX	E8 02 01 DF E8

; ======================

DBF8C:	; DBF8C -> char 3B-4B, platforms

	; XXXXXXXXXXXXXXXXXXXXXXXX
	; XXX__XXXX___XXXX___XXXXX
	; ____XXXX________XXXXX___
	; XX__X____XX____XXXX_____
	; ____XXXXXX___XXXX_______
	; XXXXXXXXXX_XXXXX________
	; _______XXXXX____________
	; ________________________

	HEX	FF E7 0F C8 0F FF 01 00 ; 3B
	HEX	FF 8F 00 61 C7 DF F0 00 ; 3C
	HEX	FF 1F F8 E0 80 00 00 00 ; 3D

	; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
	; XXXX____XX____X___XXX__XXXXX____
	; ___XXXXXXXXXX________X_______XX_
	; ______XXXXXX_______XXXXXX___XX__
	; ________XXX____XX_XXXXX___XXXX__
	; ________XXXXXX__XXXXXX__XXXXX___
	; ____________________XXXXX____XXX
	; ________________________________
;BFA4
	HEX	FF F0 1F 03 00 00 00 00 ; 3E
	HEX	FF C2 F8 F0 E1 FC 00 00 ; 3F
	HEX	FF 39 04 1F BE FC 0F 00 ; 40
	HEX	FF F0 06 8C 3C F8 87 00 ; 41

;XXXXXXXXXXXXXX__XXXXXXXXXXXXXXXXXXXXXXXX__XXXXXXXX__XXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXX___XXXXXXX__XXXXXXXXXXXXXXXXXXXXXX__XXXXXXX__X______XXXXXX______XXXXXXXXXXX
;____XXXXXX__________XXXXXXXXXXXXXXXX__________________XXXX__XX______XXXXXXXX____
;_______XX______XXX____________________XXXX___________________XXXXXXXXX__XXX_____
;____________XX__X___________________XX__XXXXX________XXX___XXXXXXX____XXXXX_____
;_________XXXXXXX_XXXXXX_XX___XXXX__XXXX___XXXX__XXXXX____XXXXXXXXXXXXX__________
;_______________XXXXXXXXXX__XXXXXXXXXXXXXX__XXXXXXXXXXXXX________________________
;________________________XXXXXXXXXXXXXXXXXX______________________________________
;BFC4
	HEX	FF F8 0F 01 00 00 00 00 ; 42
	HEX	FC FE C0 81 0C 7F 01 00 ; 43
	HEX	FF 7F 0F C0 80 7E FF 00 ; 44
	HEX	FF FF FF 00 00 C7 9F FF ; 45
	HEX	FF FE F0 03 0C 9E FF FF ; 46
	HEX	3F 7F 00 C0 F8 3C 9F C0 ; 47
	HEX	CF 20 03 00 07 F8 FF 00 ; 48
	HEX	FF 7E CC 07 1F 7F 00 00 ; 49
	HEX	FF 07 0F FC C3 FC 00 00 ; 4A
	HEX	FF FF F0 E0 E0 00 00 00 ; 4B
NBF8C	EQU	$-DBF8C

; ======================

DC014:	; DC014 -> char 138-152, platforms

	;XXXXXXXXXXXXXX__XXXXXXXXXXXXXXXXXXXXXXXX__XXXXXX
	;XXX__XX_XXXXXXX__XXXXXXXXXXXXXXXXXXXXXX__XXXXXX_
	;__XXXXXX____X_______XXXXXXXXXXXXXXXX____XXX_X___
	;__XXXXXX_XXXXX__XX____________________XXXX______
	;____XXXX_____XXX_______________X______XXXXX_____
	;_____XXXXXX____XX________X____X____XX___X_______
	;_______XXXXXXX__XXXXX_XXXXXXXX___XXXXX__________
	;_______________XXXX__XXX_XXXXXXXXXXX____________

	HEX	FF E6 3F 3F 0F 07 01 00 ; 138
	HEX	FC FE 08 7C 07 E1 FC 01 ; 139
	HEX	FF 7F 0F C0 00 80 FB E7 ; 13A
	HEX	FF FF FF 00 01 42 FC 7F ; 13B
	HEX	FF FE F0 03 03 18 7C F0 ; 13C
	HEX	3F 7E E8 C0 E0 80 00 00 ; 13D

;XXXX___XXXXXXX__XXXXXXXXXXXXXXXXXXXXXXXX__XXXXXXXXXXXXXXXXXXXXXXXXXXX___X_______
;XXXXX___XXXXXXX__XXXXXXXXXXXXXXXXXXXXXX__XXXXXXX_____XXX___XXXXXXX___XXX________
;__XXXX__XX__________XXXXXXXXXXXXXXXX________XX__XXXX______________XXXXX_________
;___XX____XXXXX__XX____________________XX__XXX__XXX______________________________
;XXXXXXXXXXXXXXXXX_______________________XXXX____XX______________________________
;______________XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX__________________________________
;___________________XXXXXXXXXXXXXXXXXXXXXXX___XXX________________________________
;___________________________________XXXXXXXXXXXXX________________________________
;C044
	HEX	F1 F8 3C 18 FF 00 00 00 ; 13E
	HEX	FC FE C0 7C FF 03 00 00 ; 13F
	HEX	FF 7F 0F C0 80 FF 1F 00 ; 140
	HEX	FF FF FF 00 00 FF FF 00 ; 141
	HEX	FF FE F0 03 00 FF FF 1F ; 142
	HEX	3F 7F 0C 39 F0 FC C7 FF ; 143
	HEX	FF 07 F0 C0 C0 00 00 00 ; 144
	HEX	FF 1F 00 00 00 00 00 00 ; 145
	HEX	F8 C7 3E 00 00 00 00 00 ; 146
	HEX	80 00 00 00 00 00 00 00 ; 147

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX___XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXX___XXX_______XXXX___XXXX_____XXXX_____XXXXXXX___XXXXXX____XXXXXXXXX___XXXXXXX___XXXXX
;__XXXXXXXXX________XXX_________X____XXXX___XXXXXXX____XXXXXXXXXX________X_XXXX__XXXXXX__
;__XXXXXX__XXX__XX___XXXXXX____XX______XXXX______XXXXXXXXXXXXXXXXXXXXX_________XXXX______
;____XXXXXXXXXX____XXXXXXXXXX__XX_______XXXXX__XXXXX___X__XXX______XXXXXXXXX_____________
;_____XXXXXXXXX_XXXX______XXX_______________XXXXXX____X_XXXXXXXX_____XXXXXXXXXXX_________
;_____XXXXXXX__XX________________________________XXXXXXXXXXXXXXXXXXX_XX__________________
;________________________________________________________XXXXXXXXX_______________________
;C094
	HEX	FF E3 3F 3F 0F 07 07 00 ; 148
	HEX	FF 80 E0 39 FC FD F3 00 ; 149
	HEX	FF F1 1C 8F 3F E0 00 00 ; 14A
	HEX	FF E0 01 C3 F3 70 00 00 ; 14B
	HEX	FF F0 0F 03 01 00 00 00 ; 14C
	HEX	C7 7F 1F C0 F3 1F 00 00 ; 14D
	HEX	FF 1F C3 FF E2 85 FF 00 ; 14E
	HEX	FF 87 FF FF 70 FE FF FF ; 14F
	HEX	FF FC 00 F8 3F 0F EC 80 ; 150
	HEX	FF 7F BC 03 E0 FE 00 00 ; 151
	HEX	FF 1F FC C0 00 00 00 00 ; 152
NC014	EQU	$-DC014

; ======================

; color table stuff?

DC0EC:	HEX	E1 9E 69 61 61 61 61 11
	HEX	E9 9E 9E 9E 69 69 69 69
	HEX	E9 9E 69 69 69 69 69 69
	HEX	E9 9E 9E 69 69 69 A6 A1
	HEX	E9 9E 9E 9E 9E 9E 69 11
	HEX	9E 9E 9E 9E 9E 69 69 11
	HEX	91 91 9E 9E 9E 9E 69 11
	HEX	E1 E1 E1 91 69 69 69 11
	HEX	E1 E1 E1 11 69 69 69 11
	HEX	E1 E1 E1 91 69 69 69 11
	HEX	91 91 9E 9E 9E 69 69 61
	HEX	9E 9E 9E 9E 69 69 69 61
	HEX	9E 9E 9E 9E 9E 69 69 11
	HEX	9E 9E 9E 9E 9E 69 69 11
	HEX	9E 9E 9E 9E 6E 69 69 11
	HEX	9E 9E 6E 9E 9E 9E 69 11
	HEX	9E 9E 9E 9E 69 69 69 11
	HEX	9E 9E 9E 69 9E 69 69 11
	HEX	9E 9E 9E 9E 9E 69 69 61
	HEX	9E 9E 9E 9E 69 A6 A6 A6
	HEX	9E 9E 9E 9E 69 69 69 61
	HEX	9E 9E 9E 61 61 61 61 11
DC19C:	HEX	61 61 11 11 11 11 11 11
	HEX	69 A6 A1 A1 A1 A1 11 11
	HEX	A1 A1 A1 A1 A1 A1 A1 A1
DC1B4:	HEX	61 61 61 61 61 61 61 61
	HEX	61 61 61 61 61 61 61 61
DC1C4:	HEX	61 61 61 61 A1 A1 A1 A1
	HEX	A6 A6 A6 A1 A1 A1 A1 11
	HEX	A1 A1 11 11 11 11 11 11
DC1DC:	HEX	11 E1 A1 A1 A1 A6 A6 A6
	HEX	A6 A6 A6 A6 61 61 61 61
	HEX	A6 A6 61 61 61 91 91 91
DC1F4:	HEX	69 69 61 61 61 61 61 61
	HEX	69 69 61 61 61 61 61 61
DC204:	HEX	69 69 91 91 61 61 61 61
	HEX	A9 A9 A9 A9 A9 A9 69 69
	HEX	11 11 A1 A1 A1 A1 A1 A1
DC21C:	HEX	11 11 11 11 11 11 A1 A1
	HEX	E1 A1 A1 A1 A6 A6 A6 61
	HEX	A6 A6 61 61 61 61 61 61
	HEX	61 61 61 61 61 61 61 61
	HEX	91 69 69 69 69 69 69 61
	HEX	11 11 69 69 69 69 69 69
	HEX	11 11 69 69 69 69 69 61
	HEX	11 11 69 69 61 61 61 61
	HEX	11 11 69 69 69 61 61 61
	HEX	11 11 69 69 69 69 69 69
	HEX	61 61 61 61 61 61 61 61
	HEX	61 69 69 69 69 69 61 61
	HEX	11 11 69 69 69 69 69 69
	HEX	11 11 69 69 69 69 69 69
	HEX	11 11 69 69 69 69 69 69
	HEX	11 11 61 61 61 69 69 61
	HEX	11 11 69 69 61 61 61 61
	HEX	61 91 91 91 91 69 69 69
	HEX	A6 A6 61 61 61 61 61 61
	HEX	A1 A6 A6 A6 A6 A6 A6 61
	HEX	A1 A1 A1 A1 A1 A1 A1 A6
DC2C4:	HEX	E9 E9 E9 E9 69 69 61 11
	HEX	E9 E9 E9 69 69 69 61 11
	HEX	E9 6E 61 61 61 11 11 11
DC2DC:	HEX	E9 E9 61 61 61 61 11 11
	HEX	E9 E9 E9 6E 69 69 11 11
	HEX	E9 E9 69 69 69 69 61 11
	HEX	E9 E9 69 69 69 69 61 11
DC2FC:	HEX	E9 E9 61 61 11 11 11 11
	HEX	91 91 69 69 69 61 61 11
	HEX	E1 E1 E1 91 69 69 69 11
	HEX	E1 E1 E1 91 69 69 69 69
	HEX	E1 E1 E1 91 69 69 69 69
	HEX	91 91 69 69 69 69 69 91
	HEX	E9 E9 E9 69 69 69 61 11
	HEX	E9 E9 E9 E9 69 69 11 11
	HEX	E9 E9 69 69 69 61 11 11
	HEX	E9 91 61 91 61 11 11 11
DC34C:	HEX	E9 E9 91 91 61 61 61 11
	HEX	91 91 69 69 69 69 69 91
	HEX	E1 E1 E1 91 69 69 69 69
	HEX	E1 E1 E1 91 69 69 69 69
	HEX	E1 E1 E1 91 69 69 91 61
	HEX	E1 91 91 61 61 61 11 11
DC37C:	HEX	E9 E9 E9 E9 69 11 11 11
	HEX	E1 91 69 69 69 61 11 11
	HEX	E1 E1 E1 91 69 69 61 11
	HEX	E1 E1 E1 91 69 69 69 11
	HEX	E1 E1 E1 91 69 69 69 61
	HEX	E1 91 69 69 69 61 69 69
	HEX	E1 E9 61 61 61 11 11 11
DC3B4:	HEX	69 61 11 11 11 11 11 11
	HEX	69 69 61 11 11 11 11 11
	HEX	61 61 11 11 11 11 11 11
	HEX	E9 E9 91 91 91 61 61 11
	HEX	E9 E9 E9 69 69 69 69 11
	HEX	E9 E9 E9 6E 69 61 61 11
	HEX	E9 E9 69 69 69 61 11 11
DC3EC:	HEX	E9 9E 91 61 61 11 11 11
	HEX	E9 9E 9E 69 69 61 11 11
	HEX	E9 9E 9E 91 69 69 69 11
	HEX	E9 9E 9E 91 69 69 69 69
	HEX	E9 9E 69 69 69 69 61 61
	HEX	E9 9E 9E 69 91 61 11 11
	HEX	E9 9E 91 61 11 11 11 11

; ======================

DC424:	; platform graphics for character slots 01D8-0212

;XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX ______XX XXXXXX__ XXXXXXXX 01D8-01DF
;_____XXX XXXX___X XXXX____ ________ XX____XX XXXX____ XXXXXXX_ _XXXXXXX 
;XXXXXXX_ XX____XX ________ ______XX XXXX____ XXXXXX__ ___XXXXX ____XXXX 
;__XXXXXX XXX___XX ________ ________ XX__XXX_ __XXXXX_ XXXX_XXX XX______ 
;___XXXXX XX__X_X_ _______X XX______ XX_XXXXX __XXXXXX XXX__XXX ________ 
;______XX XXX_XX__ X_______ XXXXX___ __XXXXXX XXXXXX__ XXXXX___ ____XX__ 
;______XX XXXX_XXX _______X XX______ XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX 
;________ XXXXXXX_ XX____XX XXXXX___ ________ ________ ________ ________ 

	HEX	FF 07 FE 3F 1F 03 03 00
	HEX	FF F1 C3 E3 CA EC F7 FE
	HEX	FF F0 00 00 01 80 01 C3
	HEX	FF 00 03 00 C0 F8 C0 F8
	HEX	FF C3 F0 CE DF 3F FF 00
	HEX	03 F0 FC 3E 3F FC FF 00
	HEX	FC FE 1F F7 E7 F8 FF 00
	HEX	FF 7F 0F C0 00 0C FF 00

;XXXXXXXX XXXXXXXX __XXXXXX XX______ ________ ________ ________ ________ 01E0-01E7
;XXXXXXXX XXXXXXX_ _XXXXXXX ________ XX______ ______XX ________ ________ 
;XXXXXXXX XXXX____ XXXX___X ___XXXXX XXXX____ ___X_XXX XX_X_XX_ _____XX_ 
;________ ______XX XX____XX __XXXXXX XX___XXX XXXXX___ XXX_____ XXX_XXXX 
;_XX_____ ________ XX__XXXX _____XXX X_XX_XXX XXXX_XXX ____XXX_ _XXX___X 
;XXXXXXX_ __XXXXX_ _____XXX XX__XXX_ _______X XXXXXXXX XXXXX___ XXX__XXX 
;XXXXXXXX X_______ XXXXXXX_ ___XXXXX X____XXX XXXXXXXX XXXX_X__ XXXXXXXX 
;________ ________ ___XXXXX XXXXX___ ________ ________ ________ ________ 

	HEX	FF FF FF 00 60 FE FF 00
	HEX	FF FE F0 03 00 3E 80 00
	HEX	3F 7F F1 C3 CF 07 FE 1F
	HEX	C0 00 1F 3F 07 CE 1F F8
	HEX	00 C0 F0 C7 B7 01 87 00
	HEX	00 03 17 F8 F7 FF FF 00
	HEX	00 00 D6 E0 0E F8 F4 00
	HEX	00 00 06 EF 71 E7 FF 00

;________ ________ ________ ________ ________ ________ 01E8-01ED
;________ _______X X_______ _____XX_ ________ ________ 
;_______X XXXXXXXX XX______ XXXXXX__ XX_____X XXX_____ 
;XXXXXX__ ____XXXX __XX_XXX XXX___XX X___XXXX XXXXXXX_ 
;_____XXX XXXXXXX_ _XXXXXXX ____XXXX ____X___ XXXXXX__ 
;____XX__ __XX____ ___XXX__ _____XX_ XX__XXXX XXX_____ 
;XXXXXXXX XXX__XXX _____XXX ____XXX_ __XXXXXX XX______ 
;________ ________ ___XXXXX ____XXXX XXXXXXX_ ________ 

	HEX	00 00 01 FC 07 0C FF 00
	HEX	00 01 FF 0F FE 30 E7 00
	HEX	00 80 C0 37 7F 1C 07 1F
	HEX	00 06 FC E3 0F 06 0E 0F
	HEX	00 00 C1 8F 08 CF 3F FE
	HEX	00 00 E0 FE FC E0 C0 00

;__XXXXXX XXX_XXX_ XXX_____ _____XXX XXX_____ _____XXX _XX__XXX XX______ 01EE-01F5
;___XXXXX _____X_X XXX_____ _____XXX XXX_____ _____XXX __XXXXXX X_______ 
;________ ____XXXX X_______ _______X X_______ _______X _XX_XXXX ________ 
;________ _____XXX X_______ _______X X_______ _______X XXXXXXX_ ________ 
;________ _______X X_______ _______X X_______ _______X XXXX____ ________ 
;________ _______X XXX_____ _____XXX XXX_____ _____XXX X_______ ________ 
;________ ________ XXX_____ _____XXX XXX_____ _____XXX X_______ ________ 
;________ ________ XXXXX___ ___XXXXX XXXXX___ ___XXXXX ________ ________ 

	HEX	3F 1F 00 00 00 00 00 00
	HEX	EE 05 0F 07 01 01 00 00
	HEX	E0 E0 80 80 80 E0 E0 F8
	HEX	07 07 01 01 01 07 07 1F
	HEX	E0 E0 80 80 80 E0 E0 F8
	HEX	07 07 01 01 01 07 07 1F
	HEX	67 3F 6F FE F0 80 80 00
	HEX	C0 80 00 00 00 00 00 00

;________ XX__XX_X XXXX__XX XXXXXXXX XXXXXXXX __XXXX__ ___XX_XX ________ 01F6-01FD
;______XX XXXX__X_ XX______ XXXXXXXX XXXXXXXX ____XXXX __X__X_X ________ 
;______XX XX_XX___ XXXXXX__ __XXXXXX XXXXXX__ __XXXXXX ___X__XX XX______ 
;______XX _XX_____ XX_XXX__ __XXXXXX XXXXXX__ __XXXXXX ______X_ XX______ 
;___XXXXX XXXXXX__ X_XX____ ____XXX_ XXXX____ ____XXXX _____X_X XX______ 
;XXXXX_X_ XXXX__XX __XX____ ____XXXX __XX____ ____XXXX _______X XX______ 
;XXXXX_XX XXXX__XX XXXX____ ____XXX_ XXXX____ ____XXXX XX__X___ XXXX____ 
;XXXX_X__ XXXX_XXX XXXXXX__ __XXX___ XXXXXX__ __XXX_XX XXXX_X__ XXXX____ 

	HEX	00 03 03 03 1F FA FB F4
	HEX	CD F2 D8 60 FC F3 F3 F7
	HEX	F3 C0 FC DC B0 30 F0 FC
	HEX	FF FF 3F 3F 0E 0F 0E 38
	HEX	FF FF FC FC F0 30 F0 FC
	HEX	3C 0F 3F 3F 0F 0F 0F 3B
	HEX	1B 25 13 02 05 01 C8 F4
	HEX	00 00 C0 C0 C0 C0 F0 F0

;________ ______XX X_X_X___ XXX_XXXX XXXXXX__ ________ ________ ________ 01FE-0205
;________ ______XX _XX_____ ___XXXXX XXXX____ ________ ________ ________ 
;________ _____XXX XXXXXX__ ___XXXXX XX___XXX XXX_____ ________ _XXXXXXX 
;________ _XXXXXXX XXXXX___ ___XXXXX XX______ X_XXX___ ____X_XX XXXXX_XX 
;________ XXX__X__ XXX_____ ____XXXX X_______ ___XXXX_ _____XXX _XX_____ 
;________ X__XX___ XXX_____ ____XXXX X__XX_XX __XXXXXX XX_XXXXX XX____XX 
;_____XXX XX______ ______XX X__X____ XXXXX_X_ _X___XXX XXXXXXXX X____XXX 
;_____XXX XXXXXX__ _____XXX XXX_____ ___XXXXX XX_X__XX XXXXXX__ ________ 

	HEX	00 00 00 00 00 00 07 07
	HEX	03 03 07 7F E4 98 C0 FC
	HEX	A8 60 FC F8 E0 E0 03 07
	HEX	EF 1F 1F 1F 0F 0F 90 E0
	HEX	FC F0 C7 C0 80 9B FA 1F
	HEX	00 00 E0 B8 1E 3F 47 D3
	HEX	00 00 00 0B 07 DF FF FC
	HEX	00 00 7F FB 60 C3 87 00

;________ ________ __XXXX_X XXXXXX__ ________ ________ ________ ________ 0206-020D
;________ ________ XXXXX_XX XXXX_X_X ________ ________ ________ ________ 
;XXXXXX__ ___X_XXX XXXXX_XX XX__XXX_ _XXXX_X_ __X_____ ______XX XXXXXXXX 
;XXXX____ _X__XX_X XXX_X__X XXXXX_X_ XXX__X__ XX_XXX__ ________ XXX___XX 
;XX____XX _XXX__XX X_XX____ XXXXXX_X __XXX_XX _X__XXXX ________ XXXXXXX_ 
;XX___XXX XX_XXXXX X_XX____ XXXXXXX_ XX_XXX_X _XXX__X_ XXXX____ _X__XXXX 
;___XX_XX X_X__XXX XX__X___ __XXXXXX XXXXX_XX XXX__XX_ XXXXXXX_ X_XXXXXX 
;____XX__ XXXXXXXX ________ ____XXXX XXXXXXXX XXXXXXXX XXXXXXXX XXXXXX__ 

	HEX	00 00 FC F0 C3 C7 1B 0C
	HEX	00 00 17 4D 73 DF A7 FF
	HEX	3D FB FB E9 B0 B0 C8 00
	HEX	FC F5 CE FA FD FE 3F 0F
	HEX	00 00 7A E4 3B DD FB FF
	HEX	00 00 20 DC 4F 72 E6 FF
	HEX	00 00 03 00 00 F0 FE FF
	HEX	00 00 FF E3 FE 4F BF FC

;________ __X__XXX _______X XXXXXX__ ________ 020E-0212
;________ XXXXX___ ________ X__XXXXX ________ 
;XXX__XX_ XXXXX___ __X__XXX __X__XXX ________ 
;XXXXX__X XXXXXX__ ______X_ ____X_XX X_______ 
;___XXXXX XXXXXX_X ______XX ___X_XXX XX______ 
;X_____XX XX_X_X__ ________ _____X_X XXX_____ 
;_______X XXX_XX__ XX______ ______X_ XXXXX___ 
;________ XXXXX_XX XXX_____ __XXXXXX __XXXXXX 

	HEX	00 00 E6 F9 1F 83 01 00
	HEX	27 F8 F8 FC FD D4 EC FB
	HEX	01 00 27 02 03 00 C0 E0
	HEX	FC 9F 27 0B 17 05 02 3F
	HEX	00 00 00 80 C0 E0 F8 3F
NC424	EQU	$-DC424

; ======================

;C5FC
	HEX	00 00 00 00 00 00 00

; ======================

DC603:	HEX	E0 20 E0 60 F0 F0 E0 00
	HEX	00 00 00 00 00 00 00
DC612:	HEX	70 10 70 30 78 78 70 00
	HEX	00 00 00 00 00 00 00
DC621:	HEX	38 08 38 18 3C 3C 38 00
	HEX	00 00 00 00 00 00 00
DC630:	HEX	1C 04 1C 0C 1E 1E 1C 00
	HEX	00 00 00 00 00 00 00
DC63F:	HEX	0E 02 0E 06 0F 0F 0E 00
	HEX	00 00 00 00 00 00 00
DC64E:	HEX	07 01 07 03 07 07 07 00
	HEX	00 00 00 00 00 00 00 00
	HEX	00 00 00 00 80 80 00 00
	HEX	00 00 00 00 00 00 00
DC66D:	HEX	03 00 03 01 03 03 03 00
	HEX	00 00 00 00 00 00 00 00
	HEX	80 80 80 80 C0 C0 80 00
	HEX	00 00 00 00 00 00 00
DC68C:	HEX	01 00 01 00 01 01 01 00
	HEX	00 00 00 00 00 00 00 00
	HEX	C0 40 C0 C0 E0 E0 C0 00
	HEX	00 00 00 00 00 00 00
DC6AB:	HEX	07 04 07 06 0F 0F 07 00
	HEX	00 00 00 00 00 00 00
DC6BA:	HEX	03 02 03 03 07 07 03 00
	HEX	00 00 00 00 00 00 00 00
	HEX	80 00 80 00 80 80 80 00
	HEX	00 00 00 00 00 00 00
DC6D9:	HEX	01 01 01 01 03 03 01 00
	HEX	00 00 00 00 00 00 00 00
	HEX	C0 00 C0 80 C0 C0 C0 00
	HEX	00 00 00 00 00 00 00
DC6F8:	HEX	00 00 00 00 01 01 00 00
	HEX	00 00 00 00 00 00 00 00
	HEX	E0 80 E0 C0 E0 E0 E0 00
	HEX	00 00 00 00 00 00 00
DC717:	HEX	70 40 70 60 F0 F0 70 00
	HEX	00 00 00 00 00 00 00
DC726:	HEX	38 20 38 30 78 78 38 00
	HEX	00 00 00 00 00 00 00
DC735:	HEX	1C 10 1C 18 3C 3C 1C 00
	HEX	00 00 00 00 00 00 00
DC744:	HEX	0E 08 0E 0C 1E 1E 0E 00
	HEX	00 00 00 00 00 00 00 00

; ======================

; sprite image data copied to VRAM at 3800H - 3D7FH

;	3800 00			3820 04
;	___________XX___	________________
;	__________XX_X__	__________XX____
;	__________XX____	_________XX_X___
;	___________X____	_________XX_____
;	XX______XXXXXXX_	XX________X_____
;	XXXX____X_XX____	XXXX____XXXXXXX_
;	XXXXXXXXXXXX____	XXXXXXXXX_XX____
;	_XXXXXXXXXX_____	_XXXXXXXXXXX____
;	__XXXXXX________	__XXXXXXXXX_____
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________

;	3840 08			3860 0C
;	________________	____________XX__
;	XXX________XX___	___________XX_X_
;	XXXXX_____XX_X__	___________XX___
;	_XXXX_____XX____	____________X___
;	_XXXXX_____X____	______XXXXXXXXX_
;	__XXXXXXXXXXXXX_	____________X___
;	__XXXXX____X____	__XXX______XX___
;	__XXXXXX__XX____	XXX_XXXXXXXX____
;	XXXXXXXXXXX_____	_X_XX_XXXXX_____
;	_XXXXXXXXXX_____	__XX_XX_XX______
;	___XXXXXXX______	____XX_XXX______
;	_____XXXXX______	______XXX_______
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________

;	3880 10			38A0 14
;	XXX________XX___	____________XX__
;	XXXXX_____XX_X__	___________XX_X_
;	_XXXX_____XX____	___________XX___
;	_XXXXX_____XX___	____________XX__
;	__XXXXX____XX___	____________XX__
;	__XXXXX____XX___	____XXXX____XX__
;	__XXXXX___XX____	__XXXXXXX__XX___
;	XXXXXXXXXXX_____	XXX_XXXXXXXX____
;	_XXXXXXXXXX_____	_X_XX_XXXXX_____
;	___XXXXXXX______	__XX_XX_XX______
;	_____XXXXX______	____XX_XXX______
;	________________	______XXX_______
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________

;	38C0 18			38E0 1C
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	___XXX__XXXXXXX_	___XXX__XXXXXXX_
;	__XX_XX_________	__XX_XX___XX____
;	_XX_XXXX__XX____	_XX_XXXX_XXXXX__
;	XXXXXXX__XXXXX__	XXXXXXXX_XXXXX__
;	X__XXX_X_XXXXX__	X__X_XXX__X_XX__
;	_XX_XXXXX_X_XX__	_XX_XX__XXX_____
;	XX_X__X_XXX_____	__XXX____X______
;	__XX_XX__X______	___XXX__________
;	__X__X__________	___X_XX_________
;	__XX_XX_________	___X___X________
;	__X_X_XX________	___XXX__________
;	______X_X_______	____X_X_________

;	3900 20			3920 24
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	___XXX__XXXXXXX_	___XXX__XXXXXXX_
;	__XX_XX____XX___	__XX_XX_________
;	_XX_XXXX__XXXXX_	_XX_XXXX___XX___
;	XXXXXXX_X_XXXXX_	XXXXXXXX__XXXXX_
;	X__XXX_XX__X_XX_	X__XXXX_X_XXXXX_
;	_XXX_XX__XXX____	_XX_XX_XX__X_XX_
;	XX_XXX____X_____	___XXX__XXXX____
;	__XX_XX_________	__XX_XX___X_____
;	__X__XXXXX______	_XX___XX________
;	__XX____X_X_____	XX_____XX_______
;	___XX___________	_XX_____XX______
;	___X_X__________	_X_X____X_X_____

;	3940 28			3960 2C
;	________________	_XX_____________
;	_XXXXX____XX____	XXXX____________
;	XXXX_XXX_XXXX___	XX_XX___________
;	__XXXX_X__XXXXX_	XXX_XX__________
;	____XXXXX__X__X_	X_XX_XXXXXXXXXX_
;	XXXX_XXXXX__X___	XX_XX_X_________
;	XXXXXXXXX_XX____	_XX_X_XX___XX___
;	_XXXXXXXX_______	__X_XXXXX_XXXXX_
;	___XXXXX________	_XXX_XX_X__XXXX_
;	_____XX_X_______	XXXXXX_XXX_X_XX_
;	______XX_X______	_X_XXX___XX_____
;	_______XX_XX____	XXXX____________
;	________XX_XX___	________________
;	_________XX_XX__	________________
;	________________	________________
;	________________	________________

;	3980 30			39A0 34
;	________________	_XX_____________
;	________________	XXXX____________
;	________________	XX_XX___________
;	________________	XXX_XX__________
;	______XXXXXXXXX_	X_XX_XX_________
;	________________	XX_XX_X_________
;	__XXX_____XX____	_XX_X_XX___XX___
;	_XXXXXXX_XXXXX__	__X_XXXXX_XXXXX_
;	XXXXXXXXX_XXXX__	_XXX_XX_X__XXXX_
;	XXXXXXXXX_X_XX__	XXXXXX_XXX_X_XX_
;	_XXX_XXXXX______	_X_XXX___XX_____
;	XXXXX_XX_X______	XXXX____________
;	____XX_XX_X_____	________________
;	_____XXXXX_X____	________________
;	________XXXXX___	________________
;	________________	________________

;	39C0 38			39E0 3C
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	___________XX___
;	________________	___XXX____XXXXX_
;	________________	__XX_XX___XXXXX_
;	__XXX_____XX____	_XX_XXXX___X_XX_
;	_XXXXXXX_XXXXX__	XXXXXXX_X__X____
;	XXXXXXXXX_XXXX__	X__XXX_XXX_X____
;	XXXXXXXXX_X_XX__	_XXX_XX__XXX____
;	_XXX_XXXXX______	XX_XXX____X_____
;	XXXXX_XX_X______	__XX_XX_________
;	____XX_XX_X_____	__X__XXXXX______
;	_____XXXXX_X____	__XX____X_X_____
;	________XXXXX___	___XX___________
;	________________	___X_X__________

;	3A00 40			3A20 44
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	__XXXX_____XX___	___XXX____XX____
;	_XXX_XX___XXXXX_	__XX_XX__XXXXX__
;	_XX_XXXX__XXXXX_	_XX_XXXX_XXXXX__
;	XXXXXXX_X__X_XX_	XXXXXXX_X_X_XX__
;	X__XXX_XXX_X____	X__XXX_XXXX_____
;	_XX_XXXX_XXX____	_XX_XXXX_X______
;	___XXX____X_____	XX_X__X_________
;	__XX_XX_________	__XX_XX_________
;	_XX___XX________	__X__X__________
;	XX_____XX_______	__XX_XX_________
;	_XX_____XX______	__X_X_XX________
;	_X_X____X_X_____	______X_X_______

;	3A40 48			3A60 4C
;	________________	____XX__________
;	________________	_____XX_________
;	________________	______X_________
;	__________XX____	________________
;	___XXX___XXXXX__	________________
;	__XX_XX__XXXXX__	___X____________
;	_XX_XXXX__X_XX__	__XX__X_________
;	XXXXXX_XX_X_____	__X__XX_________
;	X__X_XX_XXX_____	_XX__X__________
;	_XX_XXXX_X______	_XX_XX__________
;	__XXX___________	_XXXX___________
;	___XXX__________	_XX_____________
;	___X_XX_________	_XX__X__________
;	___X___X________	_XX_____________
;	___XXX__________	XX___X__________
;	____X_X_________	________________

;	3A80 50			3AA0 54
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	_____X__________
;	________________	___XXXX_________
;	________________	__XX____________
;	________________	__X_____________
;	________________	_X__X___________
;	______X_________	_X_X____________
;	______X_________	_X______________
;	_____X__________	XXX_____________
;	___XXX__________	XX_X____________
;	___XX___________	XX_XX___________
;	___XXX__________	XX___X__________
;	__XXX___________	X____X__________
;	________________	________________

;	3AC0 58			3AE0 5C
;	________________	________________
;	________________	___X____________
;	________________	___XX___________
;	________________	__XX____________
;	________________	__XX____________
;	____XX__________	________________
;	___XXX__________	________________
;	__XX____________	________________
;	__X_____________	_X______________
;	________________	_XXX____________
;	________________	__XXX___________
;	__X_____________	__X_XX__________
;	__X_____________	_XX___X_________
;	__XXX___________	_XX___X_________
;	_XXXX___________	XX____X_________
;	________________	________________

;	3B00 60			3B20 64
;	________________	__XX____________
;	________________	__XX____________
;	________________	________________
;	____X___________	________________
;	____X___________	________________
;	___XX___________	________________
;	___XX___________	_XXX____________
;	________________	__XXX___________
;	________________	__XXX___________
;	________________	__X_XX__________
;	________________	__X__X__________
;	___X____________	__X_____________
;	___XXX__________	__X__X__________
;	___XXX__________	_XX_____________
;	__XXXX__________	XX___X__________
;	________________	________________

;	3B40 68			3B60 6C
;	________________	_____XXX___XX___
;	____X___________	_____X____XX_X__
;	___XX___________	_____XXX__XX____
;	____X___________	X____XX____X____
;	________________	XX__XXXXXXXXXXX_
;	________________	XXXXXXXXX_XX____
;	________________	XXXXXXXXXXXX____
;	________________	_XXXXXXXXXX_____
;	________________	__XXXXXX________
;	___X____________	__XX__X_________
;	___XX___________	__X___X_________
;	____XX__________	_XX___X_________
;	____X___________	_XX___X_________
;	___XXX__________	__X___XX________
;	__XXX___________	__X____X________
;	________________	_XX____XX_______

; Note: 3BA0 74 / 3BC0 78 / 3BE0 7C / 3C00 80 are all blank!

;	3B80 70			3C20 84
;	_____XXX________	________________
;	_____X__________	________________
;	_____XXX________	________________
;	_____XX_________	________________
;	___XXXXXXXXXXXX_	________________
;	__XXXXXX________	________________
;	_XX_XXXX___XX___	________X_______
;	XXXXXXXX__XXXXX_	______XXX_______
;	X__XXXX_X_XXXXX_	_______XXX______
;	_XX_XX_XX__X_XX_	_______X________
;	___XXX__XXXX____	________________
;	__XX_XX___X_____	________________
;	_XX___XX________	________________
;	XX_____XX_______	________________
;	_XX_____XX______	________________
;	_X_X____X_X_____	________________

;	3C40 88			3C60 8C
;	________________	________________
;	________________	________________
;	________________	_____X___X______
;	________________	____XX___XX_____
;	________________	____XX___XX_____
;	______XXX_______	____XX___XX_____
;	_____XXXXX______	____XXX_XXX_____
;	_____XXXXX______	_____XXXXX______
;	_____XXXXX______	________________
;	_____XXXXX______	________________
;	______XXX_______	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________

;	3C80 90			3CA0 94
;	________________	XX______________
;	___X_____X____X_	XX____________X_
;	__XX_X_______XX_	_____________XX_
;	________________	________________
;	________XXX_____	_X______________
;	___XX____X____X_	_XX___________XX
;	___XX________XX_	_____________XXX
;	____XX___XX_XX__	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________

;	3CC0 98			3CE0 9C
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	_____XXX_XXX_XXX	_____XXX_XXX_XXX
;	_______X_X___X_X	_____X___X_X_X_X
;	_____XXX_XXX_X_X	_____XXX_X_X_X_X
;	_____X_____X_X_X	_______X_X_X_X_X
;	_____XXX_XXX_XXX	_____XXX_XXX_XXX
;	________________	________________

;	3D00 A0			3D20 A4
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	_____XXX_XXX_XXX	__X__XXX_XXX_XXX
;	_______X_X___X_X	_XX__X_X_X_X_X_X
;	_______X_XXX_X_X	__X__X_X_X_X_X_X
;	______X____X_X_X	__X__X_X_X_X_X_X
;	______X__XXX_XXX	_XXX_XXX_XXX_XXX
;	________________	________________

;	3D40 A8			3D60 AC
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	________________
;	________________	_____XXX________
;	_XXX_XXX_XXX_XXX	_____X__________
;	___X_X_X_X_X_X_X	_____XXX________
;	__XX_X_X_X_X_X_X	_____XX_________
;	___X_X_X_X_X_X_X	____XXXX________
;	_XXX_XXX_XXX_XXX	____XXXX________
;	________________	_____XXX________

	; first byte is length of data to copy or 00H for end of list
	; middle bytes are data to copy
	; last byte is length to skip (presumably defaults to 0x00)
DC754:	HEX	09
	HEX	00 00 00 00 C0 F0 FF 7F 3F

	HEX	07 08
	HEX	18 34 30 10 FE B0 F0 E0

	HEX	0C 05
	HEX	C0 F0 FF 7F 3F

	HEX	07 08
	HEX	30 68 60 20 FE B0 F0 E0

	HEX	08 0B
	HEX	E0 F8 78 7C 3F 3E 3F FF 7F 1F 07

	HEX	05 0B
	HEX	18 34 30 10 FE 10 30 E0 E0 C0 C0

	HEX	09 08
	HEX	03 00 38 EF 5B 36 0D 03

	HEX	04 0C
	HEX	0C 1A 18 08 FE 08 18 F0 E0 C0 C0 80

	HEX	04 0B
	HEX	E0 F8 78 7C 3E 3E 3E FF 7F 1F 07

	HEX	05 0B
	HEX	18 34 30 18 18 18 30 E0 E0 C0 C0

	HEX	0A 07
	HEX	0F 3F EF 5B 36 0D 03

	HEX	04 0C
	HEX	0C 1A 18 0C 0C 0C 98 F0 E0 C0 C0 80

	HEX	08 0C
	HEX	1C 36 6F FE 9D 6F D2 36 24 36 2B 02

	HEX	04 0C
	HEX	FE 00 30 7C 7C AC E0 40 00 00 00 80

	HEX	04 0C
	HEX	1C 36 6F FF 97 6C 38 1C 16 11 1C 0A

	HEX	04 07
	HEX	FE 30 7C 7C 2C E0 40

	HEX	09 0C
	HEX	1C 36 6F FE 9D 76 DC 36 27 30 18 14

	HEX	04 0A
	HEX	FE 18 3E BE 96 70 20 00 C0 A0

	HEX	06 0C
	HEX	1C 36 6F FF 9E 6D 1C 36 63 C1 60 50

	HEX	04 18
	HEX	FE 00 18 3E BE 96 F0 20 00 80 C0 A0 00 7C F7 3D
	HEX	0F F7 FF 7F 1F 06 03 01

	HEX	05 1B
	HEX	30 78 3E 92 C8 B0 80 00 80 40 B0 D8 6C 00 00 60
	HEX	F0 D8 EC B7 DA 6B 2F 76 FD 5C F0

	HEX	08 07
	HEX	FE 00 18 BE 9E D6 60

	HEX	09 0A
	HEX	03 00 38 7F FF FF 77 FB 0D 07

	HEX	06 18
	HEX	FE 00 30 7C BC AC C0 40 A0 D0 F8 00 60 F0 D8 EC
	HEX	B6 DA 6B 2F 76 FD 5C F0

	HEX	0A 05
	HEX	18 BE 9E D6 60

	HEX	0B 08
	HEX	38 7F FF FF 77 FB 0D 07

	HEX	08 09
	HEX	30 7C BC AC C0 40 A0 D0 F8

	HEX	05 1A
	HEX	1C 36 6F FE 9D 76 DC 36 27 30 18 14 00 00 00 18
	HEX	3E 3E 16 90 D0 70 20 00 C0 A0

	HEX	06 0C
	HEX	3C 76 6F FE 9D 6F 1C 36 63 C1 60 50

	HEX	04 0C
	HEX	18 3E 3E 96 D0 70 20 00 00 80 C0 A0

	HEX	04 0C
	HEX	1C 36 6F FE 9D 6F D2 36 24 36 2B 02

	HEX	04 06
	HEX	30 7C 7C AC E0 40

	HEX	05 01
	HEX	80

	HEX	04 16
	HEX	1C 36 6F FD 96 6F 38 1C 16 11 1C 0A 00 00 00 30
	HEX	7C 7C 2C A0 E0 40

	HEX	06 0F
	HEX	0C 06 02 00 00 10 32 26 64 6C 78 60 64 60 C4

	HEX	19 07
	HEX	02 02 04 1C 18 1C 38

	HEX	14 0C
	HEX	04 1E 30 20 48 50 40 E0 D0 D8 C4 84

	HEX	16 0A
	HEX	0C 1C 30 20 00 00 20 20 38 78

	HEX	12 0E
	HEX	10 18 30 30 00 00 00 40 70 38 2C 62 62 C2

	HEX	14 0C
	HEX	08 08 18 18 00 00 00 00 10 1C 1C 3C

	HEX	11 02
	HEX	30 30

	HEX	04 09
	HEX	70 38 38 2C 24 20 24 60 C4

	HEX	12 03
	HEX	08 18 08

	HEX	05 06
	HEX	10 18 0C 08 1C 38

	HEX	11 18
	HEX	07 04 07 86 CF FF FF 7F 3F 32 22 62 62 23 21 61
	HEX	18 34 30 10 FE B0 F0 E0

	HEX	07 11
	HEX	80 07 04 07 06 1F 3F 6F FF 9E 6D 1C 36 63 C1 60
	HEX	50

	HEX	04 0C
	HEX	FE 00 18 3E BE 96 F0 20 00 80 C0 A0

	HEX	87 03	; note the big gap
	HEX	03 01 01

	HEX	0C 03
	HEX	80 80 C0

	HEX	0C 06
	HEX	03 07 07 07 07 03

	HEX	0A 06
	HEX	80 C0 C0 C0 C0 80

	HEX	07 06
	HEX	04 0C 0C 0C 0E 07

	HEX	0A 06
	HEX	40 60 60 60 E0 C0

	HEX	09 07
	HEX	10 34 00 00 18 18 0C

	HEX	09 07
	HEX	42 06 00 E0 42 06 6C

	HEX	08 06
	HEX	C0 C0 00 00 40 60

	HEX	0B 06
	HEX	02 06 00 00 03 07

	HEX	13 05
	DB	_____XXX
	DB	_______X
	DB	_____XXX
	DB	_____X__
	DB	_____XXX

	HEX	0B 05
	DB	_XXX_XXX
	DB	_X___X_X
	DB	_XXX_X_X
	DB	___X_X_X
	DB	_XXX_XXX

	HEX	0B 05
	DB	_____XXX
	DB	_____X__
	DB	_____XXX
	DB	_______X
	DB	_____XXX

	HEX	0B 05
	DB	_XXX_XXX
	DB	_X_X_X_X
	DB	_X_X_X_X
	DB	_X_X_X_X
	DB	_XXX_XXX

	HEX	0B 05
	DB	_____XXX
	DB	_______X
	DB	_______X
	DB	______X_
	DB	______X_

	HEX	0B 05
	DB	_XXX_XXX
	DB	_X___X_X
	DB	_XXX_X_X
	DB	___X_X_X
	DB	_XXX_XXX

	HEX	0B 05
	DB	__X__XXX
	DB	_XX__X_X
	DB	__X__X_X
	DB	__X__X_X
	DB	_XXX_XXX

	HEX	0B 05
	DB	_XXX_XXX
	DB	_X_X_X_X
	DB	_X_X_X_X
	DB	_X_X_X_X
	DB	_XXX_XXX

	HEX	0B 05
	DB	_XXX_XXX
	DB	___X_X_X
	DB	__XX_X_X
	DB	___X_X_X
	DB	_XXX_XXX

	HEX	0B 05
	DB	_XXX_XXX
	DB	_X_X_X_X
	DB	_X_X_X_X
	DB	_X_X_X_X
	DB	_XXX_XXX

	HEX	0A 07
	HEX	07 04 07 06 0F 0F 07

	HEX	10 00

; ======================

; copied to VRAM 3C20H
DCA68:	HEX	00 00 00 00 00 00 00 03
	HEX	01 01 00 00 00 00 00 00
	HEX	00 00 00 00 00 00 80 80
	HEX	C0 00 00 00 00 00 00 00

DCA88:	HEX	00 00 00 00 01 05 02 01
	HEX	0D 02 04 00 00 00 00 00
	HEX	00 00 00 00 00 20 40 B0
	HEX	80 40 A0 80 00 00 00 00

DCAA8:	HEX	00 00 00 02 00 10 02 0C
	HEX	20 05 10 01 04 00 00 00
	HEX	00 00 00 20 80 08 A0 04
	HEX	30 40 08 00 40 00 00 00

; copied to VRAM 1B00H
DCAC8:	HEX	AB 00 00 00 AB 00 00 00
	HEX	AB 00 00 00 AB 00 00 00
XCAC8:

; ======================

DCAD8:	DB	__XXX___	; 00
	DB	_X___X__
	DB	_X__XX__
	DB	_X_X_X__
	DB	_XX__X__
	DB	_X___X__
	DB	__XXX___
	DB	________

	DB	___X____	; 01
	DB	__XX____
	DB	___X____
	DB	___X____
	DB	___X____
	DB	___X____
	DB	_XXXXX__
	DB	________

	DB	__XXX___	; 02
	DB	_X___X__
	DB	_____X__
	DB	___XX___
	DB	__X_____
	DB	_X___X__
	DB	_XXXXX__
	DB	________

	DB	__XXX___	; 03
	DB	_X___X__
	DB	_____X__
	DB	___XX___
	DB	_____X__
	DB	_X___X__
	DB	__XXX___
	DB	________

	DB	____XX__	; 04
	DB	___X_X__
	DB	__X__X__
	DB	_X___X__
	DB	_XXXXX__
	DB	_____X__
	DB	_____X__
	DB	________

	DB	_XXXXX__	; 05
	DB	_X______
	DB	_XXXX___
	DB	_____X__
	DB	_____X__
	DB	_X___X__
	DB	__XXX___
	DB	________

	DB	__XXX___	; 06
	DB	_X______
	DB	_X_XX___
	DB	_XX__X__
	DB	_X___X__
	DB	_X___X__
	DB	__XXX___
	DB	________

	DB	_XXXXX__	; 07
	DB	_X___X__
	DB	____X___
	DB	___X____
	DB	__X_____
	DB	__X_____
	DB	__X_____
	DB	________

	DB	__XXX___	; 08
	DB	_X___X__
	DB	_X___X__
	DB	__XXX___
	DB	_X___X__
	DB	_X___X__
	DB	__XXX___
	DB	________

	DB	__XXX___	; 09
	DB	_X___X__
	DB	_X___X__
	DB	_X__XX__
	DB	__XX_X__
	DB	_____X__
	DB	__XXX___
	DB	________

DCB28:	DB	XXXXXXXX	; 0A 64
	DB	________
	DB	__XXX___
	DB	__XXX___
	DB	_XXX____
	DB	_XXXX___
	DB	__XXXX__
	DB	_XX_XX__

	DB	XXXXXXXX	; 0B
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________

	DB	X_X_X_X_	; 0C
	DB	_X_X_X_X
	DB	X_X_X_X_
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________

	DB	________	; 0D
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________

	DB	________	; 0E
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________

	DB	________	; 0F
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________

	DB	________	; 10
	DB	________
	DB	________
	DB	________
	DB	XXXXXXXX
	DB	XXXXXXXX
	DB	XXXXXXXX
	DB	XXX__XXX

	DB	________	; 11
	DB	________
	DB	________
	DB	________
	DB	XXXXXXXX
	DB	XXXXXXXX
	DB	XXX__XXX
	DB	XXXXXXXX

	DB	________	; 12
	DB	________
	DB	________
	DB	________
	DB	XXXXXXXX
	DB	XXX__XXX
	DB	XXXXXXXX
	DB	XXXXXXXX

	DB	________	; 13
	DB	________
	DB	________
	DB	__XXXX__
	DB	XXX__XXX
	DB	XXXXXXXX
	DB	XXXXXXXX
	DB	XXXXXXXX

	DB	________	; 14
	DB	________
	DB	________
	DB	XXX__XXX
	DB	XXXXXXXX
	DB	XXXXXXXX
	DB	XXXXXXXX
	DB	XXXXXXXX

	DB	________	; 15
	DB	________
	DB	_X____X_
	DB	________
	DB	XXXXXXXX
	DB	XXXXXXXX
	DB	XXXXXXXX
	DB	XXXXXXXX

	DB	XXXXXXXX	; 16
	DB	XXXXXXXX
	DB	XXXXXXXX
	DB	XXXX_XXX
	DB	XXXXXXXX
	DB	XXXXXXXX
	DB	XXXXXXXX
	DB	XXXXXXXX

	DB	XXXXXXXX	; 17
	DB	XXXXXXXX
	DB	XXXX_XXX
	DB	XXX___XX
	DB	XXXX_XXX
	DB	XXXXXXXX
	DB	XXXXXXXX
	DB	XXXXXXXX

	DB	XXXXXXXX	; 18
	DB	XXXX_XXX
	DB	XXX___XX
	DB	XX__X__X
	DB	XXX___XX
	DB	XXXX_XXX
	DB	XXXXXXXX
	DB	XXXXXXXX

	DB	XXXXXXXX	; 19
	DB	XXXX_XXX
	DB	XXX_X_XX
	DB	XX_XXX_X
	DB	XXX_X_XX
	DB	XXXX_XXX
	DB	XXXXXXXX
	DB	XXXXXXXX

	DB	XXXXXXXX	; 1A
	DB	XXXX_XXX
	DB	XXXXXXXX
	DB	XX_XXX_X
	DB	XXXXXXXX
	DB	XXXX_XXX
	DB	XXXXXXXX
	DB	XXXXXXXX

	DB	________	; 1B
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________

	DB	________	; 1C
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________

	DB	________
	DB	________	; 1D
	DB	__XXX___
	DB	_XXXXX__
	DB	_XXXXX__
	DB	_XXXXX__
	DB	_XXXXX__
	DB	__XXX___

	DB	________	; 1E
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________

	DB	________	; 1F
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________

	DB	________	; 20
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________

	DB	________	; 21
	DB	__XXX___
	DB	_X___X__
	DB	_X___X__
	DB	_XXXXX__
	DB	_X___X__
	DB	_X___X__
	DB	_X___X__

	DB	________	; 22
	DB	_XXXX___
	DB	_X___X__
	DB	_X___X__
	DB	_XXXX___
	DB	_X___X__
	DB	_X___X__
	DB	_XXXX___

	DB	________	; 23
	DB	__XXX___
	DB	_X___X__
	DB	_X______
	DB	_X______
	DB	_X______
	DB	_X___X__
	DB	__XXX___

	DB	________	; 24
	DB	_XXX____
	DB	_X__X___
	DB	_X___X__
	DB	_X___X__
	DB	_X___X__
	DB	_X___X__
	DB	_XXXX___

	DB	________	; 25
	DB	__XXX___
	DB	_X___X__
	DB	_X______
	DB	_XXXX___
	DB	_X______
	DB	_X___X__
	DB	__XXX___

	DB	________	; 26
	DB	__XXX___
	DB	_X___X__
	DB	_X______
	DB	_XXXX___
	DB	_X______
	DB	_X______
	DB	_X______

	DB	________	; 27
	DB	__XXX___
	DB	_X___X__
	DB	_X______
	DB	_X______
	DB	_X_XXX__
	DB	_X___X__
	DB	__XXX___

	DB	________	; 28
	DB	__X__X__
	DB	_X___X__
	DB	_X___X__
	DB	_XXXXX__
	DB	_X___X__
	DB	_X___X__
	DB	_X___X__

	DB	________	; 29
	DB	_XXXXX__
	DB	___X____
	DB	___X____
	DB	___X____
	DB	___X____
	DB	___X____
	DB	_XXXXX__

	DB	________	; 2A
	DB	__XXXX__
	DB	____X___
	DB	____X___
	DB	____X___
	DB	____X___
	DB	_X__X___
	DB	__XX____

	DB	________	; 2B
	DB	_X___X__
	DB	_X__X___
	DB	_X_X____
	DB	_XX_____
	DB	_X_X____
	DB	_X__X___
	DB	_X___X__

	DB	________	; 2C
	DB	__X_____
	DB	_X______
	DB	_X______
	DB	_X______
	DB	_X______
	DB	_X___X__
	DB	_XXXXX__

	DB	________	; 2D
	DB	__X__X__
	DB	_X_XXXX_
	DB	_X_XX_X_
	DB	_X____X_
	DB	_X____X_
	DB	_X____X_
	DB	__X__X__

	DB	________	; 2E
	DB	_X___X__
	DB	_XX__X__
	DB	_X_X_X__
	DB	_X_X_X__
	DB	_X_X_X__
	DB	_X__XX__
	DB	_X___X__

	DB	________	; 2F
	DB	__XXX___
	DB	_X___X__
	DB	_X___X__
	DB	_X___X__
	DB	_X___X__
	DB	_X___X__
	DB	__XXX___

	DB	________	; 30
	DB	__XXX___
	DB	_X___X__
	DB	_X___X__
	DB	_XXXX___
	DB	_X______
	DB	_X______
	DB	_X______

	DB	________	; 31
	DB	__XXX___
	DB	_X___X__
	DB	_X___X__
	DB	_X___X__
	DB	_X_X_X__
	DB	_X__X___
	DB	__XX_X__

	DB	________	; 32
	DB	__XXX___
	DB	_X___X__
	DB	_X___X__
	DB	_XXXX___
	DB	_X_X____
	DB	_X__X___
	DB	_X___X__

	DB	________	; 33
	DB	__XXX___
	DB	_X___X__
	DB	_XX_____
	DB	__XXX___
	DB	____XX__
	DB	_X___X__
	DB	__XXX___

	DB	________	; 34
	DB	__XXX___
	DB	_X_X_X__
	DB	___X____
	DB	___X____
	DB	___X____
	DB	___X____
	DB	__XXX___

	DB	________	; 35
	DB	__X__X__
	DB	_X___X__
	DB	_X___X__
	DB	_X___X__
	DB	_X___X__
	DB	_X___X__
	DB	__XXX___

	DB	________	; 36
	DB	__X__X__
	DB	_X___X__
	DB	_X___X__
	DB	_X___X__
	DB	_XX_XX__
	DB	__XXX___
	DB	___X____

	DB	________	; 37
	DB	__X__X__
	DB	_X____X_
	DB	_X____X_
	DB	_X____X_
	DB	_X_XX_X_
	DB	_X_XX_X_
	DB	__X__X__

	DB	________	; 38
	DB	_X___X__
	DB	_X___X__
	DB	__X_X___
	DB	___X____
	DB	__X_X___
	DB	_X___X__
	DB	_X___X__

	DB	________	; 39
	DB	__X__X__
	DB	_X___X__
	DB	_X___X__
	DB	__X_X___
	DB	___X____
	DB	___X____
	DB	___X____

	DB	________	; 3A
	DB	_XXXXX__
	DB	_____X__
	DB	____X___
	DB	___X____
	DB	__X_____
	DB	_X______
	DB	_XXXXX__

	DB	________	; 3B
	DB	___X____
	DB	___X____
	DB	___X____
	DB	___X____
	DB	________
	DB	________
	DB	___X____

	DB	________	; 3C
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	________
	DB	___X____
NCAD8	EQU	$-DCAD8

DCCC0:	DB	___XXX__	; 68
	DB	__XXXXX_
	DB	_XXX_XXX
	DB	_XX___XX
	DB	_XXX_XXX
	DB	_XXX_XXX
	DB	_XXX_XXX
	DB	_XXXXXXX

	DB	________	; 69
	DB	________
	DB	___XXX__
	DB	__XXXXX_
	DB	_XXXXXX_
	DB	_XXXXXX_
	DB	_XXXXX__
	DB	__XXX___

	DB	________	; 6A
	DB	________
	DB	__XXX___
	DB	_XXXXX__
	DB	_XXXXXX_
	DB	_XXXXXX_
	DB	__XXXXX_
	DB	___XXX__

	DB	________	; 6B
	DB	________
	DB	________
	DB	___X____
	DB	__XXX___
	DB	___XX___
	DB	__XXX___
	DB	__X_X___

	DB	__XXX___	; 6C
	DB	__X_X_X_
	DB	_XXXXX__
	DB	X__X__X_
	DB	__XXX_X_
	DB	_X_X_XX_
	DB	_X____X_
	DB	_X___XX_

	DB	__XXX_X_	; 6D
	DB	__X_X_X_
	DB	_XXXXXX_
	DB	XXXXXXX_
	DB	__XXX_X_
	DB	_XXXXXX_
	DB	_X___XX_
	DB	XXX_XXX_

DCCF0:	DB	________	; 6E 60
	DB	________
	DB	_______X
	DB	_______X
	DB	__XXX__X
	DB	__XXX__X
	DB	__XXX_XX
	DB	___X__XX
	DB	_XXXXX_X	; 6F 61
	DB	XXX_XX_X
	DB	X_XXX__X
	DB	X_X_X__X
	DB	__X_X__X
	DB	_XX_XX_X
	DB	_XX_XX_X
	DB	XXX_XXXX

NCCF0	EQU	$-DCCF0
NCCC0	EQU	$-DCCC0

; ======================

DCD00:	;________________ 70/71
	;___XX__X________
	;___X___X________
	;__XX___X________
	;__XX___X________
	;___X___XX_______
	;___X____X_______
	;__XX____XX______

	HEX	00 19 11 31 31 11 10 30
	HEX	00 00 00 00 00 80 80 C0
;CD10
	;________________ 72/73
	;___XX____X______
	;____XXX_XX______
	;______XXX_______
	;________XX______
	;________X_______
	;________X_______
	;________XX______

	HEX	00 18 0E 03 00 00 00 00
	HEX	00 40 C0 80 C0 80 80 C0
;CD20
	;________________ 74/75
	;________XX______
	;________XXX_____
	;________X_XX____
	;_______XX___X___
	;_______X_____X__
	;_______XX____X__
	;________XX______

	HEX	00 00 00 00 01 01 01 00
	HEX	00 C0 E0 B0 88 04 84 C0
;CD30
	;________________ 76/77
	;__________X_X___
	;_________X__X___
	;_________X___X__
	;________XX___X__
	;________X_____X_
	;________X______X
	;________XX_____X

	HEX	00 00 00 00 00 00 00 00
	HEX	00 28 48 44 C4 82 81 C1
;CD40
	;________________ 78/79
	;________X_X_____
	;________X__X____
	;_______X___X____
	;_______X___XX___
	;______X_____X___
	;_____X______X___
	;_____X_____XX___

	HEX	00 00 00 01 01 02 04 04
	HEX	00 A0 90 10 18 08 08 18
;CD50
	;________________ 7A/7B
	;___________XX___
	;__________XXX___
	;_________XX_X___
	;________X___XX__
	;_______X_____X__
	;_______X____XX__
	;___________XX___

	HEX	00 00 00 00 00 01 01 00
	HEX	00 18 38 68 8C 04 0C 18
;CD60
	;________________
	;___X____XX______
	;___XX_XXX_______
	;____XXX_________
	;___XX___________
	;____X___________
	;____X___________
	;___XX___________

	HEX	00 10 1B 0E 18 08 08 18
	HEX	00 C0 80 00 00 00 00 00
;CD70
	;________________
	;_____X__XX______
	;_____X___X______
	;_____X___XX_____
	;_____X___XX_____
	;____XX___X______
	;____X____X______
	;___XX____XX_____

	HEX	00 04 04 04 04 0C 08 18
	HEX	00 C0 40 60 60 40 40 60
;CD80
	;________________ 80/81
	;___XX__X________
	;___X___X________
	;__XX___X________
	;__XX___X________
	;___X___XX_______
	;___X____X_______
	;__XX____XX______

	HEX	00 19 11 31 31 11 10 30
	HEX	00 00 00 00 00 80 80 C0
;CD90
	;________________ 82/83
	;____XX__X_______
	;____X___X_______
	;___XX___X_______
	;___XX___X_______
	;____X___XX______
	;____X____X______
	;___XX____XX_____

	HEX	00 0C 08 18 18 08 08 18
	HEX	00 80 80 80 80 C0 40 60
;CDA0
	;________________ 84/85
	;_____XX__X______
	;_____X___X______
	;____XX___X______
	;____XX___X______
	;_____X___XX_____
	;_____X____X_____
	;____XX____XX____

	HEX	00 06 04 0C 0C 04 04 0C
	HEX	00 40 40 40 40 60 20 30
;CDB0
	;________________ 86/87
	;______XX__X_____
	;______X___X_____
	;_____XX___X_____
	;_____XX___X_____
	;______X___XX____
	;______X____X____
	;_____XX____XX___

	HEX	00 03 02 06 06 02 02 06
	HEX	00 20 20 20 20 30 10 18
;CDC0
	;________________
	;_______XX__X____ 88/89
	;_______X___X____
	;______XX___X____
	;______XX___X____
	;_______X___XX___
	;_______X____X___
	;______XX____XX__

	HEX	00 01 01 03 03 01 01 03
	HEX	00 90 10 10 10 18 08 0C
;CDD0
	;________________
	;________XX__X___
	;________X___X___
	;_______XX___X___
	;_______XX___X___
	;________X___XX__
	;________X____X__
	;_______XX____XX_

	HEX	00 00 00 01 01 00 00 01
	HEX	00 C8 88 88 88 8C 84 86
;CDE0
	;________________ 8C/8D
	;_________XX__X__
	;_________X___X__
	;________XX___X__
	;________XX___X__
	;_________X___XX_
	;_________X____X_
	;________XX____XX

	HEX	00 00 00 00 00 00 00 00
	HEX	00 64 44 C4 C4 46 42 C3
;CDF0
	;________________
	;__________XX__X_
	;__________X___X_
	;_________XX___X_
	;_________XX___X_
	;__________X___XX
	;__________X____X
	;_________XX____X

	HEX	00 00 00 00 00 00 00 00
	HEX	00 32 22 62 62 23 21 61
;CE00
	;________________ 90/91
	;________X__XX___
	;________X___X___
	;________X___XX__
	;________X___XX__
	;_______XX___X___
	;_______X____X___
	;______XX____XX__

	HEX	00 00 00 00 00 01 01 03
	HEX	00 98 88 8C 8C 88 08 0C
;CE10
	;________________ 92/93
	;_________X__XX__
	;_________X___X__
	;_________X___XX_
	;_________X___XX_
	;________XX___X__
	;________X____X__
	;_______XX____XX_

	HEX	00 00 00 00 00 00 00 01
	HEX	00 4C 44 46 46 C4 84 86
;CE20
	;________________ 94/95
	;__________X__XX_
	;__________X___X_
	;__________X___XX
	;__________X___XX
	;_________XX___X_
	;_________X____X_
	;________XX____XX

	HEX	00 00 00 00 00 00 00 00
	HEX	00 26 22 23 23 62 42 C3
;CE30
	;________________ 96/97
	;___X__XX________
	;___X___X________
	;___X___XX_______
	;___X___XX_______
	;__XX___X________
	;__X____X________
	;_XX____XX_______

	HEX	00 13 11 11 11 31 21 61
	HEX	00 00 00 80 80 00 00 80
;CE40
	;________________ 98/99
	;____X__XX_______
	;____X___X_______
	;____X___XX______
	;____X___XX______
	;___XX___X_______
	;___X____X_______
	;__XX____XX______

	HEX	00 09 08 08 08 18 10 30
	HEX	00 80 80 C0 C0 80 80 C0
;CE50
	;________________ 9A/9B
	;_____X__XX______
	;_____X___X______
	;_____X___XX_____
	;_____X___XX_____
	;____XX___X______
	;____X____X______
	;___XX____XX_____

	HEX	00 04 04 04 04 0C 08 18
	HEX	00 C0 40 60 60 40 40 60
;CE60
	;________________ 9C/9D
	;______X__XX_____
	;______X___X_____
	;______X___XX____
	;______X___XX____
	;_____XX___X_____
	;_____X____X_____
	;____XX____XX____

	HEX	00 02 02 02 02 06 04 0C
	HEX	00 60 20 30 30 20 20 30
;CE70
	;________________ 9E/9F
	;_______X__XX____
	;_______X___X____
	;_______X___XX___
	;_______X___XX___
	;______XX___X____
	;______X____X____
	;_____XX____XX___

	HEX	00 01 01 01 01 03 02 06
	HEX	00 30 10 18 18 10 10 18
;CE80
	;________________ A0/A1
	;________________
	;________________
	;_____X_X________
	;______X_X_______
	;_______X_X______
	;_______XX_XX____
	;________XX_XX___

	HEX	00 00 00 05 02 01 01 00
	HEX	00 00 00 00 80 40 B0 D8
;CE90
	;________________ A2/A3
	;________________
	;________________
	;______X_X_______
	;_______X_X______
	;________X_X_____
	;________XX_XX___
	;_________XX_XX__

	HEX	00 00 00 02 01 00 00 00
	HEX	00 00 00 80 40 A0 D8 6C
;CEA0
	;________________ A4/A5
	;________________
	;________________
	;_______X_X______
	;________X_X_____
	;_________X_X____
	;_________XX_XX__
	;__________XX_XX_

	HEX	00 00 00 01 00 00 00 00
	HEX	00 00 00 40 A0 50 6C 36
;CEB0
	;________________ A6/A7
	;________________
	;________________
	;________X_X_____
	;_________X_X____
	;__________X_X___
	;__________XX_XX_
	;___________XX_XX

	HEX	00 00 00 00 00 00 00 00
	HEX	00 00 00 A0 50 28 36 1B
;CEC0
	;________________ A8/A9
	;________________
	;________________
	;_X_X____________
	;__X_X___________
	;___X_X__________
	;___XX_XX________
	;____XX_XX_______

	HEX	00 00 00 50 28 14 1B 0D
	HEX	00 00 00 00 00 00 00 80
;CED0
	;________________ AA/AB
	;________________
	;________________
	;__X_X___________
	;___X_X__________
	;____X_X_________
	;____XX_XX_______
	;_____XX_XX______

	HEX	00 00 00 28 14 0A 0D 06
	HEX	00 00 00 00 00 00 80 C0
;CEE0
	;________________ AC/AD
	;________________
	;________________
	;___X_X__________
	;____X_X_________
	;_____X_X________
	;_____XX_XX______
	;______XX_XX_____

	HEX	00 00 00 14 0A 05 06 03
	HEX	00 00 00 00 00 00 C0 60
;CEF0
	;________________ AE/AF
	;________________
	;________________
	;____X_X_________
	;_____X_X________
	;______X_X_______
	;______XX_XX_____
	;_______XX_XX____

	HEX	00 00 00 0A 05 02 03 01
	HEX	00 00 00 00 00 80 60 B0
;CF00
	;________________ B0/B1
	;________________
	;________________
	;________X_X_____
	;_______X_X______
	;______X_X_______
	;____XX_XX_______
	;___XX_XX________

	HEX	00 00 00 00 01 02 0D 1B
	HEX	00 00 00 A0 40 80 80 00
;CF10
	;________________ B2/B3
	;________________
	;________________
	;_________X_X____
	;________X_X_____
	;_______X_X______
	;_____XX_XX______
	;____XX_XX_______

	HEX	00 00 00 00 00 01 06 0D
	HEX	00 00 00 50 A0 40 C0 80
;CF20
	;________________ B4/B5
	;________________
	;________________
	;__________X_X___
	;_________X_X____
	;________X_X_____
	;______XX_XX_____
	;_____XX_XX______

	HEX	00 00 00 00 00 00 03 06
	HEX	00 00 00 28 50 A0 60 C0
;CF30
	;________________ B6/B7
	;________________
	;________________
	;___________X_X__
	;__________X_X___
	;_________X_X____
	;_______XX_XX____
	;______XX_XX_____

	HEX	00 00 00 00 00 00 01 03
	HEX	00 00 00 14 28 50 B0 60
;CF40
	;________________ B8/B9
	;________________
	;________________
	;____________X_X_
	;___________X_X__
	;__________X_X___
	;________XX_XX___
	;_______XX_XX____

	HEX	00 00 00 00 00 00 00 01
	HEX	00 00 00 0A 14 28 D8 B0
;CF50
	;________________ BA/BB
	;________________
	;________________
	;_____X_X________
	;____X_X_________
	;___X_X__________
	;_XX_XX__________
	;XX_XX___________

	HEX	00 00 00 05 0A 14 6C D8
	HEX	00 00 00 00 00 00 00 00
;CF60
	;________________ BC/BD
	;________________
	;________________
	;______X_X_______
	;_____X_X________
	;____X_X_________
	;__XX_XX_________
	;_XX_XX__________

	HEX	00 00 00 02 05 0A 36 6C
	HEX	00 00 00 80 00 00 00 00
;CF70
	;________________ BE/BF
	;________________
	;________________
	;_______X_X______
	;______X_X_______
	;_____X_X________
	;___XX_XX________
	;__XX_XX_________

	HEX	00 00 00 01 02 05 1B 36
	HEX	00 00 00 40 80 00 00 00
NCD00	EQU	$-DCD00

; ======================

; color table data?
; first word = VRAM address, second word = length, fifth byte = data
DCF80:	DW	2000H,0060H
	HEX	E1
	DW	2100H,00D8H
	HEX	E1
	DW	2050H,0004H
	HEX	A0
	DW	2054H,0004H
	HEX	40
	DW	2050H,0001H
	HEX	90
	DW	2058H,0001H
	HEX	90
	DW	2320H,0005H
	HEX	40
	DW	2325H,0003H
	HEX	B0
	DW	2320H,0001H
	HEX	90
	DW	2058H,0001H
	HEX	90
	DW	2340H,0008H
	HEX	E0
	DW	2080H,0058H
	HEX	60
	DW	20E8H,0008H
	HEX	30
	DW	2348H,0010H
	HEX	30
	DW	2358H,0028H
	HEX	60
	DW	2375H,0001H
	HEX	40
	DW	2300H,0010H
	HEX	E0
	DW	2305H,0001H
	HEX	60
	DW	2310H,0010H
	HEX	40
	DW	2315H,0001H
	HEX	E0
	DW	2600H,0040H
	HEX	A0
	DW	2640H,0040H
	HEX	40
	DW	2380H,0280H
	HEX	90
	DW	2060H,0003H
	HEX	8E
	DW	20D8H,0010H
	HEX	E0
	DW	0000H

; color table data?
DCFFF:	HEX	E0 E0 E0 E0 E0 E0 E0 E0
	HEX	60 60 60 60 E0 40 40 40
	HEX	40 40 40 40 40 40 40 40
	HEX	40
XCFFF:

DD018:	DW	18C0H
	HEX	3B 3C 3D 00

DD01E:	DW	18DCH
	HEX	3E 3F 40 41 00

DD025:	DW	18EAH
	HEX	42 43 44 45 46 47 48 49
	HEX	4A 4B 00

;D032
	DW	1997H
	HEX	3B 3C 3D 3E 3F 40 00

;D03B
	DW	19A0H
	HEX	41 42 43 44 45 46 47 00

;D045
	DW	19B9H
	HEX	48 49 4A 4B 4C 4D 4E 00

DD04F:	DW	19ECH
	HEX	4F 50 51 52 53 54 55 00

	DW	0000H

; 3 bytes copied to D61B9
DD05B:	HEX	00 18 30
DD05E:	HEX	E2 1E 30
DD061:	HEX	52 4D 38
DD064:	HEX	BA 2D 60
DD067:	HEX	00 38 68
DD06A:	HEX	CA 36 68
DD06D:	HEX	62 35 78

; 8 bytes copied to D6020
DD070:	HEX	90 38 B0 00 90 90 B0 00

; color table data?
DD078:	HEX	02 C2 06 FF 03 36 07 70
DD079:	EQU	DD078+1

; VDP register initialization?
DD080:	HEX	00 C3 06 80 00 36 07 70

; color table data?
DD088:	HEX	60 80 90 A0 B0 30 20 C0
	HEX	40 50 D0 70 E0 F0

DD096:	DB	__,_O,_N,_E,__,_P,_L,_A,_Y,_E,_R,__,__

DD0A3:	DB	__,_T,_W,_O,__,_P,_L,_A,_Y,_E,_R,_S,__

DD0B0:	DB	__,__,_E,_A,_S,_Y,__,_P,_L,_A,_Y,__,__
	DB	_S,_T,_A,_N,_D,_A,_R,_D,__,_P,_L,_A,_Y,__,__
	DB	_H,_A,_R,_D,__,_P,_L,_A,_Y,__,__

DD0D7:	DW	196BH
	DB	._-$-1
	DB	_P,_L,_A,_Y,_E,_R,__,_1
._

DD0E2:	DW	196BH
	DB	._-$-1
	DB	_P,_L,_A,_Y,_E,_R,__,_2
._

DD0ED:	DW	192BH
	DB	._-$-1
	DB	_G,_A,_M,_E,__,_O,_V,_E,_R
._

DD0F9:	DW	1947H
	DB	._-$-1
	DB	_T,_H,_Y,__,_G,_A,_M,_E,__,_I,_S,__,_O,_V,_E,_R
._

DD10C:	DW	1884H
	DB	._-$-1
	DB	_E,_A,_C,_H,__,_P,_L,_A,_Y,_E,_R,__
	DB	_3,_0,_0,_0,__,_P,_O,_I,_N,_T,_S
._

DD126:	DW	1847H
	DB	._-$-1
	DB	_P,_L,_A,_Y,_E,_R,__,_C,_O,_O,_P,_E,_R,_A,_T,_I,_O,_N
._

DD13B:	DW	1849H
	DB	._-$-1
	DB	_P,_L,_A,_Y,_E,_R,__,_C,_O,_N,_F,_L,_I,_C,_T
._

DD14D:	DW	1888H
	DB	._-$-1
	DB	_N,_O,__,_B,_O,_N,_U,_S,__,_A,_W,_A,_R,_D,_E,_D
._

DD160:	DW	1848H
	DB	._-$-1
	DB	_N,_O,__,_B,_O,_U,_N,_T,_Y,__,_A,_W,_A,_R,_D,_E,_D
._

DD174:	DW	1841H
	DB	._-$-1
	DB	_C,_O,_L,_L,_E,_C,_T,_E,_D,__,_3,_0,_0,_0,__
	DB	_B,_O,_U,_N,_T,_Y
._

DD18C:	DW	184AH
	DB	._-$-1
	DB	_C,_O,_L,_L,_E,_C,_T,_E,_D,__,_3,_0,_0,_0,__
	DB	_B,_O,_U,_N,_T,_Y
._

DD1A4:	DW	1968H
	DB	._-$-1
	DB	_G,_L,_A,_D,_I,_A,_T,_O,_R,__,_W,_A,_V,_E
._

DD1B5:	DW	1848H
	DB	._-$-1
	DB	_3,_0,_0,_0,__,_P,_O,_I,_N,_T,__,_B,_O,_U,_N,_T,_Y
._

DD1C9:	DW	1885H
	DB	._-$-1
	DB	_F,_O,_R,__,_D,_I,_S,_M,_O,_U,_N,_T,_I,_N,_G,__
	DB	_P,_L,_A,_Y,_E,_R
._

DD1E2:	DW	196BH
	DB	._-$-1
	DB	_T,_E,_A,_M,__,_W,_A,_V,_E
._

DD1EE:	DW	1843H
	DB	._-$-1
	DB	_B,_O,_N,_U,_S,__,_A,_W,_A,_R,_D,_E,_D,__
	DB	_F,_O,_R,__,_T,_E,_A,_M,__,_P,_L,_A,_Y
._

DD20C:	DW	1843H
	DB	._-$-1
	DB	_C,_O,_L,_L,_E,_C,_T,__,_3,_0,_0,_0,__
	DB	_S,_U,_R,_V,_I,_V,_A,_L,__,_P,_O,_I,_N,_T,_S
._

DD22B:	DW	1844H
	DB	._-$-1
	DB	_N,_O,__,_S,_U,_R,_V,_I,_V,_A,_L,__
	DB	_P,_O,_I,_N,_T,_S,__,_A,_W,_A,_R,_D,_E,_D
._

DD248:	DW	1849H
	DB	._-$-1
	DB	_B,_E,_W,_A,_R,_E,__,_O,_F,__,_T,_H,_E
._

DD258:	DW	1884H
	DB	._-$-1
	DB	_U,_N,_B,_E,_A,_T,_A,_B,_L,_E,__
	DB	_P,_T,_E,_R,_A,_D,_A,_C,_T,_Y,_L
._

DD271:	DW	1967H
	DB	._-$-1
	DB	_P,_R,_E,_P,_A,_R,_E,__,_T,_O,__,_J,_O,_U,_S,_T
._

DD284:	DW	19A9H
	DB	._-$-1
	DB	_B,_U,_Z,_Z,_A,_R,_D,__,_B,_A,_I,_T
._

DD293:	DW	192CH
	DB	._-$-1
	DB	_W,_A,_V,_E,__,__,__
._

DD29D:	DW	196BH
	DB	._-$-1
	DB	_E,_G,_G,__,_W,_A,_V,_E
._

DD2A8:	DW	1969H
	DB	._-$-1
	DB	_S,_U,_R,_V,_I,_V,_A,_L,__,_W,_A,_V,_E
._

;D2B8
	DB	_P,_R,_E,_S,_E,_N,_T,_S
	DB	_C,_O,_P,_Y,_R,_I,_G,_H,_T,__,_1,_9,_8,_2,__
	DB	_W,_I,_L,_L,_I,_A,_M,_S
	DB	_C,_O,_P,_Y,_R,_I,_G,_H,_T,__,_1,_9,_8,_3,__
	DB	_A,_T,_A,_R,_I

	OPT	NOEXPAND
	DS	0400H,0FFH
	DS	0400H,0FFH
	DS	0400H,0FFH
	DS	0115H,0FFH

	END
